﻿shr.defineClass("shr.report.dataSourceList", shr.framework.List, {	
	_self : null,
	_navi : null,
	initalizeDOM:function(){
		shr.report.dataSourceList.superClass.initalizeDOM.call(this);
		_self = this;
		$con = $("#confrim_list");		
		$(".shr-toolbar").append('<div style="display: inline-block;" class="attachmentUploadArea">'
		+'<p><input id="attachment" formId="" style="display: none;" class = "attachment_style" type="file" name="uploadAttach"/></p>'
		+'<div id="attachment_attachList"></div></div>');
		
		$('#attachment').fileupload({
			url : shr.getContextPath() +"/dynamic.do?method=uploadTemplate",
			formData : {
				uipk : "com.kingdee.shr.report.app.PersonDataSourceDef.list"
			},
			dataType : "json",
			
			start : function (e) {
				var attachListId = '#' + 'attachment' + '_attachList';
				$(attachListId).append("<p class = 'attachment-loading'>文件正在上传，请稍后 .. <span class = 'progress'></span></p>");
				$(".progress").html("10%");
			},
			
			add : function (e, data) {
				var uploadErrors = [];
				if (data.originalFiles.length && data.originalFiles[0]['size'] > 5 * 1024 * 1024) {
					shr.showError({
						message : "文件大小超出限制，请上传小于5M的文件"
					});
				} else {
					data.submit();
				}
			},
			
			progressall : function (e, data) {
				var progress = parseInt(data.loaded / data.total * 100, 10);
				$(".progress").html(progress + "%");
			},
			
			done : function (e, data) {
				var response = data.result.data;
				$(".attachment-loading").remove();
				if(response.error != undefined && response.error != null && response.error != ""){
					shr.showError({
						message : response.error,
						hideAfter: 3
					});
					return;
				}if(response.confirm != undefined && response.confirm != null && response.confirm != ""){
					$("#grid").jqGrid("reloadGrid");
					// 生成列表界面内容
					_self.creatList($(response.content));
					var path = response.path;
					$('#confrim_dialog').dialog({
								title: "当前操作,"+response.confirm,
								width: 840,
								height: 600,
								resizable: false,
								buttons:{
									'覆盖导入': function(){
										var selIds = $("#tempTab").jqGrid("getSelectedRows");
										var tempId = $("#tempTab").jqGrid("getRowRealData", selIds[0]).id;
										
										var selectedIds = $("#tempTab").jqGrid("getSelectedRows");
										if (selectedIds.length > 0) {
											var billIds = [];
											for (var i = 0, length = selectedIds.length; i < length; i++) {
												billIds.push($("#tempTab").jqGrid("getCell", selectedIds[i], "id"));
											}
											//讲数据再次传给后台
											_self.CallServer(billIds,"cover",path);
										}else{
											shr.showWarning({
												message: "请先选中表格中的数据!",
												hideAfter: 3
											});
										}
									},
									'复制导入': function(){
										var selIds = $("#tempTab").jqGrid("getSelectedRows");
										var tempId = $("#tempTab").jqGrid("getRowRealData", selIds[0]).id;
										
										var selectedIds = $("#tempTab").jqGrid("getSelectedRows");
										if (selectedIds.length > 0) {
											var billIds = [];
											for (var i = 0, length = selectedIds.length; i < length; i++) {
												billIds.push($("#tempTab").jqGrid("getCell", selectedIds[i], "id"));
											}
											//讲数据再次传给后台
											_self.CallServer(billIds,"copy",path);
										}else{
											shr.showWarning({
												message: "请先选中表格中的数据!",
												hideAfter: 3
											});
										}
									},
									'取消(不处理)': function(){
										$(this).dialog('close');
										// 删除缓存文件
										_self.remoteCall({
											method: 'DeleteFile',
											param: {
													path :path
												}, 
											success: function(data) {
												shr.showInfo({
															message: '操作成功',
															hideAfter: 3
														});
												//shr.showConfirm('完成n条数据操作', function(){});
												$("#confrim_dialog").dialog('close');
												$("#grid").jqGrid("reloadGrid");
											},
											error: function(data){
												$("#confrim_dialog").dialog('close');
												$("#grid").jqGrid("reloadGrid");
											}
										});	
									}
								}
							});
				}else{
					shr.showInfo({
						message : '导入成功',
						hideAfter: 3
					});
					$("#grid").jqGrid("reloadGrid");
				}
			},
		});
	},
	
	
	addNewAction: function() {
		top.Messenger().hideAll();
		var aa ;
		sessionStorage.setItem('reportParams',null);
    	_self.reloadPage({
    		uipk: 'shr.report.dataSourceGuide',
			thod: 'addNew'
    	});
		//this.reloadPage({
		//	uipk: this.getEditUIPK(),
		//	method: 'addNew'
		//});
	},
	
	addAction: function() {
		top.Messenger().hideAll();
		var aa ;
		sessionStorage.setItem('reportParams',null);
    	_self.reloadPage({
    		uipk: 'shr.report.dataSourceGuide',
			thod: 'addNew'
    	});
		//this.reloadPage({
		//	uipk: this.getEditUIPK(),
		//	method: 'addNew'
		//});
	},
	
	viewReportAction: function() {
		top.Messenger().hideAll();
		var billIds = this.getSelectedFields();
		if (billIds && billIds.length > 1) {
			shr.showInfo({
			message : '只能选择一条记录',
			hideAfter : 3
			});
			return;
		}else if(billIds && billIds.length == 1){
			_self.remoteCall({
				method : "viewReports",
				param : {
					billid : billIds.toString()
				},
				success : function (data) {
					if (!data)
						return;
					//data = "(" + data + ")";
					data = $.parseJSON(data);
					var $grid2 = $("#tempReport");
					$grid2.jqGrid({
						width : "auto",
						height : "auto",
						datatype : "local",
						multiselect : false,
						rownumbers : true,
						colNames : ["ID", "报表名称", "报表描述", "创建人", "调整日期"],
						colModel : [{
								name : "id",
								hidden : true,
								key : true
							}, {
								name : "name",
								width : 280
							}, {
								name : "description",
								width : 280
							}, {
								name : "creatorName",
								width : 280
							}, {
								name : "lastUpdateTime",
								width : 280
							}
						]
					});

					$grid2.jqGrid("clearGridData");
					for (var i = 0; i<data.length ; i++) {
						var d = {
							id : data[i].id,
							name : data[i].name,
							description : data[i].description,
							creatorName : data[i].creator.name,
							lastUpdateTime : data[i].lastUpdateTime
						};
						$grid2.jqGrid("addRowData", i + 1, d);
					}
				}
			});
			$('#dialog_report').dialog({
				title : '引用该数据源的报表',
				width : 800,
				height : 600,
				resizable : false,
				buttons : {
					'确定' : function () {
						$(this).dialog('close');
					}
				}
			});
		}else{
			shr.showInfo({
			message : '请选择记录',
			hideAfter : 3
			});
			return;
		}
	},
	
	
	/**
	 * 描述:删除操作
	 * @action 
	 */
	cancelAction:function(){
		top.Messenger().hideAll();	
		var selectedIds = this.getSelectedIds();
		if (selectedIds) {
			this.deleteRecord(selectedIds);
		}
	},
	
	/**
	*生成列表界面
	*/
	creatList:function(data){
		html = "<div id='tempDialog'><table id='tempTab'></table></div>";
		$con.append(html);
		var $grid = $("#tempTab");
			$grid.jqGrid({
				width: "auto",
				height: "auto",
				datatype: "local",
				multiselect: true,
				rownumbers: false,
				colNames: ["ID", "名称", "描述"],
				colModel: [{name: "id", hidden: true, key: true}, {name: "name", width: 140}, {name: "description", width: 140}]
			});
		$grid.jqGrid("clearGridData");
			for(var i=0;i<data.length;i++) {
				var d = {id: data[i].id, name: data[i].name, description: data[i].description};
				$grid.jqGrid("addRowData", i + 1, d);
			}
	},
	
	viewAction: function(billId) {
		top.Messenger().hideAll();
		// 编辑界面禁用，则直接返回
		if (this.editViewDisable) {
			return;
		}
		$.ajax({
			url: shr.getContextPath() + "/dynamic.do?method=getDataSource",
			data: {
				uipk : "com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form",
				billId : billId
			},
			success: function(data) {
				if(data.result != undefined && data.result == "error"){
					shr.showError({
					message : data.summary,
					hideAfter : 3
					});
					return;
				}
				var params  = {};
				params.model = data;
				$('#workArea', window.parent.document).attr('params', JSON.stringify(params));
				sessionStorage.setItem('reportParams', JSON.stringify(params));
				_self.reloadPage({
					uipk: 'shr.report.dataSourceGuide',
					billId: params.id
				});
			}
		});
		//this.reloadPage({
		//	uipk: "shr.report.dataSourceGuide",
		//	billId: billId,
		//	thod: 'view'
		//});			
	},
	
	/*
	响应导出按钮
	*/
	outputAction: function() {
		top.Messenger().hideAll();
		// 判断是否选中
		if(!(_self.CheckTabSelectedIds())){
			shr.showWarning({
			message: "请先选中表格中的数据!"	
			});
			return;
		}
		var a = $("#grid").jqGrid("getSelectedRows");
		var filename = $("#grid").jqGrid("getCell", a[0], "name");
		var permissonid = [];
		for(var i in a){
					permissonid [i] =  $("#grid").jqGrid("getCell", a[i], "id");
				}
		var param = $.param({
					filename:filename,
					method : 'output',
					billid : JSON.stringify(permissonid),
					uipk : "com.kingdee.shr.report.app.PersonDataSourceDef.list",
				});
		location.href = shr.getContextPath() + "/dynamic.do?" + param;
	},
	CheckTabSelectedIds: function() {
		var selectedIds = $("#grid").jqGrid("getSelectedRows");
		if (selectedIds.length > 0) {
			return true;
	    }else{
			return false;
		}
	},
	
	inputAction: function(){
		$('#attachment').click();
	},
	
	/**
	*向后台发出请求（是否覆盖或复制）
	*/
	CallServer: function(ids,type,path){
		_self.remoteCall({
			method: 'ConfirmData',
			param: {
					ids:ids,
					ConfirmType:type,
					selectData : JSON.stringify(ids),
					path :path
				}, 
			success: function(data) {
				
				shr.showInfo({
        					message: '操作成功',
        					hideAfter: 3
        				});
				
				//shr.showConfirm('完成n条数据操作', function(){});
				$("#confrim_dialog").dialog('close');
				$("#grid").jqGrid("reloadGrid");
    		},
			error: function(data){
				$("#confrim_dialog").dialog('close');
				$("#grid").jqGrid("reloadGrid");
			}
		});				
	},
});