﻿(function ($, undefined) {
	$.widget("ui.shrFileUpload", $.ui.shrctrl, {
		options : {
			id : null,
			formId : null,
			readonly : null,
			name : null,
			onlyone : null,
			url : null,
			param : null,
		},
		_create : function () {
			var self = this;

			if ((self.options.readonly == true || self.options.readonly === 'true')) {
				$('#' + self.options.id).hide();
				return;
			}
			if ($.browser.msie) {
				/* this.swfUpload();*/
				this.jQueryUpload();
			} else {
				this.jQueryUpload();
			}
		},

		//for IE
		swfUpload : function () {
			var self = this;
			$("#attachment").removeClass("attachment-style");
			this.element.uploadify({
				swf : shr.getContextPath() + "/jslib/uploadify/uploadify.swf",
				uploader : shr.getContextPath() + "/attachmentUpload.do?method=uploadAttachment&" + this.getJSessionCookie(),
				buttonText : self.options.name,
				buttonClass : "awareUpload",
				fileObjName : 'uploadAttach',
				formData : {
					boID : self.options.formId,
					onlyone : self.options.onlyone
				},
				rollover : true,
				fileSizeLimit : '5MB',
				onUploadProgress : function (file, bytesUploaded, bytesTotal, totalBytesUploaded, totalBytesTotal) {},

				onQueueComplete : function () {
					shr.setIframeHeight();
				},

				onSelectError : function (file, errorCode, errorMsg) {},

				onUploadError : function (file, errorCode, errorMsg, errorString) {
					shr.showError({
						message : "文件类型不正确, 请检查您的文件类型！"
					});
				},

				onFallback : function () {
					shr.showError({
						message : '您未安装FLASH控件，无法上传图片！请安装FLASH控件后再试。'
					});
				},

				onUploadSuccess : function (file, data, response) {
					data = $.parseJSON(data);
					if (response === 'true' || response == true) {
						shr.showInfo({
							message : '上传成功'
						});
						if ((self.options.onlyone == true || self.options.onlyone === 'true')) {
							$('#' + self.options.id + '_attachList').empty();
						}
						$('#' + self.options.id + '_attachList').append($('<div id=' + data.data.id + ' class="attachItems"><div class="attach_name">' + file.name + '</div></div>'));
						shr.setIframeHeight();
					} else {
						shr.showError({
							message : "上传失败"
						});
					}

				}
			});
		},
		//for other bowser except IE
		jQueryUpload : function () {
			var self = this;
			$(".attachmentUploadArea").prepend('<div id = "' + self.options.id + '_mask">' +
				'<p class = "attachment_title">上传附件</p>' +
				'</div>');
			this.element.fileupload({
				url : shr.getContextPath() + self.options.url+"",
				formData : self.options.param,
				dataType : "json",

				start : function (e) {
					var attachListId = '#' + self.options.id + '_attachList';
					$(attachListId).append("<p class = 'attachment-loading'>文件正在上传，请稍后 .. <span class = 'progress'></span></p>");
					$(".progress").html("10%");
				},

				add : function (e, data) {
					var uploadErrors = [];
					if (data.originalFiles.length && data.originalFiles[0]['size'] > 5 * 1024 * 1024) {
						shr.showError({
							message : "文件大小超出限制，请上传小于5M的文件"
						});
					} else {
						data.submit();
					}
				},

				progressall : function (e, data) {
					var progress = parseInt(data.loaded / data.total * 100, 10);
					$(".progress").html(progress + "%");
				},

				done : function (e, data) {
					var response = data.result.data;
					var filename = response.filename;

					$(".attachment-loading").remove();
					/*$( attachListId ).append($('<div id='+ response.id +' class="attachItems">'+
					'<div class="attach_name">'+ filename +'</div>'+
					'<div class="attach_delete">删除</div>'+
					'</div>'));*/
					/* add download option*/
				},
			});
		},
		/**
		 * 从Cookie中获取Session Id，解决上传文件302错误
		 * @returns
		 */
		getJSessionCookie : function () {
			var array = document.cookie.split(";");
			for (var i = 0; i < array.length; i++) {
				if (array[i].indexOf("JSESSIONID") >= 0) {
					return array[i].trim();
				}
			}
			return "";
		},

		destroy : function () {
			$.Widget.prototype.destroy.call(this);
		},

		_setOption : function (key, value) {
			$.Widget.prototype._setOption.apply(this, arguments);
		},

	});
}
	(jQuery));
