﻿shr.defineClass("shr.report.filterParams", shr.framework.Core, {
	loadDatasourceParam : function (reportDtas) {
		var model;
		this.reportDtas = reportDtas;
		var _self = this;
		this._isAddNew = reportDtas._isAddNew;
		var _isAddNew = reportDtas._isAddNew;
		var _currentData = reportDtas._currentData;
		$("#div_countType").empty();
		if (!_isAddNew) {
			if (_currentData == undefined || _currentData == null || _currentData == "") {
				return;
			}
			model = _currentData;
		}
		model = _currentData;
		if ($("#selectDatas_el").val().replace("S", "") == "001") {

			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">统计周期</span>' +
				'<div style="width: 100px;display: inline-block;vertical-align: bottom;">' +
				'<input id="dimension" type="text" name="dimension" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span class="day-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;">基准日期</span>' +
				'<div class="day-other-param" style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="selectdate" type="text" name="selectdate" disabled="true" class="search-input-length input-height day-other-param"/></div>');
			$("#div_countType").append('<span class="month-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;">开始日期</span>' +
				'<div class="month-other-param" style="width: 110px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate" type="text" name="startdate" class="search-input-length input-height month-other-param"/></div>');
			$("#div_countType").append('<span class="month-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;">结束日期</span>' +
				'<div class="month-other-param" style="width: 110px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate" type="text" name="enddate" class="search-input-length input-height month-other-param"/></div>');
			$("#div_countType").append('<span class="month-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;"></span>' +
				'<div class="month-other-param" style="width: 140px;display: inline-block;vertical-align: bottom;">' +
				'<input id="includetype" type="text" name="includetype" class="search-input-length input-height month-other-param"/></div>');

			var picker_json = {
				id : 'startdate'
			};
			picker_json.tagClass = 'block-father input-height';
			picker_json.validate = '{dateISO:true,required:true}';
			$("#startdate").shrDatePicker(picker_json);
			$("#startdate").shrDatePicker("disable");
			picker_json.id = 'enddate';
			$("#enddate").shrDatePicker(picker_json);
			$("#enddate").shrDatePicker("disable");
			var select_json = {
				id : "dimension"
			};
			select_json.data = [{
					value : "day",
					alias : "按日"
				}, {
					value : "month",
					alias : "按月"
				}
			];
			select_json.validate = "{required:true}";
			$('#dimension').shrSelect(select_json);
			var include_json = {
				id : "includetype"
			};
			include_json.data = [{
					value : "start",
					alias : "导出期初数据"
				}, {
					value : "end",
					alias : "导出期末数据"
				}, {
					value : "startend",
					alias : "导出期初期末数据"
				}
			];
			include_json.validate = "{required:true}";
			$('#includetype').shrSelect(include_json);
			$('#includetype').shrSelect("setValue", "start");
			$('#dimension').change(function () {
				if (_isAddNew) {
					if (_currentData.customsql == true || _currentData.customsql == "true") {
						$('.day-other-param').show();
						$('.month-other-param').hide();
						return;
					}
					if ($('#dimension').shrSelect("getValue").value == "month") {
						$('.day-other-param').hide();
						$('.month-other-param').show();

						if (_currentData.ontherfilter.startdate != undefined && _currentData.ontherfilter.startdate != "") {
							$("#startdate").attr("value", _currentData.ontherfilter.startdate);
						} else {
							$("#startdate").attr("value", "@startDate");
						}
						if (_currentData.ontherfilter.enddate != undefined && _currentData.ontherfilter.enddate != "") {
							$("#enddate").attr("value", _currentData.ontherfilter.enddate);
						} else {
							$("#enddate").attr("value", "@endDate");
						}
						/*
						if (_currentData.dataparams) {
						var length = _currentData.dataparams.length;
						for (var i = 0; i < length; i++) {
						if (_currentData.dataparams[i].paramname == "baseDate") {
						_currentData.dataparams[i].paramstate = "2";
						}
						}
						}*/
						for (var i = 0; i < _currentData.dataparams.length; i++) { // 删除掉自动带出的参数（基准日期，开始，结束日期）
							if (_currentData.dataparams[i].paramname == "baseDate" || _currentData.dataparams[i].paramname == "startDate" || _currentData.dataparams[i].paramname == "endDate") {
								_currentData.dataparams.splice(i, 1);
								i--;
							}
						}
						// 添加开始日期和结束日期

						_currentData.dataparams[_currentData.dataparams.length] = {
							paramcomp : 2,
							paramdesc : "基准日期",
							paramname : "baseDate",
							paramnull : false,
							paramstate : "0",
							paramtype : 2,
							paramuipk : null,
							paramvalue : null
						}

						_currentData.dataparams[_currentData.dataparams.length] = {
							paramcomp : 2,
							paramdesc : "开始日期",
							paramname : "startDate",
							paramnull : false,
							paramstate : "0",
							paramtype : 2,
							paramuipk : null,
							paramvalue : null
						}
						_currentData.dataparams[_currentData.dataparams.length] = {
							paramcomp : 2,
							paramdesc : "结束日期",
							paramname : "endDate",
							paramnull : false,
							paramstate : "0",
							paramtype : 2,
							paramuipk : null,
							paramvalue : null
						}
					} else {
						$('.day-other-param').show();
						$('.month-other-param').hide();
						if (_currentData.dataparams) {
							var length = _currentData.dataparams.length;
							for (var i = 0; i < _currentData.dataparams.length; i++) { // 删除掉自动带出的参数（基准日期，开始，结束日期）
								if (_currentData.dataparams[i].paramname == "baseDate" || _currentData.dataparams[i].paramname == "startDate" || _currentData.dataparams[i].paramname == "endDate") {
									_currentData.dataparams.splice(i, 1);
									i--;
								}
							}

							// 添加基准日期
							_currentData.dataparams[_currentData.dataparams.length] = {
								paramcomp : 2,
								paramdesc : "基准日期",
								paramname : "baseDate",
								paramnull : false,
								paramstate : "0",
								paramtype : 2,
								paramuipk : null,
								paramvalue : null
							}
							/*var choose = [];
							var index = 0;
							for (var i = 0; i < length; i++) {
							if (_currentData.dataparams[i].paramname != "startDate"
							&& _currentData.dataparams[i].paramname != "endDate") {
							if (_currentData.dataparams[i].paramname == "baseDate") {
							_currentData.dataparams[i].paramstate = "0";
							}
							choose[index] = _currentData.dataparams[i];
							index++;
							}
							}
							_currentData.dataparams = choose;
							 */
						}
					}
				} else {
					if (model.customsql == true || model.customsql == "true") {
						$('.day-other-param').show();
						$('.month-other-param').hide();
						return;
					}
					if ($('#dimension').shrSelect("getValue").value == "month") {
						$('.day-other-param').hide();
						$('.month-other-param').show();

						if (model.ontherfilter.startdate != undefined && model.ontherfilter.startdate != "") {
							$("#startdate").attr("value", model.ontherfilter.startdate);
						} else {
							$("#startdate").attr("value", "@startDate");
						}
						if (model.ontherfilter.enddate != undefined && model.ontherfilter.enddate != "") {
							$("#enddate").attr("value", model.ontherfilter.enddate);
						} else {
							$("#enddate").attr("value", "@endDate");
						}

						if (model.dataparams) {
							/*var length = model.dataparams.length;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == "baseDate") {
									model.dataparams[i].paramstate = "2";
								}
							}*/
							var length = model.dataparams.length;
								for(var i=0;i<model.dataparams.length;i++){ // 删除掉自动带出的参数（基准日期，开始，结束日期）
									if(model.dataparams[i].paramname == "baseDate" || model.dataparams[i].paramname == "startDate" || model.dataparams[i].paramname == "endDate"){
										model.dataparams.splice(i,1);
										i--;
									}
								}
								// 添加基准日期 开始日期和结束日期
								model.dataparams[model.dataparams.length]={
									paramcomp: 2,
									paramdesc: "基准日期",
									paramname: "baseDate",
									paramnull: false,
									paramstate: "0",
									paramtype: 2,
									paramuipk: null,
									paramvalue: null
								} 
								
								
								model.dataparams[model.dataparams.length]={
									paramcomp: 2,
									paramdesc: "开始日期",
									paramname: "startDate",
									paramnull: false,
									paramstate: "0",
									paramtype: 2,
									paramuipk: null,
									paramvalue: null
								} 
								model.dataparams[model.dataparams.length]={
									paramcomp: 2,
									paramdesc: "结束日期",
									paramname: "endDate",
									paramnull: false,
									paramstate: "0",
									paramtype: 2,
									paramuipk: null,
									paramvalue: null
								}
						}
					} else {
						$('.day-other-param').show();
						$('.month-other-param').hide();
						if (model.dataparams) {
							var length = model.dataparams.length;
							for(var i=0;i < model.dataparams.length;i++){ // 删除掉自动带出的参数（基准日期，开始，结束日期）
									if(model.dataparams[i].paramname == "baseDate" || model.dataparams[i].paramname == "startDate" || model.dataparams[i].paramname == "endDate"){
										model.dataparams.splice(i,1);
										i--;
									}
								}
								// 添加基准日期
								model.dataparams[model.dataparams.length]={
									paramcomp: 2,
									paramdesc: "基准日期",
									paramname: "baseDate",
									paramnull: false,
									paramstate: "0",
									paramtype: 2,
									paramuipk: null,
									paramvalue: null
								}
							/*var choose = [];
							var index = 0;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname != "startDate"
									 && model.dataparams[i].paramname != "endDate") {
									if (model.dataparams[i].paramname == "baseDate") {
										model.dataparams[i].paramstate = "0";
									}
									choose[index] = model.dataparams[i];
									index++;
								}
							}
							model.dataparams = choose;
							*/
						}
					}
				}
				_self.reportDtas.loadMapping();
			});

			if (_isAddNew) {
				// 自定义，设置默认为按日
				$('#dimension').shrSelect("setValue", select_json.data[0].value);
				$("#selectdate").attr("value", "@baseDate");
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
				$('.month-other-param').hide();
				// 自定义新建的数据源 默认赋值
				_currentData.dataparams[0] = {
					paramcomp : 2,
					paramdesc : "基准日期",
					paramname : "baseDate",
					paramnull : false,
					paramstate : "0",
					paramtype : 2,
					paramuipk : null,
					paramvalue : null
				}
				return;
			}

			if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				if (model.ontherfilter.selecttype != undefined && model.ontherfilter.selecttype == "month") {
					$('#dimension').shrSelect("setValue", select_json.data[1].value);
					if (model.ontherfilter.startdate != undefined && model.ontherfilter.startdate != "") {
						$("#startdate").attr("value", model.ontherfilter.startdate);
					} else {
						$("#startdate").attr("value", "@startDate");
					}
					if (model.ontherfilter.enddate != undefined && model.ontherfilter.enddate != "") {
						$("#enddate").attr("value", model.ontherfilter.enddate);
					} else {
						$("#enddate").attr("value", "@endDate");
					}
					if (model.ontherfilter.includetype != undefined && model.ontherfilter.includetype != "") {
						$('#includetype').shrSelect("setValue", model.ontherfilter.includetype);
					} else {
						$('#includetype').shrSelect("setValue", "start");
					}
				} else {
					$('#dimension').shrSelect("setValue", select_json.data[0].value);
				}
				if (model.ontherfilter.selectdate == undefined || model.ontherfilter.selectdate == "") {
					$("#selectdate").attr("value", "@baseDate");
				} else {
					$("#selectdate").attr("value", model.ontherfilter.selectdate);
				}
				/*
				if (model.ontherfilter.isncount && "true" == model.ontherfilter.isncount) {
					$("#isncount")[0].checked = true;
				} else {
					$("#isncount")[0].checked = false;
				}
				if ((model.ontherfilter.isOnthestrength && "true" == model.ontherfilter.isOnthestrength) || ($('#isOnthestrength')).is(':checked') == true) {
					$("#isOnthestrength")[0].checked = true;
				} else {
					$("#isOnthestrength")[0].checked = false;
				}
				*/
			} else {
				$('#dimension').shrSelect("setValue", select_json.data[0].value);
				$("#selectdate").attr("value", "@baseDate");
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			}
		} else if ($("#selectDatas_el").val().replace("S", "") == "002") {
			$("#div_countType").append('<table><tr><td width="25%">发薪时间</td><td width="25%">' +
				'<input type="radio" name="countType" id="isTime" value="isTime" /></td><td width="25%">统计年月</td>' +
				'<td width="25%"><input type="radio" name="countType" id="isPeriod" value="isPeriod" checked /></td></tr></table>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">开始时间</span>' +
				'<div  style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate_t" disabled="true" type="text" name="startdate" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">结束时间</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate_t" type="text" name="enddate" disabled="true" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">开始年份</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="beginYear_t" type="text" disabled="true" name="beginYear" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">开始月份</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="beginMonth_t" disabled="true" type="text" name="beginMonth" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">结束年份</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="endYear_t" type="text" disabled="true" name="endYear" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">结束月份</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="endMonth_t" type="text" disabled="true" name="endMonth" class="search-input-length input-height"/></div>');
			$("#isTime").shrRadio({
				id : 'isTime'
			}).shrRadio('check');
			$("#isPeriod").shrRadio({
				id : 'isPeriod'
			});
			var isp = 0;
			if (_isAddNew) {
				var startdate = "@startDate",
				enddate = "@endDate",
				beginYear = "@beginYear",
				beginMonth = "@beginMonth",
				endYear = "@endYear",
				endMonth = "@endMonth";
			} else {
				if(model.ontherfilter.selecttype != null){
					if(model.ontherfilter.selecttype == "isPeriod"){
						isp = true;
					}else {
						isp = false;
					}
				}else if (model.ontherfilter && (model.ontherfilter.startdate =="" || model.ontherfilter.enddate =="")) {
					isp = false;
				} else {
					isp = true;
				}
				var startdate = "@startDate",
				enddate = "@endDate",
				beginYear = "@beginYear",
				beginMonth = "@beginMonth",
				endYear = "@endYear",
				endMonth = "@endMonth";
				if (isp) {
					if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
						beginYear = model.ontherfilter.beginYear || "@beginYear";
						beginMonth = model.ontherfilter.beginMonth || "@beginMonth";
						endYear = model.ontherfilter.endYear || "@endYear";
						endMonth = model.ontherfilter.endMonth || "@endMonth";
					}
				} else {
					if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
						startdate = model.ontherfilter.startdate || "@startDate";
						enddate = model.ontherfilter.enddate || "@endDate";
					}
				}
			}

			if (isp) {
				$("#startdate_t").attr("value", "").parent().hide().prev("span").hide();
				$("#enddate_t").attr("value", "").parent().hide().prev("span").hide();
				$("#beginYear_t").attr("value", beginYear).parent().show().prev("span").show();
				$("#beginMonth_t").attr("value", beginMonth).parent().show().prev("span").show();
				$("#endYear_t").attr("value", endYear).parent().show().prev("span").show();
				$("#endMonth_t").attr("value", endMonth).parent().show().prev("span").show();
				$("#isPeriod").shrRadio('check');
			} else {
				$("#startdate_t").attr("value", startdate).parent().show().prev("span").show();
				$("#enddate_t").attr("value", enddate).parent().show().prev("span").show();
				$("#beginYear_t").attr("value", "").parent().hide().prev("span").hide();
				$("#beginMonth_t").attr("value", "").parent().hide().prev("span").hide();
				$("#endYear_t").attr("value", "").parent().hide().prev("span").hide();
				$("#endMonth_t").attr("value", "").parent().hide().prev("span").hide();
				$("#isTime").shrRadio('check');
			}
			$("#isPeriod,#isTime").change(function (a, b) {
				var ispc = $("#isPeriod").shrRadio("isSelected");
				var startdate = "@startDate";
				var enddate = "@endDate";
				var beginYear = "@beginYear";
				var beginMonth = "@beginMonth";
				var endYear = "@endYear";
				var endMonth = "@endMonth";
				
				if (ispc) {
					$("#startdate_t").attr("value", "").parent().hide().prev("span").hide();
					$("#enddate_t").attr("value", "").parent().hide().prev("span").hide();
					$("#beginYear_t").attr("value", beginYear).parent().show().prev("span").show();
					$("#beginMonth_t").attr("value", beginMonth).parent().show().prev("span").show();
					$("#endYear_t").attr("value", endYear).parent().show().prev("span").show();
					$("#endMonth_t").attr("value", endMonth).parent().show().prev("span").show();
					$("#isPeriod").shrRadio('check');
				} else {
					$("#startdate_t").attr("value", startdate).parent().show().prev("span").show();
					$("#enddate_t").attr("value", enddate).parent().show().prev("span").show();
					$("#beginYear_t").attr("value", "").parent().hide().prev("span").hide();
					$("#beginMonth_t").attr("value", "").parent().hide().prev("span").hide();
					$("#endYear_t").attr("value", "").parent().hide().prev("span").hide();
					$("#endMonth_t").attr("value", "").parent().hide().prev("span").hide();
					$("#isTime").shrRadio('check');
				}
				if (_isAddNew) {
					_currentData.dataparams = [];
					var startDate = $("#startdate_t").attr("value");
					if (startDate != undefined && startDate != "") {
						var length = 0;
						if (_currentData.dataparams) {
							length = _currentData.dataparams.length;
						}
						if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (_currentData.dataparams[i].paramname == startDate.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								if (length == 0) {
									_currentData.dataparams = [{
											paramname : startDate.replace("@", ""),
											paramdesc : "开始时间",
											paramtype : "2",
											paramcomp : "2",
											paramvalue : "getSystemDate()",
											paramnull : false,
											paramstate : "0",
											paramuipk : ""
										}
									]
								} else {
									_currentData.dataparams[length] = {
										paramname : startDate.replace("@", ""),
										paramdesc : "开始时间",
										paramtype : "2",
										paramcomp : "2",
										paramvalue : "getSystemDate()",
										paramnull : false,
										paramstate : "0",
										paramuipk : ""
									}
								}
							}
						}
					}
					var endDate = $("#enddate_t").attr("value");
					if (endDate != undefined && endDate != "") {
						var length = 0;
						if (_currentData.dataparams) {
							length = _currentData.dataparams.length;
						}
						if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (_currentData.dataparams[i].paramname == endDate.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								if (length == 0) {
									_currentData.dataparams = [{
											paramname : endDate.replace("@", ""),
											paramdesc : "结束时间",
											paramtype : "2",
											paramcomp : "2",
											paramvalue : "getSystemDate()",
											paramnull : false,
											paramstate : "0",
											paramuipk : ""
										}
									]
								} else {
									_currentData.dataparams[length] = {
										paramname : endDate.replace("@", ""),
										paramdesc : "结束时间",
										paramtype : "2",
										paramcomp : "2",
										paramvalue : "getSystemDate()",
										paramnull : false,
										paramstate : "0",
										paramuipk : ""
									}
								}
							}
						}
					}
					var beginYear = $("#beginYear_t").attr("value");
					if (beginYear != undefined && beginYear != "") {
						var length = 0;
						if (_currentData.dataparams) {
							length = _currentData.dataparams.length;
						}
						if (beginYear.indexOf("@") != -1 && beginYear.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (_currentData.dataparams[i].paramname == beginYear.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getFullYear();
								if (length == 0) {
									_currentData.dataparams = [{
											paramname : beginYear.replace("@", ""),
											paramdesc : "开始年份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
										}
									]
								} else {
									_currentData.dataparams[length] = {
										paramname : beginYear.replace("@", ""),
										paramdesc : "开始年份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
									}
								}
							}
						}
					}
					var beginMonth = $("#beginMonth_t").attr("value");
					if (beginMonth != undefined && beginMonth != "") {
						var length = 0;
						if (_currentData.dataparams) {
							length = _currentData.dataparams.length;
						}
						if (beginMonth.indexOf("@") != -1 && beginMonth.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (_currentData.dataparams[i].paramname == beginMonth.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getMonth() + 1;
								if (length == 0) {
									_currentData.dataparams = [{
											paramname : beginMonth.replace("@", ""),
											paramdesc : "开始月份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
										}
									]
								} else {
									_currentData.dataparams[length] = {
										paramname : beginMonth.replace("@", ""),
										paramdesc : "开始月份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
									}
								}
							}
						}
					}
					var endYear = $("#endYear_t").attr("value");
					if (endYear != undefined && endYear != "") {
						var length = 0;
						if (_currentData.dataparams) {
							length = _currentData.dataparams.length;
						}
						if (endYear.indexOf("@") != -1 && endYear.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (_currentData.dataparams[i].paramname == endYear.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getFullYear();
								if (length == 0) {
									_currentData.dataparams = [{
											paramname : endYear.replace("@", ""),
											paramdesc : "结束年份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
										}
									]
								} else {
									_currentData.dataparams[length] = {
										paramname : endYear.replace("@", ""),
										paramdesc : "结束年份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
									}
								}
							}
						}
					}
					var endMonth = $("#endMonth_t").attr("value");
					if (endMonth != undefined && endMonth != "") {
						var length = 0;
						if (_currentData.dataparams) {
							length = _currentData.dataparams.length;
						}
						if (endMonth.indexOf("@") != -1 && endMonth.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (_currentData.dataparams[i].paramname == endMonth.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getMonth() + 1;
								if (length == 0) {
									_currentData.dataparams = [{
											paramname : endMonth.replace("@", ""),
											paramdesc : "结束月份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
										}
									]
								} else {
									_currentData.dataparams[length] = {
										paramname : endMonth.replace("@", ""),
										paramdesc : "结束月份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
									}
								}
							}
						}
					}
					ontherfilter = {
						startdate : $("#startdate_t").attr("value"),
						enddate : $("#enddate_t").attr("value"),
						beginYear : $("#beginYear_t").attr("value"),
						beginMonth : $("#beginMonth_t").attr("value"),
						endYear : $("#endYear_t").attr("value"),
						endMonth : $("#endMonth_t").attr("value")
					};
				} else {
					model.dataparams = [];
					var startDate = $("#startdate_t").attr("value");
					if (startDate != undefined && startDate != "") {
						var length = 0;
						if (model.dataparams) {
							length = model.dataparams.length;
						}
						if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == startDate.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								if (length == 0) {
									model.dataparams = [{
											paramname : startDate.replace("@", ""),
											paramdesc : "开始时间",
											paramtype : "2",
											paramcomp : "2",
											paramvalue : "getSystemDate()",
											paramnull : false,
											paramstate : "0",
											paramuipk : ""
										}
									]
								} else {
									model.dataparams[length] = {
										paramname : startDate.replace("@", ""),
										paramdesc : "开始时间",
										paramtype : "2",
										paramcomp : "2",
										paramvalue : "getSystemDate()",
										paramnull : false,
										paramstate : "0",
										paramuipk : ""
									}
								}
							}
						}
					}
					var endDate = $("#enddate_t").attr("value");
					if (endDate != undefined && endDate != "") {
						var length = 0;
						if (model.dataparams) {
							length = model.dataparams.length;
						}
						if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == endDate.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								if (length == 0) {
									model.dataparams = [{
											paramname : endDate.replace("@", ""),
											paramdesc : "结束时间",
											paramtype : "2",
											paramcomp : "2",
											paramvalue : "getSystemDate()",
											paramnull : false,
											paramstate : "0",
											paramuipk : ""
										}
									]
								} else {
									model.dataparams[length] = {
										paramname : endDate.replace("@", ""),
										paramdesc : "结束时间",
										paramtype : "2",
										paramcomp : "2",
										paramvalue : "getSystemDate()",
										paramnull : false,
										paramstate : "0",
										paramuipk : ""
									}
								}
							}
						}
					}
					var beginYear = $("#beginYear_t").attr("value");
					if (beginYear != undefined && beginYear != "") {
						var length = 0;
						if (model.dataparams) {
							length = model.dataparams.length;
						}
						if (beginYear.indexOf("@") != -1 && beginYear.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == beginYear.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getFullYear();
								if (length == 0) {
									model.dataparams = [{
											paramname : beginYear.replace("@", ""),
											paramdesc : "开始年份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
										}
									]
								} else {
									model.dataparams[length] = {
										paramname : beginYear.replace("@", ""),
										paramdesc : "开始年份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
									}
								}
							}
						}
					}
					var beginMonth = $("#beginMonth_t").attr("value");
					if (beginMonth != undefined && beginMonth != "") {
						var length = 0;
						if (model.dataparams) {
							length = model.dataparams.length;
						}
						if (beginMonth.indexOf("@") != -1 && beginMonth.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == beginMonth.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getMonth() + 1;
								if (length == 0) {
									model.dataparams = [{
											paramname : beginMonth.replace("@", ""),
											paramdesc : "开始月份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
										}
									]
								} else {
									model.dataparams[length] = {
										paramname : beginMonth.replace("@", ""),
										paramdesc : "开始月份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
									}
								}
							}
						}
					}
					var endYear = $("#endYear_t").attr("value");
					if (endYear != undefined && endYear != "") {
						var length = 0;
						if (model.dataparams) {
							length = model.dataparams.length;
						}
						if (endYear.indexOf("@") != -1 && endYear.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == endYear.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getFullYear();
								if (length == 0) {
									model.dataparams = [{
											paramname : endYear.replace("@", ""),
											paramdesc : "结束年份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
										}
									]
								} else {
									model.dataparams[length] = {
										paramname : endYear.replace("@", ""),
										paramdesc : "结束年份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
									}
								}
							}
						}
					}
					var endMonth = $("#endMonth_t").attr("value");
					if (endMonth != undefined && endMonth != "") {
						var length = 0;
						if (model.dataparams) {
							length = model.dataparams.length;
						}
						if (endMonth.indexOf("@") != -1 && endMonth.replace("@", "").length > 0) {
							var isadd = true;
							for (var i = 0; i < length; i++) {
								if (model.dataparams[i].paramname == endMonth.replace("@", "")) {
									isadd = false;
								}
							}
							if (isadd) {
								var myDate = new Date();
								var myValue = myDate.getMonth() + 1;
								if (length == 0) {
									model.dataparams = [{
											paramname : endMonth.replace("@", ""),
											paramdesc : "结束月份",
											paramtype : "1",
											paramcomp : "1",
											paramvalue : myValue,
											paramnull : false,
											paramstate : "0",
											paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
										}
									]
								} else {
									model.dataparams[length] = {
										paramname : endMonth.replace("@", ""),
										paramdesc : "结束月份",
										paramtype : "1",
										paramcomp : "1",
										paramvalue : myValue,
										paramnull : false,
										paramstate : "0",
										paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
									}
								}
							}
						}
					}
					ontherfilter = {
						startdate : $("#startdate_t").attr("value"),
						enddate : $("#enddate_t").attr("value"),
						beginYear : $("#beginYear_t").attr("value"),
						beginMonth : $("#beginMonth_t").attr("value"),
						endYear : $("#endYear_t").attr("value"),
						endMonth : $("#endMonth_t").attr("value")
					};
				}
				// 加载参数映射界面
				_self.reportDtas.loadMapping();
			});
		} else if ($("#selectDatas_el").val().replace("S", "") == "003") {
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">开始日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate" disabled="true" type="text" name="startdate" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">结束日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate" disabled="true" type="text" name="enddate" class="search-input-length input-height"/></div>');
			if (_isAddNew) {
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			} else if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				if (model.ontherfilter.startdate == undefined || model.ontherfilter.startdate == "") {
					$("#startdate").attr("value", "@startDate");
				} else {
					$("#startdate").attr("value", model.ontherfilter.startdate);
				}
				if (model.ontherfilter.enddate == undefined || model.ontherfilter.enddate == "") {
					$("#enddate").attr("value", "@endDate");
				} else {
					$("#enddate").attr("value", model.ontherfilter.enddate);
				}
			} else {
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			}
		} else if ($("#selectDatas_el").val().replace("S", "") == "004") {
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">基准日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="selectdate" disabled="true" type="text" name="selectdate" class="search-input-length input-height"/></div>');
			if (_isAddNew) {
				$("#selectdate").attr("value", "@baseDate");
			} else if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				$("#selectdate").attr("value", model.ontherfilter.selectdate);
			} else {
				$("#selectdate").attr("value", "@baseDate");
			}
		} else if ($("#selectDatas_el").val().replace("S", "") == "005") {
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">开始日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate" disabled="true" type="text" name="startdate" class="search-input-length input-height"/></div>');
			$("#div_countType").append('<span style="padding-right: 15px; font-weight: bold;">结束日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate" disabled="true" type="text" name="enddate" class="search-input-length input-height"/></div>');
			if (_isAddNew) {
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			} else if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				if (model.ontherfilter.startdate == undefined || model.ontherfilter.startdate == "") {
					$("#startdate").attr("value", "@startDate");
				} else {
					$("#startdate").attr("value", model.ontherfilter.startdate);
				}
				if (model.ontherfilter.enddate == undefined || model.ontherfilter.enddate == "") {
					$("#enddate").attr("value", "@endDate");
				} else {
					$("#enddate").attr("value", model.ontherfilter.enddate);
				}
			} else {
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			}
		}
	},

	getontherfilter : function (_currentData) {
		var ontherfilter={};
		var params = _currentData.dataparams;
		if ($("#selectDatas_el").val().replace("S", "") == "001") {
			var curDate = $("#selectdate").attr("value");
			var startDate = $("#startdate").attr("value");
			var endDate = $("#enddate").attr("value");
			if (curDate != undefined && curDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				} else {
					params = [];
				}
				var isaddbasedate = true;
				var isaddstartdate = true;
				var isaddenddate = true;
				for (var i = 0; i < length; i++) {
					if (curDate.indexOf("@") != -1 && curDate.replace("@", "").length > 0 && params[i].paramname == curDate.replace("@", "")) {
						isaddbasedate = false;
					}
					if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0 && params[i].paramname == startDate.replace("@", "")) {
						isaddstartdate = false;
					}
					if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0 && params[i].paramname == endDate.replace("@", "")) {
						isaddenddate = false;
					}
				}
				if (isaddbasedate) {
					var paramstate = "0";
					if ($('#dimension').shrSelect("getValue").value == "month") {
						paramstate = "2";
					}
					params[length] = {
						paramname : curDate.replace("@", ""),
						paramdesc : "基准日期",
						paramtype : "2",
						paramcomp : "2",
						paramvalue : "getSystemDate()",
						paramnull : false,
						paramstate : paramstate,
						paramuipk : ""
					};
					length++;
				}
				if (isaddstartdate && $('#dimension').shrSelect("getValue").value == "month") {
					params[length] = {
						paramname : startDate.replace("@", ""),
						paramdesc : "开始日期",
						paramtype : "2",
						paramcomp : "2",
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : ""
					};
					length++;
				}
				if (isaddenddate && $('#dimension').shrSelect("getValue").value == "month") {
					params[length] = {
						paramname : endDate.replace("@", ""),
						paramdesc : "结束日期",
						paramtype : "2",
						paramcomp : "2",
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : ""
					};
					length++;
				}
			}
			if ($('#dimension').shrSelect("getValue").value == "month") {
				ontherfilter = {
					//selecttype : $('input:radio[name="countType"]:checked').val(),
					selecttype : $('#dimension').shrSelect("getValue").value,
					startdate : $("#startdate").attr("value"),
					enddate : $("#enddate").attr("value"),
					includetype : $("#includetype").shrSelect("getValue").value,
					selectdate : "@baseDate",
					isncount : ($('#isncount')).is(':checked').toString(),
					isOnthestrength :($('#isOnthestrength')).is(':checked').toString()
				}
			} else {
				ontherfilter = {
					//selecttype : $('input:radio[name="countType"]:checked').val(),
					selecttype : $('#dimension').shrSelect("getValue").value,
					selectdate : "@baseDate",
					isncount : ($('#isncount')).is(':checked').toString(),
					isOnthestrength :($('#isOnthestrength')).is(':checked').toString()
				}
			}
		} else if ($("#selectDatas_el").val().replace("S", "") == "002") {
			var startDate = $("#startdate_t").attr("value");
			if (startDate != undefined && startDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == startDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : startDate.replace("@", ""),
									paramdesc : "开始时间",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : startDate.replace("@", ""),
								paramdesc : "开始时间",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var endDate = $("#enddate_t").attr("value");
			if (endDate != undefined && endDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == endDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : endDate.replace("@", ""),
									paramdesc : "结束时间",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : endDate.replace("@", ""),
								paramdesc : "结束时间",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var beginYear = $("#beginYear_t").attr("value");
			if (beginYear != undefined && beginYear != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (beginYear.indexOf("@") != -1 && beginYear.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params.paramname == beginYear.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getFullYear();
						if (length == 0) {
							params = [{
									paramname : beginYear.replace("@", ""),
									paramdesc : "开始年份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
								}
							]
						} else {
							params[length] = {
								paramname : beginYear.replace("@", ""),
								paramdesc : "开始年份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
							}
						}
					}
				}
			}
			var beginMonth = $("#beginMonth_t").attr("value");
			if (beginMonth != undefined && beginMonth != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (beginMonth.indexOf("@") != -1 && beginMonth.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == beginMonth.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getMonth() + 1;
						if (length == 0) {
							params = [{
									paramname : beginMonth.replace("@", ""),
									paramdesc : "开始月份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
								}
							]
						} else {
							params[length] = {
								paramname : beginMonth.replace("@", ""),
								paramdesc : "开始月份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
							}
						}
					}
				}
			}
			var endYear = $("#endYear_t").attr("value");
			if (endYear != undefined && endYear != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (endYear.indexOf("@") != -1 && endYear.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == endYear.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getFullYear();
						if (length == 0) {
							params = [{
									paramname : endYear.replace("@", ""),
									paramdesc : "结束年份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
								}
							]
						} else {
							params[length] = {
								paramname : endYear.replace("@", ""),
								paramdesc : "结束年份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
							}
						}
					}
				}
			}
			var endMonth = $("#endMonth_t").attr("value");
			if (endMonth != undefined && endMonth != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (endMonth.indexOf("@") != -1 && endMonth.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == endMonth.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getMonth() + 1;
						if (length == 0) {
							params = [{
									paramname : endMonth.replace("@", ""),
									paramdesc : "结束月份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
								}
							]
						} else {
							params[length] = {
								paramname : endMonth.replace("@", ""),
								paramdesc : "结束月份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
							}
						}
					}
				}
			}
			ontherfilter = {
				selecttype : $("#isPeriod").shrRadio("isSelected")?"isPeriod":"isTime",
				startdate : $("#startdate_t").attr("value"),
				enddate : $("#enddate_t").attr("value"),
				beginYear : $("#beginYear_t").attr("value"),
				beginMonth : $("#beginMonth_t").attr("value"),
				endYear : $("#endYear_t").attr("value"),
				endMonth : $("#endMonth_t").attr("value")
			};
		} else if ($("#selectDatas_el").val().replace("S", "") == "003") {
			var startDate = $("#startdate").attr("value");
			if (startDate != undefined && startDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == startDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : startDate.replace("@", ""),
									paramdesc : "开始日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : startDate.replace("@", ""),
								paramdesc : "开始日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var endDate = $("#enddate").attr("value");
			if (endDate != undefined && endDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == endDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : endDate.replace("@", ""),
									paramdesc : "结束日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : endDate.replace("@", ""),
								paramdesc : "结束日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			ontherfilter = {
				startdate : $("#startdate").attr("value"),
				enddate : $("#enddate").attr("value")
			}
		} else if ($("#selectDatas_el").val().replace("S", "") == "004") {
			var curDate = $("#selectdate").attr("value");
			if (curDate != undefined && curDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (curDate.indexOf("@") != -1 && curDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == curDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : curDate.replace("@", ""),
									paramdesc : "基准日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : curDate.replace("@", ""),
								paramdesc : "基准日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			ontherfilter = {
				selectdate : $("#selectdate").attr("value")
			}
		} else if ($("#selectDatas_el").val().replace("S", "") == "005") {
			var startDate = $("#startdate").attr("value");
			if (startDate != undefined && startDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == startDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : startDate.replace("@", ""),
									paramdesc : "开始日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : startDate.replace("@", ""),
								paramdesc : "开始日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var endDate = $("#enddate").attr("value");
			if (endDate != undefined && endDate != "") {
				var length = 0;
				if (params) {
					length = params.length;
				}
				if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (params[i].paramname == endDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							params = [{
									paramname : endDate.replace("@", ""),
									paramdesc : "结束日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							params[length] = {
								paramname : endDate.replace("@", ""),
								paramdesc : "结束日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			ontherfilter = {
				startdate : $("#startdate").attr("value"),
				enddate : $("#enddate").attr("value")
			//	atthrOrg : $("#atthrOrg").attr("value")
			}
		}

		_currentData.dataparams = params;
		return ontherfilter;
	}

});
