﻿shr.defineClass("shr.report.queryCondition", shr.framework.Core, {
	
	// 初始化查询条件区域
	initalQueryCondition : function (reportDtas) {
		_self = this;
		this.reportDtas = reportDtas;
		var field_info = $(".select_field").html();
		var filter_block_content = $(".filter_block").html();
		$(".filter_field").find(".text-label").live("click", function () {
			if(!($("#filter_param_detailedinfo_hide").is(":hidden"))){
				shr.showError({
					message : '不可修改！',
					hideAfter : 3
				});
				return;
			}
			$(".icon-remove").click();
			var filter_block = $(this).parents(".filter_block");
			var type = $(this).parent().attr("field_type");
			var prop_field_query = $(this).parent().attr("prop_field_query");
			var prop_op = $(this).parent().attr("prop_op");
			var prop_value = $(this).parent().attr("prop_value");
			var fieldValue = $(this).parent().data("fieldValue");
			_self.initalProp_field(field_info,$(this));
			$('#prop_field_query').shrPromptBox("setValue", fieldValue);
			$("#prop_op").shrSelect("setValue", prop_op);
			if (type == "StringEnum" || type == "IntEnum" || type == "Boolean") {
				$("#prop_value").shrSelect("setValue", prop_value);
			} else if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined" && $(this).parent().data("prompt_value") != null && $(this).parent().data("prompt_value") != "") {
				$('#prop_value').shrPromptBox("setValue", $(this).parent().data("prompt_value"));
			} else {
				$("#prop_value").val(prop_value);
			}
			$("#prop_value").blur();
			$("#prop_value_down").hide();
			$("#prop_value").parents(".ui-select-frame").removeClass("oe_focused");
			filter_block.find(".icon-ok").attr("index", $(this).parent().index());
		});

		$(".icon-plus").live("click", function (e) {
			if($("#filter_param_detailedinfo_hide").is(":hidden")){
				var filter_block = $(this).parents(".filter_block");
				_self.initalProp_field(field_info,$(this));
				filter_block.find(".icon-ok").attr("isOr", "false");
				filter_block.find(".icon-ok").data("fieldinfo", $(this).parent().prev());
			}else{
				shr.showError({
					message : '不可修改！',
					hideAfter : 3
				});
				return;
			}
		});

		$(".icon_add_or").die().live("click", function (e) {
			if($("#filter_param_detailedinfo_hide").is(":hidden")){
				var filter_block = $(this).parents(".filter_block");
				_self.initalProp_field(field_info,$(this));
				filter_block.find(".icon-ok").attr("isOr", "true");
			}else{
				shr.showError({
					message : '不可修改！',
					hideAfter : 3
				});
				return;
			}
		});

		$(".icon-ok").die().live("click", function (e) {
			var filter_block = $(this).parents(".filter_block");
			var newValue = filter_block.find("#prop_value").val(); 
			var oldValue = filter_block.find(".filter_field").find(".text-tag:eq(" + $(this).attr("index") + ")").attr("prop_value");
			if (filter_block.find("#prop_field_query").size() != 0) {
				if (filter_block.find("#prop_field_query").val() == "" || filter_block.find("#prop_op").val() == "") {
					shr.showError({
						message : "查询条件输入不全",
						hideAfter : 3
					});
				} else if (filter_block.find("#prop_field_query").attr("prop_field_query") == null) {
					shr.showError({
						message : "查询条件输入不合法",
						hideAfter : 3
					});
				} else {
					var filter_field = filter_block.find(".filter_field");
					filter_field.parent().find(".field_ok").css("display", "none");

					var prop_field_query = filter_block.find('#prop_field_query').val();
					var prop_op = filter_block.find("#prop_op").shrSelect("getValue").value;
					var prop_value_text = filter_block.find("#prop_value").val();
					var prop_op_text = filter_block.find("#prop_op").val();
					var prop_value = "";
					var fieldValue = filter_block.find("#prop_field_query").data('fieldValue');
					if (prop_value == "" || prop_value == null) {
						prop_value = filter_block.find("#prop_value").val();
					}
					if (prop_value_text == "" || prop_value_text == null) {
						prop_value_text = "@" + fieldValue.field.replace(".", "_");
					}

					if (fieldValue.type == "StringEnum" || fieldValue.type == "IntEnum" || fieldValue.type == "Boolean") {
						prop_value = filter_block.find("#prop_value_el").val();
					}

					if ($(this).attr("index") != undefined) {
						filter_field.find(".text-tag:eq(" + $(this).attr("index") + ")").replaceWith('<div class="text-tag" isOr="' + $(this).attr("isOr") + '" field_type="' + filter_block.find('#prop_field_query').attr("field_type") + '" prop_field_query="' + filter_block.find('#prop_field_query').attr("prop_field_query") + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"><span class="text-label">\"' + prop_field_query + "\" " + prop_op_text + " \"" + prop_value_text + '\"</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined") {
							var prompt_value = filter_block.find("#prop_value").shrPromptBox("getValue");
							if (filter_block.find("#prop_value").prev().val() != "") {
								filter_field.find(".text-tag:eq(" + $(this).attr("index") + ")").data("prompt_value", prompt_value);
							}
						}
						filter_field.find(".text-tag:eq(" + $(this).attr("index") + ")").data('fieldValue', fieldValue);
					} else if ($(this).attr("isOr") == "false") {
						filter_field.append('<div class="text-tag" isOr="false" field_type="' + filter_block.find('#prop_field_query').attr("field_type") + '" prop_field_query="' + filter_block.find('#prop_field_query').attr("prop_field_query") + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"><span class="text-label">\"' + prop_field_query + "\" " + prop_op_text + " \"" + prop_value_text + '\"</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined") {
							var prompt_value = filter_block.find("#prop_value").shrPromptBox("getValue");
							if (filter_block.find("#prop_value").prev().val() != "") {
								filter_field.find(".text-tag:last").data("prompt_value", prompt_value);
							}
						}
						filter_field.find(".text-tag:last").data('fieldValue', fieldValue);
					} else {
						$("<div class='filter_block'></div>").insertAfter($(".filter_block:last")).append(filter_block_content);
						$(".filter_block:last").find(".filter_field").append('or <div class="text-tag" isOr="true" field_type="' + filter_block.find('#prop_field_query').attr("field_type") + '" prop_field_query="' + filter_block.find('#prop_field_query').attr("prop_field_query") + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"><span class="text-label">\"' + prop_field_query + "\" " + prop_op_text + " \"" + prop_value_text + '\"</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined") {
							var prompt_value = filter_block.find("#prop_value").shrPromptBox("getValue");
							if (filter_block.find("#prop_value").prev().val() != "") {
								$(".filter_block:last").find(".filter_field").find(".text-tag:last").data("prompt_value", prompt_value);
							}
						}
						$(".filter_block:last").find(".filter_field").find(".text-tag:last").data('fieldValue', fieldValue);
						filter_field.css("display", "table-cell");
						filter_field = $(".filter_block:last").find(".filter_field");
					}
					$(this).removeAttr("index");
					$(".select_field").empty();
					$(".select_field").hide();

					filter_field.css("display", "table-cell");
					$(".field_add").css("display", "table-cell");
					$(".field_add").find(".icon_add_or").hide();
					$(".filter_block:last").find(".icon_add_or").show();
				}
			}
			
			if((newValue!=null && newValue!=undefined) && (oldValue!=null && oldValue!="" && oldValue!=undefined) && (newValue != oldValue)){
				for(var dataparam_index=0; dataparam_index < _self.reportDtas._currentData.dataparams.length ; dataparam_index++){
					if(oldValue.replace("@","") == _self.reportDtas._currentData.dataparams[dataparam_index].paramname.replace(".", "_")){
						_self.reportDtas._currentData.dataparams.splice(dataparam_index, 1);
						break;
					}
				}
			}
			// 缓存查询条件 并 更新过滤参数
			_self.getfilterItems(_self.reportDtas);
		});

		$(".icon-remove").live("click", function (e) {
			var filter_block = $(this).parents(".filter_block");
			filter_block.find(".field_ok").css("display", "none");
			filter_block.find(".field_add").css("display", "table-cell");
			filter_block.find(".filter_field").css("display", "table-cell");
			filter_block.find(".select_field").empty();
			filter_block.find(".select_field").hide();
			$(this).prev().removeAttr("index");
		});

		$(".filter_field .text-tag").live("mouseenter", function (e) {
			$(this).find(".text-remove").show();
		}).live("mouseleave", function (e) {
			$(this).find(".text-remove").hide();
		});

		$(".filter_field").find(".text-remove").live("click", function (e) {
			if(!($("#filter_param_detailedinfo_hide").is(":hidden"))){
				shr.showError({
					message : '不可删除！',
					hideAfter : 3
				});
				return;
			}
		
			//var remove_field = $(this).parent(".text-tag").attr("prop_field_query");
			var remove_value = $(this).parent(".text-tag").attr("prop_value");
			if ($(this).parents(".filter_field").find(".text-tag").length == 1 && $(".filter_block").length > 1) {
				$(this).parents(".filter_block").remove();
				$(".filter_block:last").find(".icon_add_or").show();
			} else {
				if ($(this).parents(".filter_field").find(".text-tag").length == 1) {
					$(this).parents(".filter_block").find(".icon_add_or").hide();
				}
				$(this).parent().remove();
			}
			
			$('#mainTable').find("tr[tabindex='-1']").each(function () {
							if((remove_value.indexOf("@") == 0 && $(this).find("td").find("input[id^=data_parame_name]").attr("paramname") == remove_value.replace("@",""))){
								$(this).remove();
								return false;
							}
						});
			_self.getfilterItems(_self.reportDtas);
		});

	},
	
	initalProp_fieldF7 : function (fieldComponent, selectData) {
		var tree_f7_json = {
			id : "prop_field_query",
			name : "prop_field_query"
		};
		tree_f7_json.subWidgetName = 'shrPromptTree';
		tree_f7_json.subWidgetOptions = {
			treeSettings : {},
			dataUrl : shr.getContextPath() + "/shr/msf/service.do?method=callService&serviceName=getQueryZTreeNodes&scheme=" + selectData,
			width : 250,
			schemeNum:$("#selectDatas_el").val().replace("S", "")
		};
		$('#prop_field_query').shrPromptBox(tree_f7_json);
		fieldComponent.shrPromptBox(tree_f7_json);
		_self._addItemEventListener(fieldComponent);
	},

	initalProp_field : function (field_info,selectComp) {
		var filter_block = selectComp.parents(".filter_block");
		filter_block.find(".select_field").html(field_info);
		_self.initalProp_fieldF7(filter_block.find('#prop_field_query'), $('#selectDatas_el').val().replace("S", ""));
		filter_block.find(".select_field").css("display", "table-cell");
		filter_block.find(".select_field >div").addClass("search-emp-field");
		filter_block.find(".field_ok").css("display", "table-cell");
		filter_block.find(".field_add").css("display", "none");
		filter_block.find(".filter_field").css("display", "block");
	},
	
	getfilterItems : function (reportDtas) {

		var searchResultAll = [];
		var dataparams = [];
		var paramIndex = 0;
		var _currentData = reportDtas._currentData;
		if (_currentData.customsql != undefined && (_currentData.customsql == true || _currentData.customsql == "true")) {
			return {
				status : 1
			};
		}
		$(".filter_block").each(function (index) {
			var searchResult = [];
			$(this).find(".filter_field .text-tag").each(function (index) {
				var prop_field = $(this).attr("prop_field_query");
				var prop_op = $(this).attr("prop_op");
				var prop_value = $(this).attr("prop_value");
				var prompt_value = "";
				var field_type = $(this).attr("field_type");
				var prop_text = $(this).find(".text-label").html();
				var fieldValue = $(this).data("fieldValue");
				var uipk = fieldValue.uipk;
				if (uipk != undefined && uipk != "" && uipk != "null" && uipk != "undefined" && $(this).data("prompt_value") != null) {
					prompt_value = $(this).data("prompt_value");
				}

				var fileType = "0";
				var comp = "0";
				var parampk = "";
				if (field_type != undefined && field_type == "String") {
					fileType = "0";
				} else if (field_type == "TimeStamp" || field_type == "Date") {
					fileType = "2";
					comp = "2";
				} else if (field_type == "IntEnum") {
					fileType = "1";
					comp = "1";
				} else if (field_type == "Short" || field_type == "Double" || field_type == "BigDecimal" || field_type == "Integer" || field_type == "Long" || field_type == "Float" || field_type == "Int") {
					fileType = "1";
					comp = "0";
				} else if (field_type == "StringEnum") {
					fileType = "0";
					comp = "1";
				} else if (field_type == "Boolean") {
					fileType = "3";
					comp = "1";
				}
				if (uipk != undefined && uipk != null && uipk != "" && uipk != "null") {
					comp = "4";
					parampk = uipk + ";" + prop_field.substring(prop_field.lastIndexOf('.') + 1);
				}
				if (fieldValue.enumSource != undefined && fieldValue.enumSource != null && fieldValue.enumSource != "") {
					parampk = fieldValue.enumSource;
				}
				//if(prop_field.replace(".","_") == prop_value){
				if (prop_value == "" || prop_value == "null" || prop_value == null || prop_value == "@" + prop_field.replace(".", "_") || prop_value.indexOf("@") == 0) {
					if(prop_value == "" || prop_value == "null" || prop_value == null || prop_value == "@" + prop_field.replace(".", "_") ){
						prop_value = "@" + prop_field.replace(".", "_");
					}
					dataparams[paramIndex] = {
						//paramname : prop_field.replace(".", "_"),
						paramname : prop_value.replace("@", ""),
						paramdesc : fieldValue.name,
						paramtype : fileType,
						paramcomp : comp,
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : parampk
					};
					paramIndex++;
				}

				searchResult[index] = {
					prop_field : prop_field,
					prop_text : prop_text,
					prop_op : prop_op,
					prop_value : prop_value,
					prompt_value : prompt_value,
					field_type : field_type,
					fieldValue : fieldValue
				}
			});
			searchResultAll.push(searchResult);
		});

		//_currentData.filterItems = JSON.stringify(searchResultAll);  //**** 
		if (dataparams.length > 0) {
			if (_currentData.dataparams != undefined && _currentData.dataparams != "") {
				var paramlength = _currentData.dataparams.length;
				var addIndex = 0;
				for (var i = 0; i < dataparams.length; i++) {
					var isadd = true;
					$('#mainTable').find(".jqgrow").each(function (index) {
						var rowID = $(this).attr("id");
						if($("#data_parame_name_" + rowID).attr("paramname").replace(".","_") == dataparams[i].paramname){
							isadd = false;
						}
					});
					if (isadd) {
						var record = {
							dataparams : dataparams[i]
						};
						_self.reportDtas.loadRow(record);
					}
				}
			} else {
				if(_self.reportDtas._isAddNew){
					_currentData.dataparams = dataparams;
					_self.reportDtas.loadMapping();
					_currentData.dataparams =[];
				}else{
					//_self.reportDtas.loadMapping();
						
					var paramlength = _currentData.dataparams.length;
					var addIndex = 0;
					for (var i = 0; i < dataparams.length; i++) {
						var isadd = true;
						$('#mainTable').find(".jqgrow").each(function (index) {
							var rowID = $(this).attr("id");
							if($("#data_parame_name_" + rowID).attr("paramname").replace(".","_") == dataparams[i].paramname){
								isadd = false;
							}
						});
						if (isadd) {
							var record = {
								dataparams : dataparams[i]
							};
							_self.reportDtas.loadRow(record);
						}
					}
				}
			}
		}
		
		// 
		for(var i=0; i<searchResultAll[0].length; i++){
			var propfield="";
			if(((searchResultAll[0][i].prop_value).indexOf("@")!=0)){
				propfield = searchResultAll[0][i].prop_field;
			}else{
				continue;
			}
			
			// 直接删除对应的映射关系
			$('#mainTable').find("tr[tabindex='-1']").each(function () {
				if($(this).find("td").find("input[id^=data_parame_name]").attr("paramname") == propfield.replace(".", "_")){
					$(this).remove();
				}
			});
			
			for(var j=0; j<_currentData.dataparams.length; j++){
				if(propfield.replace(".","_") == _currentData.dataparams[j].paramname){
					_currentData.dataparams.splice(j, 1);
				}	
			}
		}
		
		// 
		$('#mainTable').find(".jqgrow").each(function (index) {
			var rowID = $(this).attr("id");
			var isExist = false;
			
			for(var searchResultAll_index = 0; searchResultAll_index < searchResultAll.length; searchResultAll_index++ )
				for(var searchResult_index =0; searchResult_index < searchResultAll[searchResultAll_index].length; searchResult_index++){
					if(($("#data_parame_name_" + rowID).attr("paramname") == searchResultAll[searchResultAll_index][searchResult_index].prop_value.replace("@", ""))||(searchResultAll[searchResultAll_index][searchResult_index].prop_value.indexOf("@") == 0 && $("#data_parame_name_" + rowID).attr("paramname") == searchResultAll[searchResultAll_index][searchResult_index].prop_value.replace("@", ""))){
						isExist = true;
					}
				}
			
			for(var dataparam_index=0; dataparam_index < _self.reportDtas._currentData.dataparams.length ; dataparam_index++){
				if($("#data_parame_name_" + rowID).attr("paramname") == _self.reportDtas._currentData.dataparams[dataparam_index].paramname.replace(".", "_")){
					isExist = true;
				}
			}
			
			if(!isExist){
				$(this).remove();
			}
			
		});
	},
	
	// 加载查询条件区域数据
	loadQueryCondition : function (model) {
		/*
		if($(".filter_block:last").find(".field_add").is(":visible")){
			return;
		}
		*/
		var length = $(".filter_block").length;
		$(".filter_block").each(function(index){
			if(index != length-1){
				$(this).remove();
			}
		});
		//$(".filter_block:last").show();
		$(".filter_block:last").find(".filter_field").empty()
		
		var filter_block = $(".filter_block:last");
			filter_block.find(".field_ok").css("display", "none");
			filter_block.find(".field_add").css("display", "table-cell");
			filter_block.find(".filter_field").css("display", "table-cell");
			filter_block.find(".select_field").empty();
			filter_block.find(".select_field").hide();
			$(this).prev().removeAttr("index");
			
		if (model.filterItems == undefined || model.filterItems == []) {
			$(".filter_block:last").find(".filter_field").empty();
			return;
		}
		// 初始化数据
		var filter_block_content = $(".filter_block").html();
		if (model.filterItems != undefined) {
			var searchFilter = $.parseJSON(model.filterItems);
			if(searchFilter == null)
			return;
			for (var i = 0, len = searchFilter.length; i < len; i++) {
				if (i > 0) {
					$("<div class='filter_block'></div>").insertAfter($(".filter_block:last")).append(filter_block_content);
				}
				if (i == searchFilter.length - 1) {
					$(".filter_block:last").find(".icon_add_or").show();
				}
				$(".filter_block:last").find(".filter_field").empty();
				
				for (var j = 0, slen = searchFilter[i].length; j < slen; j++) {
					var prop_field = searchFilter[i][j].prop_field;
					var prop_op = searchFilter[i][j].prop_op;
					var prop_value = searchFilter[i][j].prop_value;
					var prompt_value = searchFilter[i][j].prompt_value;
					var field_type = searchFilter[i][j].field_type;
					var prop_text = searchFilter[i][j].prop_text;
					var fieldValue = searchFilter[i][j].fieldValue;
					var uipk = fieldValue.uipk;
					if (i > 0 && j == 0) {
						$(".filter_block:last").find(".filter_field").append('or <div class="text-tag" field_type="' + field_type + '" prop_field_query="' + prop_field + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"></div>');
					} else {
						$(".filter_block:last").find(".filter_field").append('<div class="text-tag" field_type="' + field_type + '" prop_field_query="' + prop_field + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"></div>');
					}
					$(".filter_block:last").find(".filter_field .text-tag:last").append('<span class="text-label">' + prop_text + '</span><span class="text-remove" title="删除" style="display: none;">x</span>');

					if (uipk != null && uipk != "null" && uipk != "undefined") {
						$(".filter_block:last").find(".filter_field .text-tag:last").data("prompt_value", prompt_value);
					}
					$(".filter_block:last").find(".filter_field .text-tag:last").data("fieldValue", fieldValue);
				}
			}
		}
	},
	
	_addItemEventListener : function (prop_fieldCom) {
		var prop_op_json = {
			id : "prop_op"
		};
		prop_op_json.data = [{
				value : "like",
				alias : "包含"
			}, {
				value : "not like",
				alias : "不包含"
			}, {
				value : "=",
				alias : "等于"
			}, {
				value : "<>",
				alias : "不等于"
			}
		];

		var prop_op_date_json = {
			id : "prop_op"
		};
		prop_op_date_json.data = [{
				value : "=",
				alias : "等于"
			}, {
				value : "<>",
				alias : "不等于"
			}, {
				value : ">",
				alias : "大于"
			}, {
				value : "<",
				alias : "小于"
			}, {
				value : ">=",
				alias : "大于等于"
			}, {
				value : "<=",
				alias : "小于等于"
			}
		];

		var prop_boolean_json = {
			id : "prop_op"
		};
		prop_boolean_json.data = [{
				value : "=",
				alias : "等于"
			}, {
				value : "<>",
				alias : "不等于"
			}
		];
		prop_fieldCom.shrPromptBox("option", {
			onchange : function (e, value) {
				$(this).parents(".ui-promptBox-frame").next().replaceWith('<input id="prop_op" type="text" name="prop_op" class="search-input-length input-height"/>');
				$(this).parents(".ui-promptBox-frame").next().next().replaceWith('<input id="prop_value" type="text" name="prop_value" class="search-input-length input-height"/>');
				var parent = $(this).parents(".ui-promptBox-frame").parent();
				$("#prop_op_down").remove();
				$("#prop_value_down").remove();
				if (value.current != null) {
					var id = value.current.id;
					var name = value.current.name;
					var type = value.current.type;
					var uipk = value.current.uipk;
					var enumSource = value.current.enumSource;
					var field = value.current.field;
					prop_fieldCom.data('fieldValue', value.current);
					prop_fieldCom.attr("prop_field_query", field);
					prop_fieldCom.attr("field_type", type);
					if (type == "Date" || type == "TimeStamp") {
						parent.find("#prop_op").shrSelect(prop_op_date_json);
						parent.find("#prop_op").shrSelect("setValue", prop_op_date_json.data[0].value);

						var picker_json = {};
						parent.find("#prop_value").shrDatePicker(picker_json);
					}
					if (type == "Short" || type == "Double" || type == "BigDecimal" || type == "Integer" || type == "Long" || type == "Float" || type == "Int") {
						parent.find("#prop_op").shrSelect(prop_op_date_json);
						parent.find("#prop_op").shrSelect("setValue", prop_op_date_json.data[0].value);
					}
					if (type == "StringEnum" || type == "IntEnum") {
						parent.find("#prop_op").shrSelect(prop_boolean_json);
						parent.find("#prop_op").shrSelect("setValue", prop_boolean_json.data[0].value);

						var select_json = {};
						select_json.id = "prop_value";
						var enumUrl = enumSource;
						if (enumUrl == "com.kingdee.shr.compensation.CalState") {
							select_json.filter = "1,4,8,12,20";
						}
						if (enumUrl && enumUrl.trim().indexOf("url:") == 0) {
							var url = enumUrl.trim().substr(4);
							select_json.url = url;
						} else {
							select_json.enumSource = enumUrl;
						}
						parent.find("#prop_value").shrSelect(select_json);
					}
					if (type == "Boolean") {
						parent.find("#prop_op").shrSelect(prop_boolean_json);
						parent.find("#prop_op").shrSelect("setValue", prop_boolean_json.data[0].value);

						var select_json = {
							id : "prop_value"
						};
						select_json.data = [{
								value : "1",
								alias : "是"
							}, {
								value : "0",
								alias : "否"
							}
						];
						parent.find("#prop_value").shrSelect(select_json);
					}
					if (type == "String") {
						parent.find("#prop_op").shrSelect(prop_op_json);
						parent.find("#prop_op").shrSelect("setValue", prop_op_json.data[0].value);
						parent.find("#prop_value").css("width", "280px");
						//parent.find("#prop_value").attr("placeholder", "多选请使用用逗号分隔");
					}
					if (uipk != null && uipk != "null" && uipk != "undefined") {
						var f7FieldName = value.current.f7FieldName;
						var f7Json = {
							id : "prop_value",
							name : "prop_value"
						};
						if (f7FieldName != undefined) {
							f7Json.displayFormat = "{" + f7FieldName + "}";
						}
						f7Json.subWidgetName = 'shrPromptGrid';
						f7Json.subWidgetOptions = {
							title : name,
							uipk : uipk,
							multiselect : false
						};
						parent.find("#prop_value").shrPromptBox(f7Json);
						parent.find("#prop_value").unbind("keydown.shrPromptGrid");
						parent.find("#prop_value").unbind("keyup.shrPromptGrid");
					}
					$(".select_field >div").addClass("search-emp-field");
					parent.find("#prop_op").shrSelect("option", {
						onChange : function (e, value) {
							$(this).parents(".ui-select-frame").removeClass("oe_focused");
							$("#prop_value").focus();
							if (type == "Boolean" || type == "StringEnum" || type == "IntEnum") {
								$("#prop_value").shrSelect("selectClick");
							}
						}
					});
				}
			}
		});
	},
	
	getSearchItems : function (_currentData) {
		var searchResultAll = [];
		var dataparams = [];
		var paramIndex = 0;

		if ( (_currentData.customsql == true || _currentData.customsql == "true")) {
			return searchResultAll;
		}
		$(".filter_block").each(function (index) {
			var searchResult = [];
			$(this).find(".filter_field .text-tag").each(function (index) {
				var prop_field = $(this).attr("prop_field_query");
				var prop_op = $(this).attr("prop_op");
				var prop_value = $(this).attr("prop_value");
				var prompt_value = "";
				var field_type = $(this).attr("field_type");
				var prop_text = $(this).find(".text-label").html();
				var fieldValue = $(this).data("fieldValue");
				var uipk = fieldValue.uipk;
				if (uipk != undefined && uipk != "" && uipk != "null" && uipk != "undefined" && $(this).data("prompt_value") != null) {
					prompt_value = $(this).data("prompt_value");
				}

				var fileType = "0";
				var comp = "0";
				var parampk = "";
				if (field_type != undefined && field_type == "String") {
					fileType = "0";
				} else if (field_type == "TimeStamp" || field_type == "Date") {
					fileType = "2";
					comp = "2";
				} else if (field_type == "IntEnum") {
					fileType = "1";
					comp = "1";
				} else if (field_type == "Short" || field_type == "Double" || field_type == "BigDecimal" || field_type == "Integer" || field_type == "Long" || field_type == "Float" || field_type == "Int") {
					fileType = "1";
					comp = "0";
				} else if (field_type == "StringEnum") {
					fileType = "0";
					comp = "1";
				} else if (field_type == "Boolean") {
					fileType = "3";
					comp = "1";
				}
				if (uipk != undefined && uipk != null && uipk != "") {
					comp = "4";
					parampk = uipk + ";" + prop_field.substring(prop_field.lastIndexOf('.') + 1);
				}
				if (fieldValue.enumSource != undefined && fieldValue.enumSource != null && fieldValue.enumSource != "") {
					parampk = fieldValue.enumSource;
				}
				//if(prop_field.replace(".","_") == prop_value){
				if (prop_value == "" || prop_value == "null" || prop_value == null || prop_value == "@" + prop_field.replace(".", "_")) {
					prop_value = "@" + prop_field.replace(".", "_");
					dataparams[paramIndex] = {
						paramname : prop_field.replace(".", "_"),
						paramdesc : fieldValue.name,
						paramtype : fileType,
						paramcomp : comp,
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : parampk
					};
					paramIndex++;
				}

				searchResult[index] = {
					prop_field : prop_field,
					prop_text : prop_text,
					prop_op : prop_op,
					prop_value : prop_value,
					prompt_value : prompt_value,
					field_type : field_type,
					fieldValue : fieldValue
				}
			});
			searchResultAll.push(searchResult);
		});
		return searchResultAll;
	},
	
});