﻿shr.defineClass("shr.report.reportDatas", shr.framework.Core, {
	IsEdit : null,
	IsReportParamOk :null,
	DataPermissionIsOk : null,
	initalizeDOM : function () {
		var _self = this;
		shr.report.reportDatas.superClass.initalizeDOM.call(this);
		this.IsReportParamOk = false;
		this.DataPermissionIsOk = true;
		this._currentData = {};
		this._dataparams = [];
		this._currentDataParaMapping = [];
		this.filterParamUtil = new shr.report.filterParams;
		this.queryConditionUtil = new shr.report.queryCondition;
		this.dateUtils = new shr.report.dateUtils;
		this.preViewUtil = new shr.report.preViewData;
		$(".div_mid").width($(".view_manager_body").width() - 420);
		_self.initMainBody();
		$("#dialog_report").remove();
		if ($("#dialog_report").attr("id") == undefined || $("#dialog_report").attr("id") == "") {
			$('#preView').append('<div id="dialog_report"><div class="report_filter"></div></div>');
		}
		// 绑定事件
		$("#out_field").die();
		$("#out_field").live("click", function (e) {
			if (!$("#div_outfield_detailedinfo").is(":visible")) {
				_self.runEffect("#div_outfield_detailedinfo");
				_self.runEffect("#div_outfield_baseinfo");
			} else {
				_self.runEffect("#div_outfield_detailedinfo");
				_self.runEffect("#div_outfield_baseinfo");
			}
			$(this).find(".custom-filter").toggleClass("rotate");
		});

		$("#filter_param").die();
		$("#filter_param").live("click", function (e) {
			if (!$("#filter_param_detailedinfo").is(":visible")) {
				_self.runEffect("#filter_param_detailedinfo");
				_self.runEffect("#filter_param_baseinfo");
			} else {
				_self.runEffect("#filter_param_detailedinfo");
				_self.runEffect("#filter_param_baseinfo");
			}
			$(this).find(".custom-filter").toggleClass("rotate");
		});

		$("#param_mapping").die();
		$("#param_mapping").live("click", function (e) {
			if (!$("#div_parammapping_detailedinfo").is(":visible")) {
				_self.runEffect("#div_parammapping_detailedinfo");
				_self.runEffect("#div_parammapping_baseinfo");
			} else {
				_self.runEffect("#div_parammapping_detailedinfo");
				_self.runEffect("#div_parammapping_baseinfo");
			}
			$(this).find(".custom-filter").toggleClass("rotate");
		});

		$(window).resize(function () {
			_self.resizeTable();
		});
		
		$(document).click(function() {
			var $target;
			if(event){
				$target = $(event.target);
				if ($target.is(".oe_searchview_drawer") || $target.parents(".oe_searchview_drawer").length != 0 || $target.parents(".emp_searchview").length != 0){
					return;
				}
				$(".oe_searchview_drawer").hide();
				$(".dropdown-custom").hide();
			}
		});
	},

	initMainBody : function () {
		this.initOutPutSection();
		this.initFilterAndParam();
		this.initMappingTable();
	},
	initOutPutSection : function () {
		this.initalTree();
		this.initOutPutModel();
		this.initOutPutTable();
		this.initalOtherOption();
		this.initLeftHeadButton();
	},
	initFilterAndParam : function () {
		this.queryConditionUtil.initalQueryCondition(this);
	},

	initLeftHeadButton : function () {
		// 复制新增F7设置
		var _self = this;
		$("#div_datasources_bt").append('<div id="personal_select" style="display: none;"><input id="personalds_f7" type="text" name="personalds_f7" style="width:50px;display: none;"></input></div>');
		var f7Json = {
			id : "personalds_f7",
			name : "personalds_f7"
		};
		f7Json.displayFormat = "{number}";
		f7Json.subWidgetName = 'shrPromptGrid';
		f7Json.subWidgetOptions = {
			title : "数据源",
			//uipk : 'com.kingdee.shr.report.app.PersonDataSourceDef.F7',
			uipk : 'com.kingdee.shr.report.app.ReportDatas.person.F7',
			multiselect : true
		};
		$("#personalds_f7").shrPromptBox(f7Json);

		// 引用扩展数据源F7设置
		$("#div_datasources_bt").append('<div id="report_select" style="display: none;"><input id="reportds_f7" type="text" name="reportds_f7" style="width:50px;display: none;"></input></div>');
		var f7Json = {
			id : "prop_reportds",
			name : "prop_reportds"
		};
		f7Json.displayFormat = "{number}";
		f7Json.subWidgetName = 'shrPromptGrid';
		f7Json.subWidgetOptions = {
			title : "扩展报表数据源",
			uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.F7',
			multiselect : true
		};
		$("#reportds_f7").shrPromptBox(f7Json);
		// 清理F7控件内的值
		$("#personalds_f7").bind("change", function (e, value) {
			var addData = [];
			var addIndex = 0;
			var selectValue = $("#personalds_f7").shrPromptBox("getValue");
			if (selectValue == null) {
				return;
			}

			for (var i = 0; i < selectValue.length; i++) {
				selectValue[i] = jQuery.parseJSON(JSON.stringify(selectValue[i]).replace("personalDS.id", "personalDS_id"));
				addData[addIndex++] = {
					reportId : _self.reportId,
					dsType : 10,
					datasId : selectValue[i].personalDS_id,
					reportdatasId : selectValue[i].id
				};
			}
			if (addData.length > 0) {
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=getDatas",
					data : {
						uipk : "com.kingdee.shr.report.app.ReportDef.form",
						selectData : JSON.stringify(addData)
					},
					success : function (data) {
						if(data.IsPermission != undefined && data.IsPermission == false){
							var mess="";
							for(var i=0;i<data.msg.length;i++){
								mess += data.msg[i]+"</br>";
							}
							shr.showError({
								message : mess,
								hideAfter : 5
							});
						}
						for (var i = 0; i < data.dataValues.length; i++) {
							var canedit = true; // 是否可编辑（默认可编辑）
							var dataname = data.dataValues[i].name;
							var id = data.dataValues[i].id;
							var datatype = 10;
							_self._datasources.push(data.dataValues[i]);
							$(".div_datasources_list").append('<div class="text-tag" prop_field="' + id + '" name="' + dataname + '" datatype="' + datatype + '">'
								 + '<span class="text-label" title="' + dataname + '">' + dataname + '</span>'
								 + '<span class="text-remove" title="删除" prop_field="' + id + '" name="' + dataname + '" datatype="' + datatype + '" style="display: none;">x</span>'
								 + '</div>');
						}
						// 展开刚刚获取的数据源 模拟点击该数据源标签
						// 如果选择了多条数据源，则展开最后一条
						$("div[prop_field='" + data.dataValues[ data.dataValues.length - 1 ].id + "']").find("span[class^='text-label']").click();
						_self._isAddNew = false;
						_self._isAddNew_Save = false;
					},
					error : function(data){
						shr.showError({
							message : "复制数据源不成功！",
							hideAfter : 5
						});
					}
				});
			}
			// 清理F7控件内的值
			$("#personalds_f7").shrPromptBox("setValue", "");
		});
		$("#prop_reportds").shrPromptBox("option", {
			onchange : function (e, value) {
				var addData = [];
				var addIndex = 0;
				for (var i = 0; i < value.current.length; i++) {
					var hasName = false;
					$(".div_datasources_list").find(".text-label").each(function () {
						if ($(this).html() == value.current[i].name) {
							hasName = true;
						}
					});
					if (!hasName) {
						//addData[addIndex++] ={dsType:value.current[i].dsType,datasId:value.current[i].id};
						addData[addIndex++] = {
							reportId : _self.reportId,
							dsType : 0,
							dataSourceID : value.current[i].id
						};
					}
				}
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=addDatas",
					data : {
						uipk : "com.kingdee.shr.report.app.ReportDef.form",
						selectData : JSON.stringify(addData)
					},
					success : function (data) {
						for (var i = 0; i < data.data.length; i++) {
							$(".div_datasources_list").append('<div class="text-tag" prop_field="' + data.data[i].dataSources.id + '" name="' + data.data[i].dataSources.name + '" datatype="0">'
								 + '<span class="text-label" title="' + data.data[i].dataSources.name + '">' + data.data[i].dataSources.name + '</span>'
								 + '<span class="text-remove" title="删除" prop_field="' + data.data[i].dataSources.id + '" name="' + data.data[i].dataSources.name + '" datatype="0" style="display: none;">x</span>'
								 + '</div>');
							_self._datasources.push(data.data[i].dataSources);
						}
						// 展开刚刚获取的数据源 模拟点击该数据源标签
						// 如果选择了多条数据源，则展开最后一条
						$("div[prop_field='" + data.data[data.data.length - 1].dataSources.id + "']").find("span[class^='text-label']").click();
						_self._isAddNew = false;
						_self._isAddNew_Save = true;
					}
				});
				// 清理F7控件内的值
				//$("#prop_reportds").shrSelect("setValue", null);
				//$("#report_select").shrSelect("setValue", "");
			}
		});
	},

	initOutPutModel : function () {
		var _self = this;
		var html = "<input type='radio' name='outputMode'  id='detail'  value='detail' checked='checked' style='margin-bottom: 5px;' />输出明细 " +
			"<input type='radio' name='outputMode' id='groupcount'  value='groupcount' checked='checked' style='margin-bottom: 5px;'  />分组计算 " +
			"<input type='radio' name='outputMode' id='groupsum'  value='groupsum' checked='checked' style='margin-bottom: 5px;'  />分组求和 " +
			"<input type='radio' name='outputMode' id='groupavg'  value='groupavg' checked='checked' style='margin-bottom: 5px;' />分组求平均 ";
		$("#div_mid_outputmode").empty();
		$("#div_mid_outputmode").append(html);
		$("#detail").bind("click", function () {
			$("#gridTable").hideCol("groupParame");
			$("#gridTable").hideCol("sumParame");
			$("#gridTable").hideCol("avgParame");
			_self.handlerSettingListener();
			_self.handlerOrderSettingListener();
			_self.resizeTable();
		});
		$("#groupcount").bind("click", function () {
			$("#gridTable").hideCol("groupParame");
			$("#gridTable").hideCol("sumParame");
			$("#gridTable").hideCol("avgParame");
			_self.handlerSettingListener();
			_self.handlerOrderSettingListener();
			_self.resizeTable();
		});
		$("#groupsum").bind("click", function () {
			$("#gridTable").showCol("groupParame");
			$("#gridTable").showCol("sumParame");
			$("#gridTable").hideCol("avgParame");
			_self.handlerSettingListener();
			_self.handlerOrderSettingListener();
			_self.resizeTable();
		});
		$("#groupavg").bind("click", function () {
			$("#gridTable").showCol("groupParame");
			$("#gridTable").hideCol("sumParame");
			$("#gridTable").showCol("avgParame");
			_self.handlerSettingListener();
			_self.handlerOrderSettingListener();
			_self.resizeTable();
		});
	},

	initOutPutTable : function () {
		var _self = this;
		$("#toobar").empty();
		$("#toobar").append('<div id="removeparam" class="ui-jqgrid-sortable" style="text-align:right;cursor: pointer;margin-right: 50px;">删除字段</div>');
		$("#removeparam").die().live("click", function (e) {
			var selectedId = $("#gridTable").jqGrid("getGridParam", "selarrrow");
			if (selectedId.length == 0) {
				　　shr.showError({
						message : "请选择一条记录",
						hideAfter : 3
					});
				　　return false;
			} else {
				var len = selectedId.length;
				for (var i = 0; i < len; i++) {
					$("#gridTable").jqGrid("delRowData", selectedId[0]);
				}
			}
		});
		function handlerFieldFormat(v, x, r) {
			if (v == undefined || v == null || "undefined" == v || v == "") {
				return '<a id="settingParame' + x.rowId + '" class="settingParam_set" href="javascript:void(0);" value="" >维护分段</>';
			} else {
				return '<a id="settingParame' + x.rowId + '" class="settingParam_set" href="javascript:void(0);" value="' + v + '" style="color: #0088cc;">维护分段</>';
			}
		};

		function orderSetting(v, x, r) {
			return '<i title="向上" id="up_' + x.rowId + '" class="icon-arrow-up up-down"></i> <i  title="向下" id="down_' + x.rowId + '" class="icon-arrow-down up-down"></i>';
		}

		$("#div_mid_outputparam").append('<table id="gridTable"></table>');
		var myColName = ['id', '编码', '输出字段', '字段别名', '字段类型', '分组字段', '求和字段', '求平均字段', '维护分段','时间类型','排序'];
		var myColModel = [{
				name : 'id',
				index : 1,
				width : 60,
				sorttype : "int",
				align : 'center',
				hidden : true
			}, {
				name : 'outNumber',
				index : 2,
				width : 60,
				sortable: false,
				sorttype : "date"
			}, {
				name : 'outParame',
				index : 3,
				width : 100,
				sortable: false,
				sorttype : "date"
			}, {
				name : 'outParameDes',
				index : 4,
				width : 100,
				sortable: false,
				editable : true,
				unformat : function (cellvalue, options, cell) {
					var returnValue = cellvalue;
					if (cell.children[0] != undefined) {
						returnValue = cell.children[0].value;
					}
					return returnValue;
				}
			}, {
				name : 'paramType',
				index : 5,
				width : 100,
				editable : true,
				sortable: false,
				hidden : true
			}, {
				name : 'groupParame',
				index : 6,
				width : 80,
				align : 'center',
				editable : false,
				sortable: false,
				edittype : "checkbox",
				formatter : function (v, x, r) {
					if (v) {
						return "<input id='groupcheck_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' checked='check'/>";
					} else {
						return "<input id='groupcheck_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' />";
					}
				},
				unformat : function (cellvalue, options, cell) {
					cellValue = cell.children[0].checked;
					return cellValue;
				}
			}, {
				name : 'sumParame',
				index : 7,
				width : 60,
				align : 'center',
				editable : false,
				sortable: false,
				edittype : "checkbox",
				formatter : function (v, x, r) {
					if (v) {
						return "<input id='sumcheck_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' checked='check'/>";
					} else {
						return "<input id='sumcheck_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' />";
					}
				},
				unformat : function (cellvalue, options, cell) {
					cellValue = cell.children[0].checked;
					return cellValue;
				}
			}, {
				name : 'avgParame',
				index : 8,
				width : 60,
				align : 'center',
				editable : false,
				sortable: false,
				edittype : "checkbox",
				formatter : function (v, x, r) {
					if (v) {
						return "<input id='avgcheck_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' checked='check'/>";
					} else {
						return "<input id='avgcheck_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' />";
					}
				},
				unformat : function (cellvalue, options, cell) {
					cellValue = cell.children[0].checked;
					return cellValue;
				}
			}, {
				name : 'settingParame',
				index : 10,
				width : 80,
				align : "left",
				sortable: false,
				sorttype : "float",
				formatter : handlerFieldFormat,
				unformat : function (cellvalue, options, cell) {
					cellValue = $(cell.children[0]).attr("value");
					return cellValue;
				}
			},{ // 时间类型 
				name : 'timeType',
				index : 9,
				width : 80,
				align : "left",
				sortable : false,
				editable : false,
				formatter : function (v, x, r) {
					if (v) {
						return "<input id='timeType_" + r.outNumber + "' type='checkbox' class='outputcheck' fieldnane='" + r.outNumber + "' checked='check'/>";
					} else {
						if(r.paramType == 'Date' || r.paramType == 'TimeStamp'){
							return '<select style="width: 100%;" name="D1" id=timeType_'+r.outNumber+'> <option id="a1" value="date"  selected="selected">日期</option> <option id="a2" value="time" >时间</option><option id="a3" value="all">日期+时间</option> </select>';
						}else{
							return '<label style="width: 100%;">不可设置</label>';
						}
					}
				}
			}, {
				name : 'order',
				index : 11,
				width : 80,
				align : "left",
				sortable : false,
				editable : false,
				formatter : orderSetting,
			}
		];
		$("#gridTable").empty();
		$("#gridTable").jqGrid({
			datatype : "local",
			height : 400,
			width : 700,
			cellEdit : true,
			cellsubmit : 'clientArray',
			afterInsertRow : function (rowid, rowdat, name) {
				if (rowdat.outNumber == undefined) {
					$("#gridTable").jqGrid("delRowData", rowid);
				}
			},
			colNames : myColName,
			colModel : myColModel,
			//rownumbers : true,
			multiselect : true,
			autowidth : true,
			shrinkToFit : false,
			//caption: "输出字段列表",
			//onCellSelect : function (rowid, index, contents, event) {},
		});
		this.handlerOrderSettingListener();
	},

	//初始化树
	initalTree : function (param) {
		var _self = this;
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=getConfigSch",
			data : {
				uipk : "com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form"
			},
			success : function (data) {
				var schemesel = [];
				if (data.length == undefined || data.length < 1) {
					shr.showInfo({
						message : "您没有任何信息集的查看权限，请联系管理员分配权限！否则无法使用数据源功能！",
						hideAfter : 10
					});
					// 隐藏数据源功能区域
					$("#div_datasources").hide();
					return;
				}
				for (var i = 0; i < data.length; i++) {
					//为了处理ie11下001,002。。会变成1,2的问题，特意加了S
					schemesel[i] = {
						'value' : 'S' + data[i].number,
						'alias' : data[i].name
					}
				}
				var select_json = {
					id : "selectDatas",
					readonly : "",
					value : "",
					onChange : null,
					validate : "",
					filter : ""
				};
				select_json.data = schemesel;
				select_json.validate = "{required:true}";
				$('#selectDatas').shrSelect(select_json);
				$('#selectDatas').shrSelect("setValue", 'S001');
				$('#selectDatas').change(function () {
					_self.selectNumber = $('#selectDatas_el').val();
					if (_self.selectNumber.replace("S", "") == _self._currentData.selectDatas || $('#selectDatas_el').val() == _self._currentData.selectDatas || $('#selectDatas_el').val() == ""
						 || $('#selectDatas_el').val() == undefined || $('#selectDatas_el').val() == null) {
						_self.loadTree($('#selectDatas_el').val().replace("S", ""));
						return;
					}

					$("#gridTable").jqGrid("clearGridData");
					$(".filter_block:last").find(".filter_field").empty();
					$('#mainTable').find("[class=report_param]").each(function () {
						$(this).parent().parent().remove();
					});
					
					if(_self._currentData.selectDatas != _self.selectNumber.replace("S", "")){
						_self._currentData.other_option = [];
					}
					// 设置其他选项
					_self.setOther_option();
					_self._currentData.dataparams = [];
					_self._currentData.field_list = [];
					_self._currentData.filterItems = "[]";
					_self._currentData.other_option = [];
					_self._currentData.ontherfilter=[];
					_self._currentDataParaMapping = [];
					_self.deleteAllBaseInfo();

					_self.loadTree($('#selectDatas_el').val().replace("S", ""));
					_self._currentData.selectDatas = $('#selectDatas_el').val().replace("S", "");
					_self._currentData.selectDatasName = $('#selectDatas').val();
					_self.selectNumber = $('#selectDatas_el').val();
					_self.initalFilterParam();
					//_self._currentData.dataparams = [];
					_self.filterParamUtil.getontherfilter(_self._currentData);
					_self.loadMapping();
				});
			}
		});
	},
	reloadTree : function (selectScheme) {
		if (selectScheme != undefined) {
			var schemesel = $('#selectDatas').shrSelect("getData");
			for (var i = 0; i < schemesel.length; i++) {
				if (schemesel[i].value.replace("S", "") == selectScheme) {
					this.loadTree(selectScheme);
				}
			}
		}
	},
	//加载树
	loadTree : function (schemeNum) {
		var _self = this;
		$("#field_tree").empty();
		var tree = $('<ul id="datas_Ztree" class="ui-promptTree-tree ztree" style="height: 455px;background: white;"></ul>').appendTo($("#field_tree")),
		settings = {
			async : {
				enable : true,
				url : shr.getContextPath() + "/shr/msf/service.do?method=callService&serviceName=getQueryZTreeNodes",
				autoParam : ['id'],
				otherParam : {
					"scheme" : schemeNum
				}
			},
			otherParam : {
				"parentKey" : "parent"
			},
			callback : {
				onClick : function (event, treeId, treeNode, clickFlag) {
					if (treeNode.isLeaf) {
						var hasName = false;
						$("#gridTable").find("[tabindex='-1']").each(function (index) {
							var rowID = $(this).attr("id");
							if (treeNode.field == rowID) {
								hasName = true;
							}
						});
						if (!hasName) {
							var row = {};
							row.prop_field = treeNode.field;
							row.text = treeNode.name;
							row.columnsql = "";
							row.field_type = treeNode.dataType;
							row.isavg = false;
							row.isgroup = false;
							row.issum = false;
							row.outParameDes = treeNode.name;
							_self.addRow($("#gridTable").jqGrid("getRowData").length, row);
							if ($('#selectDatas_el').val() == 'S001') {
								_self.loadOtherOption(treeNode.field);
							} else if ($('#selectDatas_el').val() == 'S002') {
								_self.loadOtherOption(treeNode.field);
							}
						}
					} else {
						return false;
					}
				}
			}
		};
		$.fn.zTree.init(tree, settings);
	},

	handlerSettingListener : function () {
		var settings = $("#gridTable").find(".settingParam_set");
		for (var i = 0; i < settings.length; i++) {
			settings[i].onclick = function () {
				var _setting = this;
				$("#option").empty();
				$("#content").empty();
				$("#content").append('<textarea id="fieldSetting" type="text" name="fieldSetting" style="width: 97%;height: 230px;display: block;font-size: 14px !important;font-family: Microsoft YaHei, Tahoma, Helvetica, Arial, "宋体b8b\4f53", sans-serif !important;font-weight: bold;"/>');
				if ($(_setting).attr("value") != undefined && $(_setting).attr("value") != null && "undefined" != $(_setting).attr("value")) {
					$('#fieldSetting').val($(_setting).attr("value"));
				} else {
					$('#fieldSetting').val("");
				}
				$('#dialog').dialog({
					title : '维护分段',
					width : 840,
					height : 400,
					resizable : false,
					buttons : {
						'确定' : function () {
							if($('#fieldSetting').val() == null || $('#fieldSetting').val() == undefined || $('#fieldSetting').val() == ""){
								_setting.style.color = "";
							}else{
								_setting.style.color = "#0088cc";
							}
							$(_setting).attr("value", $('#fieldSetting').val());
							$(this).dialog('close');
						}
					},
					close : function (event, ui) {
						$(this).dialog('destroy');
						$('#dialog').hide();
					}
				});
				$("#ui-id-1").parent().css("border-bottom", "0");
				var buttonpane = $('#dialog').parent().find(".ui-dialog-buttonpane");
				//if(buttonpane.find(".plugView").length == 0){
				buttonpane.append('<div class="plugView" style="margin-top: 12px;margin-left: 150px;">如有疑问，请点击 '+
				'<a onclick="_self.reportDtas.openPlugView()" style="display:inline-block;color:#428bca;font-weight: bold;cursor:pointer;text-decoration:underline;">维护分段说明</a>，学习一下吧。</div>');
				//}
			}
		}
		var checkBoxs = $("#gridTable").find(".outputcheck");
		for (var i = 0;i< checkBoxs.length ; i++) {
			checkBoxs[i].onchange = function (e) {
				var fieldName = $(this).attr("fieldnane");
				if (fieldName == undefined)
					return;
				var checkid = $(this).attr("id");
				var paramType = $("#gridTable").getRowData(fieldName).paramType;
				if (checkid.indexOf("groupcheck_") == 0) {
					if (this.checked) {
						$(document.getElementById("sumcheck_" + fieldName)).attr("checked", false);
						$(document.getElementById("avgcheck_" + fieldName)).attr("checked", false);
					}
				} else if (checkid.indexOf("sumcheck_") == 0) {
					if (paramType != "Integer" && paramType != "Float"
						&& paramType != "BigDecimal" && paramType != "Double"
						&& paramType != "Int"){
							$(this).attr("checked", false);
							return;
						}
					if (this.checked) {
						$(document.getElementById("groupcheck_" + fieldName)).attr("checked", false);
						$(document.getElementById("avgcheck_" + fieldName)).attr("checked", false);
					}

				} else if (checkid.indexOf("avgcheck_") == 0) {
					if (paramType != "Integer" && paramType != "Float"
						&& paramType != "BigDecimal" && paramType != "Double"
						&& paramType != "Int"){
							$(this).attr("checked", false);
							return;
						}
					if (this.checked) {
						$(document.getElementById("groupcheck_" + fieldName)).attr("checked", false);
						$(document.getElementById("sumcheck_" + fieldName)).attr("checked", false);
					}
				}
			}
		}
	},

	openPlugView : function(){
		window.open(shr.getContextPath() + "/addon/report/web/resource/plugView.html");
	},
	
	handlerOrderSettingListener : function () {
		var ups = $("#gridTable").find("i[id^='up_']");
		var downs = $("#gridTable").find("i[id^='down_']");
		for (var i = 0; i < ups.length; i++) {
			// ie9浏览器，对title为""的tips也会显示，这里将td的title手动设为"排序"。
			$(ups[i]).parent().attr("title","排序");
			ups[i].onclick = function () {
				var insert = $(this).parent().parent();
				if ($("#gridTable").find('tr')[1] == this.parentElement.parentElement) {
					return;
				}
				var tr = insert.prev('tr');
				tr.before(insert);
			}
		}

		for (var i = 0; i < downs.length; i++) {
			downs[i].onclick = function () {
				var insert = $(this).parent().parent();
				var tr = insert.next('tr');
				tr.after(insert);
			}
		}
	},

	// 初始化附加信息
	initalOtherOption : function () {
		$("#div_right_option").empty();
		$("#div_right_option").append('<div class="other_item"><input id="isncount" type="checkbox"/><span>' + '仅显示占人头' + '</span></div>');
		$("#isncount").shrCheckbox();
		$("#isncount").shrCheckbox("check");
		$("#isncount").parent().css("float", "left");
		$("#isncount").parent().css("margin-right", "5px");
		$("#div_right_option").append('<div class="other_item"><input id="isOnthestrength" type="checkbox"/><span>' + '仅显示占编制' + '</span></div>');
		$("#isOnthestrength").shrCheckbox();
		$("#isOnthestrength").shrCheckbox("check");
		$("#isOnthestrength").parent().css("float", "left");
		$("#isOnthestrength").parent().css("margin-right", "5px");

	},

	initDataSourceSection : function () {
		var _self = this;
		$(".div_datasources_list").find(".text-remove").die().live("click", function (e) {
			if ($(this).attr("remove") == "false" || $(this).attr("remove") == false) {
				return;
			}
			if(_self.IsEdit == "false" || _self.IsEdit == false){
				shr.showError({
					message : "非创建者，不可删除！",
					hideAfter : 3
				});
				return;
			}
			var select = $(this);
			shr.showConfirm('您确认要删除吗？', function () {
				top.Messenger().hideAll();
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=removeDataSource",
					data : {
						uipk : "com.kingdee.shr.report.app.ReportDef.form",
						dsType : select.attr("datatype"),
						dataSourceID : select.attr("prop_field"),
						reportID : _self.reportId
					},
					success : function (data) {
						if (data.result != undefined && data.result == "success") {
							select.parent().remove();
							_self.removeDataFrom_datasources(select.parent().attr("prop_field"));
							$("#div_datasetting").hide()
							shr.showInfo({
								message : "删除成功",
								hideAfter : 2
							});
						}
					}
				});
			});
		});
		$(".div_datasources_list .text-tag").die().live("mouseenter", function (e) {
			$(this).find(".text-remove").show();
		}).live("mouseleave", function (e) {
			$(this).find(".text-remove").hide();
		});
		// 处理点击数据源标签事件
		$(".div_datasources_list").find(".text-label").die().live("click", function () {
			_self.loadDatasource(this);
			_self.handlerOrderSettingListener(); // 输出列表排序按钮添加事件
			_self._isAddNew_Save = true;
			if(_self.IsEdit == "true" ){
				_self.customSql_Shield(); // 根据是否为自定义sql数据源 ，屏蔽相应的区域
			}
			// 判断是否为扩展数据源  扩展数据源 不可更改数据源名字
			if(_self._currentData.selectDatas == undefined){
				$("#datasourceName").attr("disabled",true);
			}else{
				$("#datasourceName").attr("disabled",false);
			}
			//根据是否具有编辑权限，手动对遮罩层的Css进行一个调整（Css）
			if(_self.IsEdit == false || _self.IsEdit == "false" || _self._currentData.customsql){
			   $("#filter_param_detailedinfo_hide").height($("#filter_param_detailedinfo_hide").parents().height());
			}
			if ($.block) {
				$.block.hide();
			}
		});
	},

	initMappingTable : function () {
		$('#param').append('<table id="mainTable"></table>');
		var myColName = ['id', '数据源参数名称', '对应报表参数名称'];
		var myColModel = [{
				name : 'id',
				index : 'id',
				width : 60,
				sorttype : "int",
				hidden : true
			}, {
				name : 'reportParamType',
				index : 'reportParamType',
				sortable: false,
				width : 200,
				formatter : function (v, x, r) {
					if (v) {
						return '<input id="data_parame_name_' + v + '" class="report_param" type="text" name="data_parame_name_' + v + '"  value="' + v + '" style="width:91%;"></input>';
					} else {
						return '<input id="data_parame_name_' + v + '" class="report_param" type="text" name="data_parame_name_' + v + '"  value="" style="width:91%;"></input>';
					}
				}
			}, {
				name : 'reportParamName',
				index : 'reportParamName',
				width : 300,
				align : 'center',
				editable : true,
				edittype : "select",
				sortable: false,
				formatter : function (v, x, r) {
					if (v) {
						return '<input id="report_parame_name_' + v + '" class="report_param" type="text" name="report_parame_name_' + v + '"  value="' + v + '" style="width:91%;"></input>';
					} else {
						return '<input id="report_parame_name_' + v + '" class="report_param" type="text" name="report_parame_name_' + v + '"  value="" style="width:91%;"></input>';
					}
				},
				unformat : function (cellvalue, options, cell) {
					cellValue = $($(cell[0]).find(".report_param")[0]).shrSelect("getValue").value;
					return cellValue;
				}
			}
		];
		$("#mainTable").empty();
		$("#mainTable").jqGrid({
			datatype : "local",
			height : "auto",
			width : 600,
			cellEdit : true,
			colNames : myColName,
			colModel : myColModel,
			rownumbers : true,
			//multiselect : true,
			//caption: "输出字段列表",
			onCellSelect : function (rowid, index, contents, event) {},
		});
	},

	resizeTable : function () {
		if($(".div_mid").length > 0){
			var newWidth = $(".view_manager_body").width() - 410;
			$(".div_mid").width(newWidth);
			$("#gridTable").setGridWidth(newWidth);
			$("#div_mid_outputparam").find("#gbox_gridTable")[0].style.width = (newWidth - 2) + "px";
			$("#div_mid_outputparam").find("#gview_gridTable")[0].style.width = (newWidth - 2) + "px";
			$("#div_mid_outputparam").find(".ui-jqgrid-hdiv")[0].style.width = (newWidth - 2) + "px";
			$("#div_mid_outputparam").find(".ui-jqgrid-htable")[0].style.width = (newWidth - 15) + "px";
			$("#div_mid_outputparam").find(".ui-jqgrid-bdiv")[0].style.width = (newWidth - 2) + "px";
			$("#div_mid_outputparam").find(".ui-jqgrid-btable")[0].style.width = (newWidth - 15) + "px";
			$("#div_mid_outputparam").find(".jqgfirstrow")[0].style.width = (newWidth - 15) + "px";
		}
	},

	loadDatasource : function (dscomponent) {
		this._isAddNew = false;
		if ($("#div_datasetting").is(":hidden")) {
			$("#div_datasetting").show();
		}
		if (!$(dscomponent).parent().hasClass("template_pressed")) {
			$(".div_datasources_list .text-tag").removeClass("template_pressed");
			$(".div_datasources_list .text-label").removeClass("text_label_pressed");
			$(dscomponent).parent().addClass("template_pressed");
			$(dscomponent).parent().find(".text-label").addClass("text_label_pressed");
		}
		$("#datasourceName").val($(dscomponent).parent().find(".text_label_pressed").html()); // 获取数据源名称	datatype
		var datatype = $(dscomponent).parent().attr("datatype");
		var datasourceID = $(dscomponent).parent().attr("prop_field");
		// 扩展数据源-只显示参数映射区域内容
		if (datatype == "0") { // 扩展数据源
			$("#div_outfield").hide();
			$("#div_filterparam").hide();
			$("button[name='editsql']").hide();
			$("button[name='preview']").hide();
			this._currentData = this.findDatasource(datasourceID, datatype);
			// 获取扩展数据源的参数信息
			this.getDatasourceParam();
			this.getParamMapping(this.reportId, this._currentData.id, datatype);
			// 加载映射区域的内容
			$('#mainTable').find("[class=report_param]").each(function () {
				$(this).parent().parent().remove();
			});
			for (var i = 0; i < this._currentData.dataparams.length; i++) {
				var record = {
					dataparams : this._currentData.dataparams[i]
				};
				this.loadRow(record);
			}
			// 加载数据映射区域信息
			this.loadMapping();
			// 加载参数映射区域的基本信息
			this.loadParamMappingBaseInfo();
			return;
		} else {
			$("#div_outfield").show();
			if($("#div_outfield_detailedinfo").is(":hidden")){
				$("#div_outfield_baseinfo").show();
			}else{
				$("#div_outfield_baseinfo").hide();
			}
			$("#div_filterparam").show();
			if($("#filter_param_detailedinfo").is(":hidden")){
				$("#filter_param_baseinfo").show();
			}else{
				$("#filter_param_baseinfo").hide();
			}
			$("#div_parammapping").show();
			if($("#div_parammapping_detailedinfo").is(":hidden")){
				$("#div_parammapping_baseinfo").show();
			}else{
				$("#div_parammapping_baseinfo").hide();
			}
			$("button[name='editsql']").show();
			$("button[name='preview']").show();
		}
		// 在页面加载数据源基本信息
		this._currentData = this.findDatasource(datasourceID, datatype);
		this.loadOutPutSectionData(this._currentData, datatype);
		this.getParamMapping(this.reportId, this._currentData.id, datatype);
		// 加载查询条件区域
		this.queryConditionUtil.loadQueryCondition(this._currentData);
		this.initalFilterParam();
		// 加载关系映射界面数据
		this.loadMapping();
		// 加载输出字段区域的基本信息
		this.loadOutputFieldBaseInfo();
		// 加载过滤区域的基本信息
		this.loadFilterBaseInfo();
		// 加载参数映射区域的基本信息
		this.loadParamMappingBaseInfo();
	},

	loadOutPutSectionData : function (datasource, datatype) {
		if (datatype == 10) { //人事数据源
			$('#selectDatas').shrSelect("setValue", 'S' + datasource.selectDatas);
			$("#gridTable").jqGrid("clearGridData");
			for (var i = 0; i < datasource.field_list.length; i++) {
				this.addRow(i, datasource.field_list[i]);
			}
			// 设置统计方式
			this.setGrouptype();
			// 设置其他选项
			this.setOther_option();
		}
	},

	findDatasource : function (datasourceID, datatype) {
		var datasource;
		//根据ID从_datasources集合中取到选中的数据源
		for (var i = 0; i < this._datasources.length; i++) {
			var data = this._datasources[i];
			if (datatype == 10) { //人事数据源
				if (data.id == datasourceID) {
					datasource = data;
					break;
				}
			} else { // 扩展数据源
				if (data.id == datasourceID) {
					datasource = data;
					break;
				}
			}
		}
		return datasource;
	},

	/*
	复制新增
	 */
	add_copyAction : function () {
		if((!(this._isAddNew_Save))&&(_self.reportDtas._currentData.id == undefined)){ //未保存
			var showMsg = "当前数据源没有保存，继续此操作数据将丢失，是否继续？";
			shr.showConfirm(showMsg, function () {
				_self.reportDtas._isAddNew_Save = true;
				_self.reportDtas._isAddNew = false;
				// 清楚页面数据
				$("#datasourceName").val("");
				$("#div_datasetting").hide();
				$(".div_datasources_list .text-tag").removeClass("template_pressed");
				$(".div_datasources_list .text-label").removeClass("text_label_pressed");
				$("#div_outfield_baseinfo").empty();
				_self.reportDtas.clearPageData();
				$("#div_outfield_detailedinfo").hide();
				$("#filter_param_detailedinfo").hide();
				$("#div_parammapping_detailedinfo").hide();
				
				$("#personal_select").find(".ui-promptBox-icon").click();
			});	
		}else{
			if(_self.reportDtas._currentData.id == undefined || $("#datasourceName").is(":hidden")){
				$("#personal_select").find(".ui-promptBox-icon").click();
				return true;
			}else{
				if(!(this.checkValue())){
					return;
				}
				$("#personal_select").find(".ui-promptBox-icon").click();
			}
		}
	},

	/*
	自定义新增
	 */
	addAction : function () {
		if((!(this._isAddNew_Save))&&(_self.reportDtas._currentData.id == undefined)){ //未保存
			var showMsg = "当前数据源没有保存，继续此操作数据将丢失，是否继续？";
			shr.showConfirm(showMsg, function () {
				_self.reportDtas._isAddNew_Save = true;
				_self.reportDtas._isAddNew = false;
			},function(){
				shr.msgHideAll();
				return ;
			});	
		}
		if(_self.reportDtas._currentData.id != undefined && !($("#datasourceName").is(":hidden"))){
			//  判断数据源映射是否正确完成
			if(!(this.checkValue())){
				return;
			}
		}
		
		this._currentData = {};
		this._currentData.field_list = [];
		this._currentData.filterItems = [];
		this._currentData.dataparams = [];
		this._currentData.ontherfilter = [];
		this._isAddNew = true;
		this._isAddNew_Save = false;
		this._currentData.customsql = false;
		this._currentData.querySql = "";
		this._currentData.other_option = [];
		this._currentData.outputColumn = [];
		if ($("#div_datasetting").is(":hidden")) {
			$("#div_datasetting").show();
		}
		$("#div_outfield").show();
		$("#div_filterparam").show();
		$("button[name='editsql']").show();
		$("button[name='preview']").show();

		// 清除所有区域的基本概要信息
		this.deleteAllBaseInfo();
		$("#datasourceName").val("");
		$("#datasourceName").attr("disabled",false);
		$(".div_datasources_list .text-tag").removeClass("template_pressed");
		$(".div_datasources_list .text-label").removeClass("text_label_pressed");
		$("#div_outfield_baseinfo").empty();
		this.clearPageData();
		var schemesel = $('#selectDatas').shrSelect("getData");
		$("#selectDatas").shrSelect("setValue", schemesel[0].value);
		this.filterParamUtil.getontherfilter(this._currentData);
		var datatype = 10;
		this.loadOutPutSectionData(this._currentData, datatype);
		// 加载查询条件区域
		this.queryConditionUtil.loadQueryCondition(this._currentData);
		// 加载关系映射界面数据
		this.loadMapping();

		shr.showInfo({
			message : "自定义新增",
			hideAfter : 3
		});
		$("#div_left_hide").hide();
		$("#div_mid_hide").hide();
		$("#div_right_hide").hide();
		$("#filter_param_detailedinfo_hide").hide();
		$("#div_parammapping_detailedinfo_hide").hide();
	},

	/*
	引用扩展数据源
	 */
	add_datasAction : function () {
		if((!(this._isAddNew_Save))&&(_self.reportDtas._currentData.id == undefined)){ //未保存
			var showMsg = "当前数据源没有保存，继续此操作数据将丢失，是否继续？";
			shr.showConfirm(showMsg, function () {
				_self.reportDtas._isAddNew_Save = true;
				_self.reportDtas._isAddNew = false;
				// 清楚页面数据
				$("#datasourceName").val("");
				$("#div_datasetting").hide();
				$(".div_datasources_list .text-tag").removeClass("template_pressed");
				$(".div_datasources_list .text-label").removeClass("text_label_pressed");
				$("#div_outfield_baseinfo").empty();
				_self.reportDtas.clearPageData();
				$("#div_outfield_detailedinfo").hide();
				$("#filter_param_detailedinfo").hide();
				$("#div_parammapping_detailedinfo").hide();
				
				$("#report_select").find(".ui-promptBox-icon").click();
			});
		}else{
			if(_self.reportDtas._currentData.id == undefined || $("#datasourceName").is(":hidden")){
				$("#report_select").find(".ui-promptBox-icon").click();
				return true;
			}else{
				if(!(this.checkValue())){
					return;
				}
				$("#report_select").find(".ui-promptBox-icon").click();
			}
		
			//  判断数据源映射是否正确完成
			
		}
	},

	/*
	新增映射关系
	 */
	addparamAction : function () {
		//var myDate = new Date();
		//_self.addMappingRow('param' + myDate.getTime());
		var record = {};
		record.dataparams = {};
		record.dataparams.paramname = "";
		record.dataparams.paramdesc = "";
		this.loadRow(record);
	},

	/*
	删除映射关系
	 */
	removeparamAction : function () {
		$('#mainTable').find(".cbox").each(function () {
			if ($(this)[0].checked == true) {
				$(this).parent().parent().remove();
			}
		});
	},

	/*
	编辑SQL
	 */
	editsqlAction : function () {

		if (this._currentData == null) {
			shr.showInfo({
				message : "请选择一个数据源",
				hideAfter : 3
			});
			return;
		}

		//生成SQL
		this.getSql('show', this._currentData);

	},

	/*
	数据预览
	 */
	previewAction : function () {
		if (this._isAddNew) { // 自定义数据源
			shr.showError({
				message : "请先保存，再进行预览！",
				hideAfter : 3
			});
			return;
		}
		
		if (!this._isAddNew_Save) { // 未保存数据源
			shr.showError({
				message : "请先保存，再进行预览！",
				hideAfter : 3
			});
			return;
		}
		
		if (this._currentData == null) {
			shr.showInfo({
				message : "请选择一个数据源",
				hideAfter : 3
			});
			return;
		}
		if(this._dataparams.length == 0 ){
		　shr.showError({
				message : "检查到您的参数配置存在异常，请校正后再执行本操作！",
				hideAfter : 3
			});
			return;
		}
		// 获取输出字段
		this._currentData.field_list = this.getfield_list();
		//数据预览
		this.preViewUtil.preView(this._currentData, this._dataparams,this._currentDataParaMapping);
	},

	/*
	保存数据源
	 */
	savedatasAction : function () {
		/* 检查数据非法性*/
		if (!this.checkValue()) {
			return;
		}
		if ($.block) {
			$.block.show({
				text : '正在保存数据源，请稍候...'
			});
		}
		
		this._currentData.grouptype = $("input[name='outputMode']:checked").val();
		if (this._isAddNew) { //自定义数据源
			// 获取查询条件
			this._currentData.filterItems = this.queryConditionUtil.getSearchItems(this._currentData);
			// 获取ontherfilter
			this._currentData.ontherfilter = this.filterParamUtil.getontherfilter(this._currentData);
			// 获取选择字段 和 输出字段
			this._currentData.field_list = this.getfield_list();
			// 获取其他选项
			this.getother_option();
			// 报表参数和数据源参数映射
			this.mappingParam();
			// 保存
			this.SaveData();

		} else { // 非自定义数据源
			if (this._currentData.name != $("#datasourceName").val()) {
				// 判断名称是否存在
				if (!this.IsExist($("#datasourceName").val(), this._currentData)) {
					$(".div_datasources_list").find(".text-label").each(function () {
						if ($(this).html() == _self.reportDtas._currentData.name) {
							$(this).html($("#datasourceName").val());
							$(this).attr("title",$("#datasourceName").val());
							return;
						}
					});
					this._currentData.name = $("#datasourceName").val();
				} else {
					shr.showError({
						message : '数据源名称不能重复',
						hideAfter : 3
					});
					if ($.block) {
						$.block.hide();
					}
					return;
				}
			}
			
			if(this._currentData.selectDatas !=null && this._currentData.selectDatas !=undefined){ // 人事数据源
				// 获取查询条件
				this._currentData.filterItems = JSON.stringify(this.queryConditionUtil.getSearchItems(this._currentData));
				// 获取ontherfilter
				this._currentData.ontherfilter = this.filterParamUtil.getontherfilter(this._currentData);
				// 获取输出字段
				this._currentData.field_list = this.getfield_list();
				// 获取其他选项
				this.getother_option();
			}
			// 报表参数和数据源参数映射
			this.mappingParam();
			// 更新数据
			this.updateSave();

			// 保存数据源参数和报表参数的映射关系
			this.saveParamMapping(this._currentDataParaMapping, this._currentData.id);
			
			// 替换页面缓存的数据源对象
			for (var i = 0; i < this._datasources.length; i++) {
				if (this._datasources[i].id == this._currentData.id) {
					// 替换
					this._datasources[i] = this._currentData;
					break;
				}
			}
		}
	},

	/*
	判断数据源名称是否存在
	 */
	IsExist : function (name, data) {
		var isexist = false;
		if (this._datasources == null) {
			return isexist;
		}
		for (var i = 0; i < this._datasources.length; i++) {
			if (name.trim() == this._datasources[i].name && data.id != this._datasources[i].id) {
				isexist = true;
				break;
			}
		}
		return isexist;
	},

	runEffect : function (divId) {
		var options = {};
		$(divId).toggle("blind", options, 500);
	},
	onNext : function (_wizard) {
		if(this.IsEdit == false || this.IsEdit == "false" || this.DataPermissionIsOk == false){
			return {
				status : 1
			};
		}
		
		if(!(this._isAddNew_Save)){ //未保存
			var wizard = _wizard;
			var showMsg = "当前数据源没有保存，离开此页面数据将丢失，确认离开此页面？";
			shr.showConfirm(showMsg, function () {
				_self.reportDtas._isAddNew_Save = true;
				_self.reportDtas._isAddNew = false;
				if(wizard._index == 4){
					$(".next").trigger("click"); 
				}else if(wizard._index == 2){
					$(".prev").trigger("click"); 
				}else if(wizard._index == 1){
					// 回到首页
					_self.reloadPage({
						//uipk : 'shr.report.ReportDefGuide',
						uipk : 'shr.report.ReportDefGuidev2.0',
						billId : _self.reportDtas.reportId
					});
				}
			});
			return {
				status : 0
			};
		}else{
			//  判断数据源映射是否正确完成
			if(!(this._isAddNew == false && this._isAddNew_Save == true) && (!(this.checkParamMapping()))){
				return {
					status : 0
				};
			}
			
			if(_wizard._index == 4){
				var wizard = _wizard;
				//  判断报表参数是否都已经被数据源参数映射
				var Msg = this.checkReportParmMapping();
				if( Msg != "" && this.IsReportParamOk == false){
					Msg = '检测到您的报表参数: ' + Msg + ' 未进行参数映射，是否继续下一步？';
					shr.showConfirm(Msg, function () {
						_self.reportDtas._isAddNew_Save = true;
						_self.reportDtas._isAddNew = false;
						_self.reportDtas.IsReportParamOk = true;
						if(wizard._index == 4){
							$(".next").trigger("click"); 
						}
					});
					
					return {
						status : 0
					};
				}	
			}
			
			_wizard.setParm("_datasources", this._datasources);
			return {
				status : 1
			};
		}
	},

	onNaviLoad : function (_navi) {
		this.reportId = _navi.getParm("reportId");
		this.adminOrg = _navi.getParm("adminOrg");
		this.reportParam = _navi.getParm("reportParam");
		this.IsEdit = _navi.getParm("IsEdit");
		this._isAddNew_Save = true;
		if (_navi.getParm("_datasources") != undefined && _navi.getParm("_datasources")!=0) {
			var _datasources = _navi.getParm("_datasources");
			this._datasources = _datasources;
			for (var i = 0; i < _datasources.length; i++) {
				if (_datasources[i].selectDatas != undefined) { // 人事数据源
					var datatype = 10;
				} else {
					var datatype = 0;
				}
				$(".div_datasources_list").append('<div class="text-tag" prop_field="' + _datasources[i].id + '" name="' + _datasources[i].name + '" datatype="' + datatype + '">'
					 + '<span class="text-label" title="' + _datasources[i].name + '">' + _datasources[i].name + '</span>'
					 + '<span class="text-remove" title="删除" prop_field="' + _datasources[i].id + '" name="' + _datasources[i].name + '" datatype="' + datatype + '" style="display: none;">x</span>'
					 + '</div>');
			}
			this.initDataSourceSection();
		} else {
			// 检查信息集权限
			if(!(this.CheckDataPermission(this.reportId))){
				// 隐藏div_datasources_bt区域的按钮	复制，扩展、自定义数据源新增
				$("#div_datasources_bt").hide();
				this.DataPermissionIsOk = false;
				return;
			}
			this._datasources = [];
			this.initDataSourceSection();
		}

		this._dataparams = jQuery.parseJSON(_navi.getParm("reportParam"));
		if (_navi.datasource == undefined || _navi.datasource == null) {}
		//_navi.report.datasource = [];
		
		//根据是否具有编辑权限，判断是否需要加上遮罩层
		if(this.IsEdit == false || this.IsEdit == "false"){
			$("#datasourceName").attr("disabled",true);
			$("button[name='editsql']").hide();
			$("button[name='savedatas']").hide();
			$("#div_left_hide").show();
			$("#div_mid_hide").show();
			$("#div_right_hide").show();
			$("#filter_param_detailedinfo_hide").show();
			$("#div_parammapping_detailedinfo_hide").show();
			$("#div_datasources_bt_hide").show();
		}else{
			$("#datasourceName").attr("disabled",false);
			$("button[name='editsql']").show();
			$("button[name='savedatas']").show();
			$("#div_left_hide").hide();
			$("#div_mid_hide").hide();
			$("#div_right_hide").hide();
			$("#filter_param_detailedinfo_hide").hide();
			$("#div_parammapping_detailedinfo_hide").hide();
			$("#div_datasources_bt_hide").hide();
		}
	},

	loadOtherOption : function (prop_field) {
		shr.callService({
			serviceName : "getStructureConfigMultiRowService",
			async : true,
			param : {
				scheme : $('#selectDatas_el').val().replace("S", ""),
				selectFields : prop_field
			},
			success : function (data) {
				if (data.length != 0) {
					for (var i in data) {
						if (data[i].moltiAlias != null && $("#" + data[i].clientNumber).length == 0) {
							$("#div_right_option").append('<div class="other_item"><input id="' + data[i].clientNumber + '" type="checkbox"/><span>' + data[i].moltiAlias + '</span></div>');
							$("#" + data[i].clientNumber).shrCheckbox();
							$("#" + data[i].clientNumber).shrCheckbox("check");
							$("#" + data[i].clientNumber).parent().css("float", "left");
							$("#" + data[i].clientNumber).parent().css("margin-right", "5px");
						}
					}
				}
			}
		});
	},
	// 初始化过滤及参数区域
	initalFilterParam : function () {
		this.filterParamUtil.loadDatasourceParam(this);
	},

	// 加载基本信息显示区域内容
	loadBaseInfo : function (datasourceID, datatype) {
		var datasource;
		//根据ID从_datasources集合中取到选中的数据源
		for (var i = 0; i < this._datasources.length; i++) {
			var data = this._datasources[i];
			if (datatype == 10) { //人事数据源
				if (data.id == datasourceID) {
					datasource = data;
					break;
				}
			} else { // 扩展数据源
				if (data.dataSources.id == datasourceID) {
					datasource = data;
					break;
				}
			}
		}
		// 在页面加载信息
		// 加载table表格
		//_self.createTable();
		if (datatype == 10) { //人事数据源
			for (var i = 0; i < datasource.field_list.length; i++) {
				this.addRow(i, datasource.field_list[i]);
			};
		}
		return datasource;
	},

	ondblClickRow : function (id) {
		var s = 1;
	},
	addMouseHandler : function () {
		//处理mouseover事件
		$("#grid").bind('mouseover',
			function (e) {
			var ptd = $(e.target),
			ptr = $(ptd).closest("tr.jqgrow"),
			rowspan = ptd.attr("rowspan") || 1;
			ptr.addClass("ui-state-hover");

		}).bind('mouseout',
			function (e) {
			var ptd = $(e.target),
			ptr = $(ptd).closest("tr.jqgrow"),
			rowspan = ptd.attr("rowspan") || 1;
			ptr.removeClass("ui-state-hover");

		}).bind("click", function (e) {
			var td = $(e.target),
			ptr = $(td).closest("tr.jqgrow"),
			rowspan = (parseInt(td.attr("rowspan"))) || 1;
			if ($("#jqg_grid_" + ptr.attr("id"))[0].checked) {
				ptr.addClass("ui-state-highlight");
				ptr.attr("aria-selected", "true");
			} else {
				ptr.attr("aria-selected", "false");
				ptr.removeClass("ui-state-highlight");
			}
		});
	},

	addRow : function (i, data) {
		var outParameDes = data.outParameDes;
		if (data.outParameDes == "" || data.outParameDes == undefined || data.outParameDes == null) {
			outParameDes = data.text;
		}
		var info = {
			id : i,
			outNumber : data.prop_field,
			outParame : data.text,
			outParameDes : outParameDes,
			settingParame : data.columnsql,
			paramType : data.field_type,
			avgParame : data.isavg,
			groupParame : data.isgroup,
			sumParame : data.issum,
			dateType : data.dateType
		};
		$("#gridTable").jqGrid('addRowData', data.prop_field, info);
		$("select[id='timeType_"+data.prop_field+"']").attr("value",data.dateType);
		if($("#gridTable").find(".jqgfirstrow")[0].style.width == "auto"){
			$("#gridTable").find(".jqgfirstrow")[0].style.width = $("#gridTable")[0].style.width;
		}else{
			$("#gridTable").find(".jqgfirstrow")[0].style.width = "auto";
		}
		this.handlerSettingListener();
		this.handlerOrderSettingListener();
		// 设值复选框实例  $("#gridTable").find('tr').eq(7).find('td').eq(4).find('input').attr('checked','checked')
	},

	// 获取SQL
	getSql : function (sqlpanel, model) {
		var resultSql;
		var _self = this;
		model.field_list = _self.getfield_list();
		if (_self._currentData.customsql || _self._currentData.customsql == "true") {
			if (sqlpanel == "show") {
				// 初始化编辑sql对话框
				_self.initalSqlDialog(_self._currentData.querySql);
				$('#dialog').dialog({
					title : 'Sql查询',
					width : 840,
					height : 600,
					resizable : false,
					buttons : {
						'确定' : function () {
							if ($("#is_customsql")[0].checked) {
								_self._currentData.customsql = $("#is_customsql")[0].checked;
								_self._currentData.querySql = $('#query_sql').val();
							}
							$(this).dialog('close');
						}
					},
					close : function (event, ui) {
						$(this).dialog('destroy');
						$('#dialog').hide();
					}
				});
			}
		} else {
			shr.remoteCall({
				uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
				method : 'getSql',
				param : {
					col_field : JSON.stringify(model.field_list),
					searchFilter : model.filterItems,
					selectDatas : model.selectDatas,
					ontherfilter : JSON.stringify(model.ontherfilter),
					otheroption : JSON.stringify(model.other_option),
					grouptype : $("input[name='outputMode']:checked").val()
				},
				success : function (data) {
					_self._currentData.querySql = data.sql;
					if (sqlpanel == "show") {
						// 初始化编辑sql对话框
						_self.initalSqlDialog(data.sql);
						$('#dialog').dialog({
							title : 'Sql查询',
							width : 840,
							height : 600,
							resizable : false,
							buttons : {
								'确定' : function () {
									if ($("#is_customsql")[0].checked) {
										_self._currentData.customsql = $("#is_customsql")[0].checked;
										_self._currentData.querySql = $('#query_sql').val();
									}
									$(this).dialog('close');
								}
							},
							close : function (event, ui) {
								$(this).dialog('destroy');
								$('#dialog').hide();
							}
						});
					}
				}
			});
		}
	},
	// 初始化编辑sql对话框
	initalSqlDialog : function (data) {
		var _self = this;
		$("#option").empty();
		$("#option").append('<div><div style="display: inline-block;">自定义sql</div>' +
			'<input role="checkbox" style="margin-bottom: 5px;margin-left: 5px;margin-right: 10px;" type="checkbox" id="is_customsql" class="cbox" name="is_customsql">');
		$("#content").empty();
		$("#content").append('<textarea id="query_sql" type="text" name="query_sql" style="width: 97%;height: 400px;display: block;font-size: 14px !important;font-family: Microsoft YaHei, Tahoma, Helvetica, Arial, "宋体b8b\4f53", sans-serif !important;font-weight: bold;"/>');
		$('#query_sql').val(data);
		if (_self._currentData.customsql) {
			$('#query_sql')[0].disabled = false;
			$("#is_customsql").attr("checked", true);
		} else {
			$('#query_sql')[0].disabled = true;
			$("#is_customsql").attr("checked", false);
		}
		
		if(this.IsEdit == "false") {
			$("#is_customsql").attr("disabled",true);
		} else {
			$("#is_customsql").attr("disabled",false);
		}
		
		$("#is_customsql").change(function () {
			if ($(this)[0].checked == true) {
				$('#query_sql')[0].disabled = false;
				_self._currentData.customsql = true;
			} else {
				$('#query_sql')[0].disabled = true;
				_self._currentData.customsql = false;
			}
			// 自定义sql时界面的处理(屏蔽相应的区域不可操作)
			_self.customSql_Shield();
		});
		
	},

	/*
	重新加载映射关系界面
	 */
	loadMapping : function () {
		$('#mainTable').find("[class=report_param]").each(function () {
			$(this).parent().parent().remove();
		});
		if (this._isAddNew) {
			for (var i = 0; i < this._currentData.dataparams.length; i++) {
				var record = {
					dataparams : this._currentData.dataparams[i]
				};
				this.loadRow(record);
			}
			return;
		} else {
			if (this._currentData == undefined || this._currentData == null || this._currentData.dataparams == undefined || this._currentData.dataparams == null) {
				return;
			}
			var params = "";
			if (this._currentDataParaMapping.param != undefined && this._currentDataParaMapping.param != "") {
				if (typeof this._currentDataParaMapping.param == 'string') {
					params = jQuery.parseJSON(this._currentDataParaMapping.param);
				} else {
					params = this._currentDataParaMapping.param;
				}
			}

			for (var j = 0; j < this._currentData.dataparams.length; j++) {
				var record = {
					dataparams : this._currentData.dataparams[j]
				};
				if (params != "") {
					for (var i = 0; i < params.length; i++) {
						if (params[i].dataparameName == this._currentData.dataparams[j].paramname.replace(".", "_")) {
							record.reportparams = params[i];
						}
					}
				}
				this.loadRow(record);
			}
			//for(var i = 0;i<_currentData.dataparams.length;i++){
			//	_self.loadRow(_currentData.dataparams[i]);
			//}
		}
	},

	loadRow : function (record) {
		var myDate = new Date();
		var fieldName = 'param' + myDate.getTime();
		var info = {
			id : record.dataparams.paramname,
			reportParamType : fieldName,
			reportParamName : fieldName
		};
		$("#mainTable").jqGrid('addRowData', fieldName, info);
		var jsonstr = "[]";
		var jsonarray = eval('(' + jsonstr + ')');
		if(this._dataparams != null){
			for (var i = 0; i < this._dataparams.length; i++) {
				var arr = {
					"value" : this._dataparams[i].param_value,
					"alias" : this._dataparams[i].param_name,
					"component" : this._dataparams[i].prop_component
				}
				jsonarray.push(arr);
			}
			var report_paramname_date_json = {
				id : "report_parame_name_" + fieldName
			};
			report_paramname_date_json.data = jsonarray;
		}
		
		$("#data_parame_name_" + fieldName).attr("paramname", record.dataparams.paramname);
		$("#data_parame_name_" + fieldName).attr("value", record.dataparams.paramdesc);
		$("#data_parame_name_" + fieldName).attr("component", record.dataparams.paramcomp);
		$("#report_parame_name_" + fieldName).attr("value", "");
		$("#report_parame_name_" + fieldName).shrSelect(report_paramname_date_json);
		if (record.reportparams && record.reportparams.reportparam) {
			$("#report_parame_name_" + fieldName).shrSelect("setValue", record.reportparams.reportparam.param_value);
			$("#report_parame_name_" + fieldName).attr("component",record.reportparams.reportparam.prop_component);
		} else {
			$("#report_parame_name_" + fieldName).shrSelect("setValue", "");
		}
		$("#report_parame_name_" + fieldName).removeClass("phone-input");

	},

	getSearchItems : function () {
		var searchResultAll = [];
		var dataparams = [];
		var paramIndex = 0;

		if (!this._isAddNew && (this._currentData.customsql == true || this._currentData.customsql == "true")) {
			return {
				status : 1
			};
		}
		$(".filter_block").each(function (index) {
			var searchResult = [];
			$(this).find(".filter_field .text-tag").each(function (index) {
				var prop_field = $(this).attr("prop_field_query");
				var prop_op = $(this).attr("prop_op");
				var prop_value = $(this).attr("prop_value");
				var prompt_value = "";
				var field_type = $(this).attr("field_type");
				var prop_text = $(this).find(".text-label").html();
				var fieldValue = $(this).data("fieldValue");
				var uipk = fieldValue.uipk;
				if (uipk != undefined && uipk != "" && uipk != "null" && uipk != "undefined" && $(this).data("prompt_value") != null) {
					prompt_value = $(this).data("prompt_value");
				}

				var fileType = "0";
				var comp = "0";
				var parampk = "";
				if (field_type != undefined && field_type == "String") {
					fileType = "0";
				} else if (field_type == "TimeStamp" || field_type == "Date") {
					fileType = "2";
					comp = "2";
				} else if (field_type == "IntEnum") {
					fileType = "1";
					comp = "1";
				} else if (field_type == "Short" || field_type == "Double" || field_type == "BigDecimal" || field_type == "Integer" || field_type == "Long" || field_type == "Float" || field_type == "Int") {
					fileType = "1";
					comp = "0";
				} else if (field_type == "StringEnum") {
					fileType = "0";
					comp = "1";
				} else if (field_type == "Boolean") {
					fileType = "3";
					comp = "1";
				}
				if (uipk != undefined && uipk != null && uipk != "") {
					comp = "4";
					parampk = uipk + ";" + prop_field.substring(prop_field.lastIndexOf('.') + 1);
				}
				if (fieldValue.enumSource != undefined && fieldValue.enumSource != null && fieldValue.enumSource != "") {
					parampk = fieldValue.enumSource;
				}
				//if(prop_field.replace(".","_") == prop_value){
				if (prop_value == "" || prop_value == "null" || prop_value == null || prop_value == "@" + prop_field.replace(".", "_")) {
					prop_value = "@" + prop_field.replace(".", "_");
					dataparams[paramIndex] = {
						paramname : prop_field.replace(".", "_"),
						paramdesc : fieldValue.name,
						paramtype : fileType,
						paramcomp : comp,
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : parampk
					};
					paramIndex++;
				}

				searchResult[index] = {
					prop_field : prop_field,
					prop_text : prop_text,
					prop_op : prop_op,
					prop_value : prop_value,
					prompt_value : prompt_value,
					field_type : field_type,
					fieldValue : fieldValue
				}
			});
			searchResultAll.push(searchResult);
		});
		return searchResultAll;
	},

	_refresh : function () {
		var value = this.element.data(dataFlg),
		displayValue = value ? $.shrPromptBox.format(value, this.options.displayFormat, this.options.fieldSeparator) : null;
		this.element.attr("title", displayValue);
		if (this.options.customformatter != null && this.options.customparam != null) {
			displayValue = this.options.customformatter(displayValue, this.options.customparam);
		}
		this.element.val(displayValue);
		this.element.prev().val(value ? $.shrPromptBox.format(value, this.options.submitFormat, this.options.fieldSeparator) : null);
	},

	/*
	报表和数据源参数映射
	 */
	mappingParam : function () {
		var dataparams = [];
		var _self = this;
		_self._currentDataParaMapping = [];
		$('#mainTable').find(".jqgrow").each(function (index) {
			var rowID = $(this).attr("id");
			var value;
			var name;
			var reportparam;
			/*
			if($("#report_parame_name_"+rowID).attr("value") == undefined || $("#report_parame_name_"+rowID).attr("value") == ""){  //判断报表参数是否有值
			shr.showError({
			message : '报表参数不能为空',
			hideAfter : 3
			});
			return;
			}
			 */
			// 表里报表参数找到与之对应的
			for (var i = 0; i < _self._dataparams.length; i++) {
				if (_self._dataparams[i].param_value == $("#report_parame_name_" + rowID).shrSelect("getValue").value) {
					reportparam = _self._dataparams[i];
					break;
				}

			}
			if(reportparam != null && reportparam != undefined){
				value = reportparam.param_default_value;
				if ($("#data_parame_name_" + rowID).attr("paramname") == undefined) {
					name = $("#prop_field_" + rowID).attr("prop_field_query");
				} else {
					name = $("#data_parame_name_" + rowID).attr("paramname");
				}
				dataparams[index] = {
					paramname : name,
					paramdesc : $("#data_parame_name_" + rowID).attr("value"),
					paramtype : reportparam.prop_type,
					paramcomp : reportparam.prop_component,
					paramvalue : "",
					paramnull : reportparam.is_null,
					//paramstate : $("#prop_state_"+rowID+"_el").attr("value"),
					paramuipk : reportparam.uipk,
					paramins : reportparam.ins,
					reportparamtype : reportparam.paramtype
				}
				
				_self._currentDataParaMapping[index] = {
					dataparameName : name,
					dataparameDesc : $("#data_parame_name_" + rowID).attr("value"),
					reportparam : reportparam
				}
			}
			
			// 与filteItem项做匹配 手动添加的自定义参数需与filteItem项做匹配
			if (reportparam!=undefined && reportparam.paramtype == "1" && _self._currentData.filterItems){
				_self.mateFilterItem($("#prop_field_" + rowID), reportparam);
			}

		});

		this._currentData.dataparams = dataparams;

	},

	/*
	更新数据源
	 */
	updateSave : function () {
		if (this._currentData.dataparams == undefined) {
			this._currentData.dataparams = [{
					paramname : "adminOrg",
					paramdesc : "组织",
					paramtype : "0",
					paramcomp : "4",
					paramvalue : "",
					paramnull : true,
					paramstate : "0",
					paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
				}
			]
		} else {
			this._currentData.dataparams[this._currentData.dataparams.length] = {
				paramname : "adminOrg",
				paramdesc : "组织",
				paramtype : "0",
				paramcomp : "4",
				paramvalue : "",
				paramnull : true,
				paramstate : "0",
				paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
			}
		}

		shr.remoteCall({
			uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
			method : 'dsSave',
			param : {
				id : this._currentData.id,
				col_field : JSON.stringify(this._currentData.field_list),
				searchFilter : this._currentData.filterItems,
				selectDatas : this._currentData.selectDatas,
				otherfilter : JSON.stringify(this._currentData.other_option),
				outputColumn : JSON.stringify(this._currentData.outputColumn),
				dataSourceName : this._currentData.name,
				dataSourceDesc : this._currentData.description,
				dataSourceId : this._currentData.id,
				querySql : this._currentData.querySql,
				paramsDate : JSON.stringify(this._currentData.dataparams),
				customsql : this._currentData.customsql,
				ontherfilter : JSON.stringify(this._currentData.ontherfilter),
				grouptype : $("input[name='outputMode']:checked").val(),
				sheetName : this._currentData.name,
				//adminOrg : JSON.stringify(this.adminOrg)
				adminOrg : this.adminOrg,
				reportId : this.reportId
			},
			success : function (data) {
				// 触发标签点击事件（起到刷新数据的效果）
				$("div[prop_field='" + _self.reportDtas._currentData.id + "']").find("span[class^='text-label']").click();
				_self._isAddNew = false;
				_self._isAddNew_Save = true;
				shr.showInfo({
					message : "保存成功",
					hideAfter : 3
				});
			}
		});
		this._currentData.dataparams.splice(this._currentData.dataparams.length - 1, 1);
	},

	/*
	保存自定义的数据源
	 */
	SaveData : function () {
		//获取sql
		var _self = this;
		if (this._currentData.querySql == "" || this._currentData.querySql == null || this._currentData.querySql == undefined) {
			_self.getother_option();
			var mode = {
				field_list : this._currentData.field_list,
				filterItems : this._currentData.filterItems,
				selectDatas : $('#selectDatas_el').val().replace("S", ""),
				ontherfilter : this._currentData.ontherfilter,
				other_option : this._currentData.other_option,
				groupType : $("input[name='outputMode']:checked").val()
			}

			_self.getSql("no", mode);
		};

		if (this._currentData.dataparams == undefined) {
			this._currentData.dataparams = [{
					paramname : "adminOrg",
					paramdesc : "组织",
					paramtype : "0",
					paramcomp : "4",
					paramvalue : "",
					paramnull : true,
					paramstate : "0",
					paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
				}
			]
		} else {
			this._currentData.dataparams[this._currentData.dataparams.length] = {
				paramname : "adminOrg",
				paramdesc : "组织",
				paramtype : "0",
				paramcomp : "4",
				paramvalue : "",
				paramnull : true,
				paramstate : "0",
				paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
			}
		}

		shr.remoteCall({
			uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
			method : 'Save',
			param : {
				reportId : this.reportId,
				col_field : JSON.stringify(this._currentData.field_list),
				searchFilter : JSON.stringify(this._currentData.filterItems),
				selectDatas : $('#selectDatas_el').val().replace("S", ""),
				otherfilter : JSON.stringify(this._currentData.other_option),
				outputColumn : JSON.stringify(this._currentData.outputColumn),
				dataSourceName : $("#datasourceName").val().trim(),
				dataSourceDesc : $("#datasourceName").val().trim(),
				dataSourceId : "",
				querySql : this._currentData.querySql,
				paramsDate : JSON.stringify(this._currentData.dataparams),
				customsql : this._currentData.customsql,
				ontherfilter : JSON.stringify(this._currentData.ontherfilter),
				grouptype : $("input[name='outputMode']:checked").val(),
				sheetName : $("#datasourceName").val(),
				adminOrg : JSON.stringify(this.adminOrg)
			},
			success : function (data) {
				_self._datasources[_self._datasources.length] = data;
				_self._currentData = data;
				// 保存数据源参数和报表参数的映射关系
				_self.saveParamMapping(_self._currentDataParaMapping, _self._currentData.id);
				_self._isAddNew = false;
				_self._isAddNew_Save = true;
				$(".div_datasources_list").append('<div class="text-tag" prop_field="' + data.id + '" name="' + data.name + '" datatype="' + 10 + '">'
					 + '<span class="text-label text_label_pressed" title="' + data.name + '">' + data.name + '</span>'
					 + '<span class="text-remove" title="删除" prop_field="' + data.id + '" name="' + data.name + '" datatype="' + 10 + '" style="display: none;">x</span>'
					 + '</div>');
				// 触发标签点击事件（起到刷新数据的效果）
				$("div[prop_field='" + data.id + "']").find("span[class^='text-label']").click();
				shr.showInfo({
					message : "保存成功",
					hideAfter : 3
				});
			},
			error : function(data){
				if ($.block) {
					$.block.hide();
				}
			}
		});
		if ($.block) {
			$.block.hide();
		}
	},

	/*
	获取other_option
	 */
	getother_option : function () {
		div_right
		var other_option = $(".other_item");
		var otherfilter = [];
		if (other_option.length != 0) {
			other_option.each(function (index) {
				otherfilter[index] = {
					clientNumber : $(this).find("input").attr("id"),
					moltiAlias : $(this).find("span").html(),
					isSelect : $(this).find("input").parent().hasClass("checked")
				}
			});
		}
		if (this._isAddNew) {
			this._currentData.other_option = otherfilter;
		} else {
			this._currentData.other_option = otherfilter;
		}
	},

	/*
	获取选择字段
	 */
	getfield_list : function () {
		var field_list = [];
		var outputColumn = [];
		var obj = $("#gridTable").jqGrid("getRowData").length;
		var i = 0;
		$("#gridTable").find("tr[tabindex='-1']").each(function (index) {
			var pr = $("#gridTable").jqGrid("getRowData", this.getAttribute("id"));
			field_list[i] = {
				text : pr.outParame,
				outParameDes : pr.outParameDes,
				prop_field : pr.outNumber,
				field_type : pr.paramType,
				isgroup : pr.groupParame,
				issum : pr.sumParame,
				isavg : pr.avgParame,
				columnsql : pr.settingParame
			};
			outputColumn[i] = {
				columnLabel : pr.outParameDes,
				columnName : pr.outNumber,
				columnTypeName : pr.paramType
			}
			if(pr.paramType == 'Date' || pr.paramType == 'TimeStamp'){
				field_list[i].dateType = $("select[id='timeType_"+pr.outNumber+"']").val();
				outputColumn[i].dateType = $("select[id='timeType_"+pr.outNumber+"']").val();
			}
			i++;
		});

		if (this._isAddNew) {
			this._currentData.outputColumn = outputColumn;
			return field_list;
		} else {
			this._currentData.outputColumn = outputColumn;
			return field_list;
		}
	},

	/*
	从当前缓存的数据源数组(_datasources)中删除掉指定ID的数据源
	 */
	removeDataFrom_datasources : function (dataID) {
		for (var i = 0; i < this._datasources.length; i++) {
			if (this._datasources[i].id == dataID) {
				this._datasources.splice(i, 1);
				break;
			}
		}
	},

	// 匹配filterItems
	mateFilterItem : function (paramname, reportparam) {
		var filters;
		filters = this._currentData.filterItems;
		var isexist = false;
		var sameItem;
		for (var i = 0; i < filters.length; i++) {
			if (filters[i].prop_field == paramname.attr("prop_field_query")) {
				isexist = true;
				sameItem = filters[i];
				break;
			}
		}
	},

	// 保存报表参数与数据源参数的映射关系
	saveParamMapping : function (DataParaMapping, id) {
		var _self = this;
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=updateParamMapping",
			async : false,
			data : {
				uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
				id : id,
				datatype : 10,
				reportId : _self.reportId,
				DataParaMapping : JSON.stringify(DataParaMapping)
			},
			success : function (data) {
				shr.showInfo({
					message : "参数保存成功",
					hideAfter : 3
				});
			}
		});
		
	},

	// 获取报表参数与数据源参数的映射关系
	getParamMapping : function (reportId, dataid, datatype) {
		var _self = this;
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=getParamMapping",
			async : false,
			data : {
				uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
				reportId : _self.reportId,
				datatype : datatype,
				dataid : dataid
			},
			success : function (data) {
				_self._currentDataParaMapping = data;
			}
		});

	},

	// 设置映射关系
	setParamMapping : function () {
		var _self = this;
		$('#mainTable').find(".jqgrow").each(function (index) {
			var rowID = $(this).attr("id");
			var value;
			var name;
			var reportparam;
			var index;
			// 表里报表参数找到与之对应的
			for (var i = 0; i < _self._currentDataParaMapping.length; i++) {
				if (_self._currentDataParaMapping[i].dataparameName == $("#data_parame_name_" + rowID).attr("paramname")) {
					reportparam = _self._currentDataParaMapping[i];
					break;
				}

			}
			var jsonstr = "[]";
			var jsonarray = eval('(' + jsonstr + ')');
			for (var i = 0; i < _self._dataparams.length; i++) {
				var arr = {
					"value" : i,
					"alias" : _self._dataparams[i].param_value
				}
				jsonarray.push(arr);
			}
			var report_paramname_date_json = {
				id : "report_parame_name_" + rowID
			};
			report_paramname_date_json.data = jsonarray;
			$("#report_parame_name_" + rowID).shrSelect(report_paramname_date_json);
			$("#report_parame_name_" + rowID).removeClass("phone-input");
			for (var i = 0; i < _self._dataparams.length; i++) {
				if (reportparam.reportparam.param_value == _self._dataparams[i].param_value) {
					index = i;
					break;
				}
			}
			$("#report_parame_name_" + rowID).shrSelect("setValue", report_paramname_date_json.data[index].value);
		});
	},

	// 设置统计方式
	setGrouptype : function () {
		var groupType = this._currentData.grouptype;
		if (groupType == "groupcount") {
			$("#groupcount").click();
		} else if (groupType == "groupsum") {
			$("#groupsum").click();
		} else if (groupType == "groupavg") {
			$("#groupavg").click();
		} else {
			$("#detail").click();
		}
	},

	// 设置其他选项
	setOther_option : function () {
		var other_option = this._currentData.other_option;
		$("#div_right_option").empty();
		$("#div_right_option").append('<div><span>附加信息</span></div>');
		if($('#selectDatas_el').val().replace("S","") == "001"){
			// 员工信息集默认加上 仅显示占人头 和  仅显示占编制
			$("#div_right_option").append('<div class="other_item"><input id="isncount" type="checkbox"/><span>' + '仅显示占人头' + '</span></div>');
			$("#isncount").shrCheckbox();
			$("#isncount").shrCheckbox("check");
			$("#isncount").parent().css("float", "left");
			$("#isncount").parent().css("margin-right", "5px");
			$("#div_right_option").append('<div class="other_item"><input id="isOnthestrength" type="checkbox"/><span>' + '仅显示占编制' + '</span></div>');
			$("#isOnthestrength").shrCheckbox();
			$("#isOnthestrength").shrCheckbox("check");
			$("#isOnthestrength").parent().css("float", "left");
			$("#isOnthestrength").parent().css("margin-right", "5px");
		}
		for (var i = 0; i < other_option.length; i++) {
			if ((other_option[i].clientNumber == "isncount")) {
				if (other_option[i].isSelect) {
					//$("#" + other_option[i].clientNumber).shrCheckbox("check");
					//$("#" + other_option[i].clientNumber).attr("checked","true");
				}else{
					$("#" + other_option[i].clientNumber).shrCheckbox("unCheck");
				}
				continue;
			} else if (other_option[i].clientNumber == "isOnthestrength") {
				if (other_option[i].isSelect) {
					//$("#" + other_option[i].clientNumber).shrCheckbox("check");
					//$("#" + other_option[i].clientNumber).attr("checked","true");
				}else{
					$("#" + other_option[i].clientNumber).shrCheckbox("unCheck");
				}
				continue;
			} else {
				$("#div_right_option").append('<div class="other_item"><input id="' + other_option[i].clientNumber + '" type="checkbox"/><span>' + other_option[i].moltiAlias + '</span></div>');
				$("#" + other_option[i].clientNumber).shrCheckbox();
				if (other_option[i].isSelect) {
					$("#" + other_option[i].clientNumber).shrCheckbox("check");
				}else{
					$("#" + other_option[i].clientNumber).shrCheckbox("unCheck");
				}
				$("#" + other_option[i].clientNumber).parent().css("float", "left");
				$("#" + other_option[i].clientNumber).parent().css("margin-right", "5px");
			}
		}
	},

	// 清楚页面数据
	clearPageData : function () {
		// 清除输出字段列表框数据
		$("#gridTable").jqGrid("clearGridData");

		// 清除查询条件区域数据
		$(".filter_block:last").find(".filter_field").empty();

		// 清除映射区域数据
		$('#mainTable').find("[class=report_param]").each(function () {
			$(this).parent().parent().remove();
		});

	},

	// 检查数据合法性
	checkValue : function () {
		
		var isok = true;
		// 1.检查数据员名称合法性
		if ($("#datasourceName").val().trim() == "" || $("#datasourceName").val().trim() == null || $("#datasourceName").val().trim() == undefined) {
			shr.showError({
				message : "数据源名称不能为空",
				hideAfter : 3
			});
			return false;
		}
		
		if(($("#gridTable").find("[tabindex='-1']").length == 0) && (this._currentData.selectDatas!=undefined)){
			shr.showError({
				message : "输出字段不允许为空！",
				hideAfter : 3
			});
			return false;
		}
		
		if(this._currentData.selectDatas!=undefined){ //人事数据源进行输出字段合法性判断
			// 2.检查输出字段表格合法性
			var type = $("input[name='outputMode']:checked").val();
			var groupsum_count = 0;
			var groupavg_count = 0;
			var group_count = 0;
			if (type == "groupsum") { // 分组求和 -- 分组字段和求和字段为互斥的
				$("#gridTable").find("[tabindex='-1']").each(function (index) {
					var pr = $("#gridTable").jqGrid("getRowData", this.getAttribute("id"));
					if ((pr.groupParame == pr.sumParame) && (pr.groupParame == true)) {
						shr.showError({
							message : "分组求和统计方式中,【" + pr.outParame + "】字段不能同时为分组字段和求和字段",
							hideAfter : 3
						});
						isok = false;
						return false;
					}
					if(pr.sumParame == true){
						groupsum_count++;
					}
					if(pr.groupParame == true){
						group_count++;
					}
				});
				
				if(groupsum_count == 0 || group_count == 0){
					shr.showError({
						message : "分组求和统计方式中,至少需要一个分组字段和求和字段！",
						hideAfter : 3
					});
					isok = false;
					return false;
				}
				
			} else if (type == "groupavg") { // 分组求平均  --分组字段和求平均字段为互斥的，同一个字段只能勾选其中一个属性，不能同时勾选
				$("#gridTable").find("[tabindex='-1']").each(function (index) {
					var pr = $("#gridTable").jqGrid("getRowData", this.getAttribute("id"));
					if ((pr.groupParame == pr.avgParame) && (pr.groupParame == true)) {
						shr.showError({
							message : "分组求平均统计方式中,【" + pr.outParame + "】字段不能同时为分组字段和求平均字段",
							hideAfter : 3
						});
						isok = false;
						return false;
					}
					
					if(pr.avgParame == true){
						groupavg_count++;
					}
					if(pr.groupParame == true){
						group_count++;
					}
					
				});
				
				if(groupavg_count == 0 || group_count == 0){
					shr.showError({
						message : "分组求平均统计方式中,至少需要一个分组字段和求平均字段！",
						hideAfter : 3
					});
					isok = false;
					return false;
				}
				
			}
		}
		

	
			$('#mainTable').find(".jqgrow").each(function (index) {
				var rowID = $(this).attr("id");
				var value;
				var name;
				var reportparam;
				var paramdata = $("#report_parame_name_" + rowID).shrSelect("getData");
				if ($("#report_parame_name_" + rowID).attr("value") == undefined || $("#report_parame_name_" + rowID).attr("value") == "") { //判断报表参数是否有值
					shr.showError({
						message : '参数映射不完整',
						hideAfter : 3
					});
					isok = false;
					return false;
				}else{
					for(var i=0;i<paramdata.length;i++){
						if($("#report_parame_name_" + rowID).shrSelect("getValue").value == paramdata[i].value){
							if(paramdata[i].component != $("#data_parame_name_" + rowID).attr("component")){
								shr.showError({
									message :"数据源参数【"+ $("#data_parame_name_" + rowID).attr("value")+"】"+'与其对应的报表参数类型不匹配，请检查！',
									hideAfter : 3
								});
								isok = false;
								return false;
							}
						}
					}
					
				}
			});
	
		return isok;
	},

	// 加载输字段出区域的基本信息
	loadOutputFieldBaseInfo : function () {
		$("#div_outfield_baseinfo").empty();
		var field_list = this._currentData.field_list;
		var sum_field = "<div><span style='font-weight: bold;font-family: initial;'>求和字段：</span>";
		var avg_field = "<div><span style='font-weight: bold;font-family: initial;'>求平均字段：</span>";
		var group_field = "<div><span style='font-weight: bold;font-family: initial;'>分组字段：</span>";
		// 输出字段
		if (field_list == null || field_list == undefined || field_list == "") {
			return;
		}
		var html = "<div><span style='font-weight: bold;font-family: initial;'>输出字段：</span>";
		for (var i = 0, size = field_list.length; i < size; i++) {
			html += field_list[i].text + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			if(this._currentData.grouptype == "groupcount"){
				group_field += field_list[i].text + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			// 判断各个字段的统计方式
			if (field_list[i].isavg) {
				avg_field += field_list[i].text + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			if (field_list[i].issum) {
				sum_field += field_list[i].text + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			if (field_list[i].isgroup) {
				group_field += field_list[i].text + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			}
		}
		html += "</div>";
		$("#div_outfield_baseinfo").append(html);
		// 输出方式
		var grouptype = this._currentData.grouptype;
		if (!(grouptype == undefined || grouptype == "" || grouptype == null)) {
			html = "<div><span style='font-weight: bold;font-family: initial;'>输出方式：</span>";
			switch (grouptype) {
			case 'detail':
				html += "输出明细";
				html += "</div>";
				$("#div_outfield_baseinfo").append(html);
				break;
			case 'groupsum':
				html += "分组求和";
				html += "</div>";
				group_field += "</div>";
				sum_field += "</div>";
				$("#div_outfield_baseinfo").append(html);
				$("#div_outfield_baseinfo").append(group_field);
				$("#div_outfield_baseinfo").append(sum_field);
				break;
			case 'groupcount':
				html += "分组计数";
				html += "</div>";
				group_field += "</div>";
				$("#div_outfield_baseinfo").append(html);
				$("#div_outfield_baseinfo").append(group_field);
				break;
			case 'groupavg':
				html += "分组求平均";
				html += "</div>";
				group_field += "</div>";
				avg_field += "</div>";
				$("#div_outfield_baseinfo").append(html);
				$("#div_outfield_baseinfo").append(group_field);
				$("#div_outfield_baseinfo").append(avg_field);
				break;
			}
		}else{
			html = "<div><span style='font-weight: bold;font-family: initial;'>输出方式：</span>";
			html += "输出明细";
			html += "</div>";
			$("#div_outfield_baseinfo").append(html);
		}
	},

	// 加载过滤区域的基本信息
	loadFilterBaseInfo : function () {
		var ontherfilter = this._currentData.ontherfilter;
		var filterItems = jQuery.parseJSON(this._currentData.filterItems);
		/*
		if (ontherfilter == null || ontherfilter == undefined || ontherfilter == "") {
			return;
		}
		*/
		$("#filter_param_baseinfo").empty();
		var html = "<div><span style='font-weight: bold;font-family: initial;'>统计方式：</span>";
		if(ontherfilter.selecttype == "" || ontherfilter.selecttype == undefined || ontherfilter.selecttype == null){
			if(this._currentData.selectDatas == "001"){
				if(ontherfilter.enddate != null){
					ontherfilter.selecttype = "month";
				}else{
					ontherfilter.selecttype = "day";
				}
			}else if(this._currentData.selectDatas == "002"){
				if(ontherfilter.startDate != ""){
					ontherfilter.selecttype = "isTime";
				}else{
					ontherfilter.selecttype = "isPeriod";
				}
			}
		}
		
		if (ontherfilter.selecttype == "day") {
			html += "按日统计</div>";
		} else if(ontherfilter.selecttype == "month"){
			html += "按月统计</div>";
		} else if(ontherfilter.selecttype == "isTime"){
			html += "发薪时间</div>";
		} else if(ontherfilter.selecttype == "isPeriod"){
			html += "统计年月</div>";
		} else{
			html += "无</div>";
		}
		$("#filter_param_baseinfo").append(html);

		html = "<div><span style='font-weight: bold;font-family: initial;'>过滤条件：</span>";
		if (filterItems == null || filterItems.length == 0 || filterItems[0].length == 0) {
			html += "无";
		} else {
			for(var filterItems_index = 0; filterItems_index < filterItems.length; filterItems_index++){
				var filterIter = filterItems[filterItems_index];
				for (var i = 0; i < filterIter.length; i++) {
					html += filterIter[i].prop_text + "   ";
				}
				if(filterItems_index+1 != filterItems.length){
					html +=" or ";
				}
			}
			
		}
		html += "</div>";
		$("#filter_param_baseinfo").append(html);
	},

	// 加载参数映射区域的基本信息
	loadParamMappingBaseInfo : function () {
		var DataParaMapping = this._currentDataParaMapping.param;
		if (typeof DataParaMapping == 'string') {
			DataParaMapping = (jQuery.parseJSON(this._currentDataParaMapping.param));
		}
		$("#div_parammapping_baseinfo").empty();
		html = "<div><span style='font-weight: bold;font-family: initial;'>参数映射：</span>";
		if (DataParaMapping == null || DataParaMapping == undefined || DataParaMapping.length == 0) {
			html += "无";
		} else {
			for (var i = 0; i < DataParaMapping.length; i++) {
				html += DataParaMapping[i].dataparameDesc + " 等于 " + DataParaMapping[i].reportparam.param_name + "; ";
			}
		}
		html += "</div>";
		$("#div_parammapping_baseinfo").append(html);
	},

	// 清除所有区域的基本概要信息
	deleteAllBaseInfo : function () {
		$("#div_parammapping_baseinfo").empty();
		$("#filter_param_baseinfo").empty();
		$("#div_outfield_baseinfo").empty();
	},

	// 获取扩展数据源的参数信息
	getDatasourceParam : function () {
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=getDatasourceParam",
			async : false,
			data : {
				uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
				datasourceId : this._currentData.id
			},
			success : function (data) {
				_self.reportDtas._currentData.dataparams = data;
			}
		});
	},
	
	// 自定义sql时界面的处理(屏蔽相应的区域不可操作)
	customSql_Shield : function(){
		if(_self.reportDtas._currentData.customsql){
			// 1.屏蔽输出输出区域 （除了可以更改字段别名）
			$("#div_left_hide").show();
			$("#div_mid_hide").show();
			$("#div_right_hide").show();
			// 2.屏蔽过滤条件区域
			$("#filter_param_detailedinfo_hide").height($("#filter_param_detailedinfo_hide").parents().height());
			$("#filter_param_detailedinfo_hide").show();
			// 3.屏蔽参数映射区域
			$("#div_parammapping_detailedinfo_hide").show();
		}else{
			// 
			$("#div_left_hide").hide();
			$("#div_mid_hide").hide();
			$("#div_right_hide").hide();
			// 
			$("#filter_param_detailedinfo_hide").hide();
			// 
			$("#div_parammapping_detailedinfo_hide").hide();
		}		
	},
	
	// 检查数据源参数映射关系
	checkParamMapping : function(){
		var isok = true;
		$('#mainTable').find(".jqgrow").each(function (index) {
			var rowID = $(this).attr("id");
			var value;
			var name;
			var reportparam;
			if ($("#report_parame_name_" + rowID).attr("value") == undefined || $("#report_parame_name_" + rowID).attr("value") == "") { //判断报表参数是否有值
				shr.showError({
					message : '您还未对当前数据源进行参数映射',
					hideAfter : 3
				});
				isok = false;
				return ;
			}
		});
		
		if(isok == false){
			return isok;
		}
		
		var dataIds = [];
		for(var i=0;i<this._datasources.length;i++){
			dataIds[i] = this._datasources[i].id;
		}
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=checkParamMapping",
			async : false,
			data : {
				uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
				reportId : this.reportId,
				dataid : JSON.stringify(dataIds)
			},
			success : function (data) {
				if(data.result){
					isok = true;
				}else{
					shr.showError({
						message : '您有数据源参数映射未完成，请检查！',
						hideAfter : 3
					});
					isok = false;
				}
			}
		});
		return isok;
	},
	
	// 检查报表参数是否全部被数据源参数映射
	checkReportParmMapping : function(){
		var isok = true;
		var Msg = "";
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=checkReportParamMapping",
			async : false,
			data : {
				uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
				reportId : this.reportId,
			},
			success : function (data) {
				if(data.result){
					isok = true;
				}else{
					for(var i=0; i<data.NofindParams.length; i++){
						Msg += "【"+data.NofindParams[i].param_name + "】" ; 
					}
					/*
					shr.showError({
						message : '您的报表参数: ' + Msg + ' 未进行参数映射，请处理！',
						hideAfter : 3
					});
					*/
					isok = false;
				}
			}
		});
		return Msg;
	},
	
	// 检查信息集权限
	CheckDataPermission : function(reportId){
		var isDataPermissionOk = true; 
		// 检查当前用户使用该报表时，还有哪些信息集的权限未分配
		$.ajax({
			url: shr.getContextPath() + "/dynamic.do?method=getMissPermission",
			async:false,
			data: {
				uipk : "com.kingdee.shr.report.app.ReportDef.list",
				reportId : reportId
			},
			success: function(data) {
				//_wizard.setParm("_datasources",data);
				if(data.length > 0){
					var msg = "";
					for(var i=0;i<data.length;i++){
						msg += data[i]+"   ";
					}
					shr.showError({
						message : '您缺少'+msg+"信息集权限，请联系管理员分配权限！否则无法查看数据源!",
						hideAfter : 5
					});
					isDataPermissionOk = false;
				}
			}
		});
		return isDataPermissionOk;
	},
});
