﻿shr.defineClass("shr.report.reportDefPreView", shr.framework.Core, {

	initalizeDOM : function () {
		shr.report.reportDefPreView.superClass.initalizeDOM.call(this);
		var _self = this;
		$("#preView").empty();
		//$("#preView").append('<div id="tempdiv" style="display:none;"></div>');
		$("#preView").append('<div class="template_list" style="margin-bottom: 10px;"></div>');
		$("#preView").append('<div id="table"><table id="grid" class=""></table></div>');
		$("#preView").append('<div id="dialog_report" ><div class="report_filter"></div></div>');

		_self.remoteCall({
			method : 'getDataSources',
			param : {
				reportId : _self.initData.billId
			},
			success : function (data) {
				if (data.dataSources != undefined && data.dataSources != "") {
					//$("#tempdiv").before('<div class="template_list" style="margin-top: 10px;margin-left: 10px;"></div>');
					$(".template_list").empty();
					for (var i = 0; i < data.dataSources.length; i++) {
						$(".template_list").append('<div class="text-tag"><span class="text-label" templateid="' + data.dataSources[i].id + '" '
							 + 'title="' + data.dataSources[i].name + '">' + data.dataSources[i].name + '</span><span class="text-remove" title="" style="display: block;"></span></div>');
					}
					if (_self.initData.defaultDS != undefined && _self.initData.defaultDS != "") {
						$(".template_list").find(".text-label").each(function () {
							if ($(this).attr("templateid") == _self.initData.defaultDS.id) {
								$(this).parent().click();
							}
						});
					} else {
						$(".template_list").find(".text-tag")[0].click();
					}
				}
			}
		});

		$(".template_list").find(".text-tag").die().live("click", function (event) {
			if (!$(this).hasClass("template_uncheck")) {
				$(".template_list .text-tag").removeClass("template_pressed");
				$(this).addClass("template_pressed");
				$("#tempname_new").val($(this).find(".text-label").html());

				var boid = $(this).find(".text-label").attr("templateId");
				_self.doselectDataSource(boid, _self.initData.filterParam);
			}
		});
	},

	doselectDataSource : function (selectDS, filterParam) {
		var _self = this;
		if ($.block) {
			$.block.show({
				text : '正在加载，请稍候...'
			});
		}
		_self.remoteCall({
			method : 'getDSData',
			param : {
				reportId : _self.initData.billId,
				selectDS : selectDS,
				filterParam : $.toJSON(filterParam)
			},
			success : function (data) {
				$("#table").empty();
				$("#table").append('<table id="grid" class=""></table>');
				var infos = {};
				infos.head = [];
				if (data.columns != undefined && data.columns != "") {
					var columns = data.columns;
					for (var i = 0; i < columns.length; i++) {
						infos.head[i] = {
							name : columns[i].columnName,
							label : columns[i].columnLabel,
							width : 100,
							align : "left",
							hidden : false,
							key : false,
							frozen : false
						}
					}
				}
				infos.head[infos.head.length] = {
					name : 'id',
					label : 'id',
					width : 150,
					align : "left",
					hidden : true,
					key : false,
					frozen : false
				}

				infos.datas = [];
				if (data.data != undefined && data.data != "") {
					infos.datas = data.data;
				}
				_self.createTable(infos);
			}
		});
	},

	downloadReportAction : function () {
		var _self = this;
		var boid = $('#selectTemplate').shrSelect("getValue").value;
		if (boid == undefined || boid == "") {
			boid = _self.initData.template.value;
		}
		if (boid != undefined && boid != "") {
			var param = $.param({
					method : 'getReport',
					boid : boid,
					billId : _self.initData.billId,
					uipk : "com.kingdee.shr.report.app.ReportDef.list",
					filterParam : $.toJSON(_self.initData.filterParam)
				});
			location.href = shr.getContextPath() + "/dynamic.do?" + param;
		} else {
			shr.showError({
				message : "请选择模板",
				hideAfter : 3
			});
		}
	},

	doqueryAction : function () {
		var _self = this;
		var queryData;
		if ($(".report_filter").find("div").length > 0) {
			_self.showFilterDialog(_self.initData.filterParam);
			return;
		}
		shr.remoteCall({
			uipk : 'com.kingdee.shr.report.app.ReportDef.list',
			method : 'getReportFilterItems',
			param : {
				reportId : _self.initData.billId
			},
			success : function (data) {
				queryData = data.filterItems;
				var result = data.filterItems;
				var templates;
				var show = true;
				var templateid;
				_self.addFilterComponent(result);

				if (data.templates.length == 1) {
					show = false;
					templateid = data.templates[0].value;
				}
				var select_json = {
					id : "selectTemplate",
					readonly : "",
					value : "",
					onChange : null,
					validate : "",
					filter : ""
				};
				select_json.data = data.templates;
				select_json.validate = "{required:true}";
				$('#selectTemplate').shrSelect(select_json);
				$('#selectTemplate').shrSelect("setValue", _self.initData.template.value);

				for (var i = 0; i < result.length; i++) {
					var isneed = 'false';
					if (!result[i].isAllowNull) {
						isneed = 'true';
					}
					if (result[i].inputState != 2) {
						show = true;
						if (result[i].inputType == 4) {
							var grid_f7_json = {
								id : result[i].name,
								name : result[i].name
							};
							grid_f7_json.subWidgetName = 'shrPromptGrid';
							if (result[i].desc != undefined && result[i].desc != '') {
								var f7param = result[i].desc.split(";");
								grid_f7_json.subWidgetOptions = {
									title : result[i].properties.alias_zh_CN,
									uipk : f7param[0],
									query : "",
									filter : "",
									domain : "",
									multiselect : false
								};
								grid_f7_json.readonly = "";
								grid_f7_json.validate = "{required:" + isneed + "}";
								if (f7param.length > 1) {
									grid_f7_json.submitFormat = '{' + f7param[1] + '}';
								} else {
									grid_f7_json.submitFormat = '{id}';
								}
							} else {
								grid_f7_json.subWidgetOptions = {
									title : result[i].properties.alias_zh_CN,
									uipk : result[i].inputCtrl.defDbsource.name,
									query : "",
									filter : "",
									domain : "",
									multiselect : false
								};
								grid_f7_json.readonly = "";
								grid_f7_json.validate = "{required:" + isneed + "}";
								grid_f7_json.submitFormat = '{' + result[i].inputCtrl.defValue.name + '}';
							}
							grid_f7_json.value = {
								id : "",
								name : ""
							};
							$("#" + result[i].name).shrPromptBox(grid_f7_json);
							for (var j = 0, len = _self.initData.tempValue.length; j < len; j++) {
								if (result[i].name == _self.initData.tempValue[j].name) {
									$("#" + result[i].name).shrPromptBox("setValue", _self.initData.tempValue[j].value);
								}
							}
						} else if (result[i].inputType == 0) {
							var text_json = {
								id : result[i].name,
								name : result[i].name,
								readonly : "",
								value : "",
								validate : "{maxlength:255,required:" + isneed + "}",
								onChange : null
							};
							$('#' + result[i].name).shrTextField(text_json);
							for (var j = 0, len = _self.initData.tempValue.length; j < len; j++) {
								if (result[i].name == _self.initData.tempValue[j].name) {
									$("#" + result[i].name).attr("value", _self.initData.tempValue[j].value);
								}
							}
						} else if (result[i].inputType == 1) {
							if (result[i].designDataType == "3") {
								var select_json = {
									id : result[i].name
								};
								select_json.data = [{
										value : "1",
										alias : "是"
									}, {
										value : "0",
										alias : "否"
									}
								];
								select_json.validate = "{required:" + isneed + "}";
								$('#' + result[i].name).shrSelect(select_json);
								if (result[i].defaultValue == "1") {
									$('#' + result[i].name).shrSelect("setValue", select_json.data[0].value);
								} else if (result[i].defaultValue == "0") {
									$('#' + result[i].name).shrSelect("setValue", select_json.data[1].value);
								}
							} else if (result[i].designDataType == "0" || result[i].designDataType == "1") {
								if (result[i].desc && result[i].desc != "") {
									var select_json = {
										id : result[i].name
									};
									var enumUrl = result[i].desc;
									if(enumUrl == "com.kingdee.shr.compensation.CalState"){
										select_json.filter = "1,4,8,12,20";
									}
									if(enumUrl && enumUrl.trim().indexOf("url:")==0){
										var url = enumUrl.trim().substr(4);
										select_json.url = url;
									}else{
										select_json.enumSource = enumUrl;
									}
									select_json.validate = "{required:" + isneed + "}";
									$('#' + result[i].name).shrSelect(select_json);
								}
							}
							for (var j = 0, len = _self.initData.tempValue.length; j < len; j++) {
								if (result[i].name == _self.initData.tempValue[j].name) {
									$("#" + result[i].name).shrSelect("setValue", _self.initData.tempValue[j].value.value);
								}
							}
						} else if (result[i].inputType == 2) {
							var picker_json = {
								id : result[i].name
							};
							picker_json.tagClass = 'block-father input-height';
							picker_json.validate = '{dateISO:true,required:' + isneed + '}';
							$('#' + result[i].name).shrDatePicker(picker_json);
							$('#' + result[i].name).attr("value", result[i].defaultValue);
							for (var j = 0, len = _self.initData.tempValue.length; j < len; j++) {
								if (result[i].name == _self.initData.tempValue[j].name) {
									$("#" + result[i].name).attr("value", _self.initData.tempValue[j].value);
								}
							}
						}
					}
				}
				if (show) {
					_self.showFilterDialog(queryData);
				} else {
					$(".report_filter").empty();
					var param = $.param({
							method : 'getReport',
							boid : templateid,
							billId : params.id,
							uipk : "com.kingdee.shr.report.app.ReportDef.list",
							filterParam : $.toJSON(queryData)
						});
					location.href = shr.getContextPath() + "/dynamic.do?" + param;
				}
			}
		});
	},

	showFilterDialog : function (queryData) {
		var _self = this;
		$('#dialog_report').dialog({
			title : '选择过滤条件',
			width : 840,
			height : 600,
			resizable : false,
			buttons : {
				'确定' : function () {
					var allParam = [];
					for (var i = 0; i < queryData.length; i++) {
						if (queryData[i].inputState != 2) {
							if (queryData[i].inputType != null && (queryData[i].inputType == 4 || queryData[i].inputType == 1)) {
								queryData[i].curentValue = $('#' + queryData[i].name).prev().val();
								if ("adminOrg" == queryData[i].name) {
									queryData[i].curentValueAlias = $('#' + queryData[i].name).shrPromptBox("getValue").displayName;
								} else {
									queryData[i].curentValueAlias = $('#' + queryData[i].name).val();
								}
							} else {
								queryData[i].curentValue = $('#' + queryData[i].name).val();
							}
						}
						var alias = {
							alias : queryData[i].properties.alias_zh_CN
						};
						allParam[i] = {
							curentValue : queryData[i].curentValue,
							curentValueAlias : queryData[i].curentValueAlias,
							dataType : queryData[i].dataType,
							defaultValue : queryData[i].defaultValue,
							designDataType : queryData[i].designDataType,
							inputState : queryData[i].inputState,
							inputType : queryData[i].inputType,
							isAllowNull : queryData[i].isAllowNull,
							properties : JSON.stringify(alias),
							name : queryData[i].name
						}
					}
					_self.initData.filterParam = allParam;
					var defaultDS = $(".template_list").find(".template_pressed").find(".text-label").attr("templateId");
					_self.doselectDataSource(defaultDS, allParam);
					$(this).dialog('close');
				},
				'取消' : function () {
					$(this).dialog('close');
				}
			}
		});
	},

	createTable : function (infos) {
		var head = infos.head;
		var colNames = [],
		colModel = [],
		dataGrid_option = {},
		columnModel = '',
		gridId = 'grid';
		for (var i = 0; i < head.length; i++) {
			columnModel += head[i].name + ",";
			colNames.push(head[i].label);
			var columnOptions = {
				name : head[i].name,
				label : head[i].label,
				width : head[i].width,
				align : head[i].align,
				hidden : head[i].hidden,
				key : head[i].key,
				frozen : head[i].frozen
			};
			colModel.push(columnOptions);
		}

		var url = shr.getContextPath();
		url = url + '';

		dataGrid_option = {
			url : url,
			uipk : "",
			query : "",
			sorterItems : "number",
			datatype : "local",
			filter : "",
			colNames : colNames,
			jsonReader : {
				repeatitems : false
			},
			colModel : colModel,
			data : infos.datas,
			columnModel : columnModel,
			pagerpos : 'center',
			rowNum : 500000,
			customPager : '#gridPager',
			height : '' + ($(window).height() - 330),
			rowList : [50, 100, 200],
			multiselect : false,
			recordpos : 'left',
			pginputpos : 'right',
			recordtext : '({0}-{1})/{2}',
			gridview : true,
			pginput : true,
			rownumbers : true,
			viewrecords : true,
			shrinkToFit : false,
			mtype : 'POST'
		};
		dataGrid_option.loadComplete = function (ret) {
			if ($("#gridPager").html() == "" && "true" == "true") {
				$("#grid").setCustomPager("#gridPager");
			}

			shr.setIframeHeight();

			$('#gridPager_left').click(function () {
				$('.ui-pg-selbox').show();
				$(this).children('.ui-paging-info').hide();
			});

			if ($.isFunction(jsBinder.gridLoadComplete)) {
				jsBinder.gridLoadComplete.call(this, ret);
			}
		};

		dataGrid_option.onPaging = function () {
			$('.ui-pg-selbox').hide();
			$('#gridPager_left').children('.ui-paging-info').show();
		};
		$("#grid").jqGrid(dataGrid_option);

		$("#grid").jqGrid("resizeGrid", {
			base : $("#grid"),
			offset : 0
		});
		$(window).resize(function () {
			$.ieHack.hackResize(function (e) {
				$("#grid").jqGrid("resizeGrid", {
					base : $("#grid"),
					offset : 0
				});
			}, $("#grid"));
			$("#grid").setGridHeight($(window).height() - 330);
			$("#grid").setGridWidth($(window).width() - 130);
		});
	},

	addFilterComponent : function (data) {
		var router = 0;
		var xml;
		$(".report_filter").empty();
		$(".report_filter").append('<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
			 + '<div class="field_label" title="' + "模板" + '">' + "模板" + '</div></div><div class="span3 field-ctrl">'
			 + '<input class="block-father input-height" id="selectTemplate" name="selectTemplate" validate="" placeholder="" type="text"  dataExtenal="" />'
			 + '</div><div class="span1 field-desc"></div></div></div>');
		for (var i = 0; i < data.length; i++) {
			if (data[i].inputState != 2) {
				router++;
				var isneed = 'false';
				if (!data[i].isAllowNull) {
					isneed = 'true';
				}
				if (data[i].designDataType == 0 && data[i].inputType == 4) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 0) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 1) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 2) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 3) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input type="checkbox" id="' + data[i].name + '" name="' + data[i].name + '" value="1"    dataExtenal=""> <span></span>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input type="checkbox" id="' + data[i].name + '" name="' + data[i].name + '" value="1"    dataExtenal=""> <span></span>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				}
			}
		}
		if (router % 2 == 1 && xml != null) {
			$(".report_filter").append(xml + '</div>');
		}
	}
});
