﻿shr.defineClass("shr.report.dataSourceSave", shr.framework.Core, {
	_navi : null,
	initalizeDOM:function(){
		
	},
	
	dsSaveAction: function() {
		var _navi = this._navi;
		var model = _navi.getParm("model");
		var dataSourceName = $("#dataSourceName").val();
		var dataSourceDesc = $("#dataSourceDesc").val();
		var sheetName = $("#sheetName").val();
		var adminOrg = $("#adminOrg").shrPromptBox("getValue");
		
		if(dataSourceName.trim() == ""){
			shr.showError(
			{
				message: "请填写数据集名称",
				hideAfter: 3
			});
			return false;
		}
		
		if(model.dataparams == undefined){
			model.dataparams = [{
				paramname : "adminOrg",
				paramdesc : "组织",
				paramtype : "0",
				paramcomp : "4",
				paramvalue : "",
				paramnull : "0",
				paramstate : "0",
				paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
			}]
		}else{
			model.dataparams[model.dataparams.length] = {
				paramname : "adminOrg",
				paramdesc : "组织",
				paramtype : "0",
				paramcomp : "4",
				paramvalue : "",
				paramnull : "0",
				paramstate : "0",
				paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
			}
		}
		
		shr.remoteCall({
			uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
			method : 'dsSave',
			param : {
				col_field : JSON.stringify(model.field_list),
				searchFilter : model.filterItems,
				selectDatas : model.selectDatas,
				otherfilter : JSON.stringify(model.other_option),
				outputColumn : JSON.stringify(model.outputColumn),
				dataSourceName : dataSourceName,
				dataSourceDesc : dataSourceDesc,
				dataSourceId : model.id,
				querySql : model.querySql,
				paramsDate : JSON.stringify(model.dataparams),
				customsql : model.customsql,
				ontherfilter : JSON.stringify(model.ontherfilter),
				isgroup : model.isgroup,
				sheetName : sheetName,
				adminOrg : JSON.stringify(adminOrg)
			},
			success: function(data) {
				shr.showInfo({
					message: "保存成功",
					hideAfter: 3
				});
				_navi.reloadPage({
	    			uipk: 'com.kingdee.shr.report.app.PersonDataSourceDef.list'
	    		});
			}
		});
	},
	
	onNext:function(_wizard){		
		var model = _wizard.getParm("model");
		model.name = $("#dataSourceName").val();
		model.description = $("#dataSourceDesc").val();
	    return {status: 1};
	},
	
	onNaviLoad:function(_navi){	
		var _self = this;
		_self._navi = _navi;
		var model = _navi.getParm("model");
		$("#dataSourceName").val(model.name);
		$("#dataSourceDesc").val(model.description);
		$("#sheetName").val(model.sheetName);
		var admin_f7_json = {id:"adminOrg",name:"adminOrg"};
		admin_f7_json.subWidgetName = 'shrPromptGrid';
		admin_f7_json.subWidgetOptions = {title:"行政组织",uipk:"com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7",query:"",filter:"",domain:"",multiselect:false};
		admin_f7_json.readonly = '';
		admin_f7_json.validate = '{required:false}';
		admin_f7_json.value = {id:"",name:""};
		$('#adminOrg').shrPromptBox(admin_f7_json);	
		if(model.adminOrg != undefined && model.adminOrg != "" && model.adminOrg != '""'){
			$('#adminOrg').shrPromptBox("setValue",$.parseJSON(model.adminOrg));
		}else{
			$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=getUserTopAdmin",
				async:false,
				data: {
					uipk : "com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form"
				},
				success: function(data) {
					$('#adminOrg').shrPromptBox("setValue",data);
				}
			});
		}
	},
	
	finishedClick:function(){
		var _self = this;
		_self.dsSaveAction();
	}
});