﻿shr.defineClass("shr.report.fieldChoose", null, {
	_self : null,
	_index : 0,
	selectNumber : '',
	initalizeDOM : function () {
		_self = this;
		$('.field_list').sortable();
		this._index = $(".wz_navi_step.selected").attr("index");
	},
	
	initalTree : function( param ) {
		_self = this;
		$('#selectDatas').change(function () {
			if ($('#selectDatas_el').val() == _self.selectNumber) {
				return;
			}
			$(".field_list").empty();
			_self.loadTree();
			_self.selectNumber = $('#selectDatas_el').val();
		});
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=getConfigSch",
			data : {
				uipk : "com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form"
			},
			success : function (data) {
				var schemesel = [];
				if(data.length == undefined || data.length < 1){
					shr.showInfo({
					message : "你没有信息集的查看权限，请联系管理员分配权限！",
					hideAfter : 10
					});
					return;
				}
				for (var i = 0; i < data.length; i++) {
				//为了处理ie11下001,002。。会变成1,2的问题，特意加了S
					schemesel[i] = {
						'value' : 'S'+data[i].number,
						'alias' : data[i].name
					}
				}
				var select_json = {
					id : "selectDatas",
					readonly : "",
					value : "",
					onChange : null,
					validate : "",
					filter : ""
				};
				select_json.data = schemesel;
				select_json.validate = "{required:true}";
				$('#selectDatas').shrSelect(select_json);
				if(param.selectDatas){
					for(var i = 0; i < schemesel.length; i++){
						if(schemesel[i].value.replace("S","") == param.selectDatas){
							$('#selectDatas_el').val(schemesel[i].value);
							$("#selectDatas").get(0).value = schemesel[i].alias;
							break;
						}
					}
					_self.loadTree();
				}else{
					$("#selectDatas").shrSelect("setValue", schemesel[0].value);
				}
				
				$(".report_fields .text-tag").draggable({
					revert : "invalid",
					cursor : "move",
					helper : "clone",
					containment : "document"
				});
				$(".field_setting .fields-content").droppable({
					drop : function (event, ui) {
						var pId = $(this).parent().attr('id');
						$(this).append(ui.draggable);
						if (pId == "count_field") {
							$(this).find(".formula-select").show();
						} else {
							$(this).find(".formula-select").hide();
						}
					}
				});
				$(".field_list").find(".text-remove").live("click", function (e) {
					$(this).parent().remove();
				});

				$(".field_list .text-tag").live("mouseenter", function (e) {
					$(this).find(".text-remove").show();
				}).live("mouseleave", function (e) {
					$(this).find(".text-remove").hide();
				});
				
			}
		});
	},
	
	loadTree : function() {
		var self = this;
		$("#field_tree").empty();
		var tree = $('<ul class="ui-promptTree-tree ztree" style="height: 500px;"></ul>').appendTo($("#field_tree")),
			settings = {
				async : {
					enable : true,
					url : shr.getContextPath() + "/shr/msf/service.do?method=callService&serviceName=getQueryZTreeNodes",
					autoParam : ['id'],
					otherParam : {
						"scheme" : $('#selectDatas_el').val().replace("S","")
					}
				},
				otherParam : {
					"parentKey" : "parent"
				},
				callback : {
					onClick : self.onTreeClick
				}
			};
			$.fn.zTree.init(tree, settings);
	},
	
	onTreeClick : function (event, treeId, treeNode, clickFlag) {
		if (treeNode.isLeaf) {
			var hasName = false;
			$(".field_list").find(".text-label").each(function () {
				if ($(this).html() == treeNode.name) {
					hasName = true;
					return;
				}
			});			
			if (!hasName) {
				_self.loadField(treeNode.field, treeNode.name, treeNode.dataType);
				if ($('#selectDatas_el').val() == 'S001') {
					_self.loadOtherOption(treeNode.field);
				}else if ($('#selectDatas_el').val() == 'S002') {
					_self.loadOtherOption(treeNode.field);
				}
			}
		} else {
			return false;
		}
	},
	loadField : function (prop_field, prop_text, field_type) {
		$(".field_list").append('<div class="text-tag" prop_field="' + prop_field + '" field_type="' + field_type + '">'
			 + '<span class="text-label" title="' + prop_text + '">' + prop_text + '</span>'
			 + '<span class="text-remove" title="删除" style="display: none;">x</span>'
			 + '</div>');
	},
	loadOtherOption : function (prop_field) {
		shr.callService({
			serviceName : "getStructureConfigMultiRowService",
			async : true,
			param : {
				scheme:$('#selectDatas_el').val().replace("S",""),
				selectFields : prop_field
			},
			success : function (data) {
				if (data.length != 0) {
					for (var i in data) {
						if (data[i].moltiAlias != null && $("#" + data[i].clientNumber).length == 0) {
							$(".other_option").append('<div class="other_item"><input id="' + data[i].clientNumber + '" type="checkbox"/><span>' + data[i].moltiAlias + '</span></div>');

							$("#" + data[i].clientNumber).shrCheckbox();
							$("#" + data[i].clientNumber).shrCheckbox("check");
							$("#" + data[i].clientNumber).parent().css("float", "left");
							$("#" + data[i].clientNumber).parent().css("margin-right", "5px");
						}
					}
				}
			}
		});
	},

	onNext : function (_wizard) {
		var model = _wizard.getParm("model");
		if($('#selectDatas_el').val() == null || $('#selectDatas_el').val() == "" || $('#selectDatas_el').val() == undefined){
			return {
				status : 0
			};
		}
		var field_list = $(".field_list .text-tag");
		var selectFieldAll = [];
		if (field_list && field_list.length > 0) {
			field_list.each(function (index) {
				var prop_field = $(this).attr("prop_field");
				var field_type = $(this).attr("field_type");
				var text = $(this).text().replace("x", "");
				selectFieldAll[index] = {
					prop_field : prop_field,
					field_type : field_type,
					text : text
				}
			});
		}
		for(var i = 0;i<selectFieldAll.length;i++){
			var fieldNumber = selectFieldAll[i].prop_field;
			for(var j = i+1;j<selectFieldAll.length;j++){
				if(fieldNumber == selectFieldAll[j].prop_field){
					shr.showError({
					message : "字段“"+selectFieldAll[i].text+"”和字段“"+selectFieldAll[j].text+"”是重复字段，请去掉一个",
					hideAfter : 3
					});
					return {
						status : 0
					};
				}
			}
		}
		model.field_list = selectFieldAll;
		var other_option = $(".other_option .other_item");
		var otherfilter = [];
		if (other_option.length != 0) {
			other_option.each(function (index) {
				otherfilter[index] = {
					clientNumber : $(this).find("input").attr("id"),
					moltiAlias : $(this).find("span").html(),
					isSelect : $(this).find("input").parent().hasClass("checked")
				}
			});
		}
		model.other_option = otherfilter;
		model.selectDatas = $('#selectDatas_el').val().replace("S","");
		model.selectDatasName = $('#selectDatas').val();
		return {
			status : 1
		};
	},

	onNaviLoad : function (_navi) {
		if ($('#breadcrumb').length == 0) {
			$(".wz_navi").before("<div class='view_mainPage'><ul id='breadcrumb' class='breadcrumb' data-breadcrumbType=''></ul></div>");
		}
		if (shr.isWorkareaFrame() || shr.isWizardFrame()) {
			var breadcrumb = $('#breadcrumb').shrBreadcrumb();
			breadcrumb.shrBreadcrumb('addItem', {
				name : '向导'
			});
		}
		var params = $.parseJSON($('#workArea', window.parent.document).attr('params'));
		if (params == undefined) {
			params = $.parseJSON(sessionStorage.getItem('reportParams'));
		}
		if (params != undefined) {
			$(".wz_navi_step").addClass("enabled");
		}
		var model = _navi.getParm("model");
		if (model == undefined || model == "") {
			if (params != null) {
				model = params.model;
				_navi.setParm("model", model);
			} else {
				model = {};
				_navi.setParm("model", model);
			}
		}
		this.initalTree(model);

		for (var i = 0; i < model.field_list.length; i++) {
			this.loadField(model.field_list[i].prop_field, model.field_list[i].text, model.field_list[i].field_type);
		}
		for (var i in model.other_option) {
			$(".other_option").append('<div class="other_item"><input id="' + model.other_option[i].clientNumber + '" type="checkbox"/><span>' + model.other_option[i].moltiAlias + '</span></div>');

			$("#" + model.other_option[i].clientNumber).shrCheckbox();
			if (model.other_option[i].isSelect) {
				$("#" + model.other_option[i].clientNumber).shrCheckbox("check");
			}
			$("#" + model.other_option[i].clientNumber).parent().css("float", "left");
			$("#" + model.other_option[i].clientNumber).parent().css("margin-right", "5px");
		}
	}
});
