shr.defineClass("shr.report.filterSet", null, {
	selectDatas : '',
	initalizeDOM : function () {
		$(document).click(function () {
			var $target;
			if (event) {
				$target = $(event.target);
				if ($target.is(".oe_searchview_drawer") || $target.parents(".oe_searchview_drawer").length != 0 || $target.parents(".emp_searchview").length != 0) {
					return;
				}
				$(".oe_searchview_drawer").hide();
				$(".dropdown-custom").hide();
			}
		});
		var _self = this;
		var selectPage = $(".selectPage").length == 0 ? $("<div class='selectPage'></div>").appendTo($("body")) : $(".selectPage");
		var dropdownElement = $('<ul class="dropdown-custom overflow-select" style="display: none;"></ul>').appendTo(selectPage);
		$("#prop_value").live("keyup", function () {
			_self.getkeyNodes(event, dropdownElement);
		});
		$(".icon-chevron-down").parent().click(function () {
			if ($(".oe_searchview_drawer").is(':hidden')) {
				$(".oe_searchview_drawer").show();
			} else {
				$(".oe_searchview_drawer").hide();
			}
		});

		var field_info = $(".select_field").html();
		var filter_block_content = $(".filter_block").html();
		$(".filter_field").find(".text-label").live("click", function () {
			$(".icon-remove").click();
			var filter_block = $(this).parents(".filter_block");
			filter_block.find(".select_field").html(field_info);
			var type = $(this).parent().attr("field_type");
			var prop_field = $(this).parent().attr("prop_field");
			var prop_op = $(this).parent().attr("prop_op");
			var prop_value = $(this).parent().attr("prop_value");
			var fieldValue = $(this).parent().data("fieldValue");

			var tree_f7_json = {
				id : "prop_field",
				name : "prop_field"
			};
			tree_f7_json.subWidgetName = 'shrPromptTree';
			tree_f7_json.subWidgetOptions = {
				treeSettings : {},
				dataUrl : shr.getContextPath() + "/shr/msf/service.do?method=callService&serviceName=getQueryZTreeNodes&scheme=" + _self.selectDatas,
				width : 250
			};
			$('#prop_field').shrPromptBox(tree_f7_json);

			_self._addItemEventListener($('#prop_field'));

			$('#prop_field').shrPromptBox("setValue", fieldValue);
			$("#prop_op").shrSelect("setValue", prop_op);
			if (type == "StringEnum" || type == "IntEnum" || type == "Boolean") {
				$("#prop_value").shrSelect("setValue", prop_value);
			} else if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined" && $(this).parent().data("prompt_value") != null && $(this).parent().data("prompt_value") != "") {
				$('#prop_value').shrPromptBox("setValue", $(this).parent().data("prompt_value"));
			} else {
				$("#prop_value").val(prop_value);
			}
			$("#prop_value").blur();
			$("#prop_value_down").hide();
			$("#prop_value").parents(".ui-select-frame").removeClass("oe_focused");

			filter_block.find(".icon-ok").attr("index", $(this).parent().index());

			filter_block.find(".select_field >div").addClass("search-emp-field");
			filter_block.find(".field_ok").css("display", "table-cell");
			filter_block.find(".select_field").css("display", "table-cell");
			filter_block.find(".field_add").css("display", "none");
			filter_block.find(".filter_field").css("display", "block");
		});

		$(".icon-plus").live("click", function (e) {
			var filter_block = $(this).parents(".filter_block");
			filter_block.find(".select_field").html(field_info);
			var tree_f7_json = {
				id : "prop_field",
				name : "prop_field"
			};
			tree_f7_json.subWidgetName = 'shrPromptTree';
			tree_f7_json.subWidgetOptions = {
				treeSettings : {},
				dataUrl : shr.getContextPath() + "/shr/msf/service.do?method=callService&serviceName=getQueryZTreeNodes&scheme=" + _self.selectDatas,
				width : 250
			};
			filter_block.find('#prop_field').shrPromptBox(tree_f7_json);
			_self._addItemEventListener(filter_block.find('#prop_field'));
			filter_block.find(".select_field").css("display", "table-cell");
			filter_block.find(".select_field >div").addClass("search-emp-field");
			filter_block.find(".field_ok").css("display", "table-cell");
			filter_block.find(".field_add").css("display", "none");
			filter_block.find(".filter_field").css("display", "block");
			filter_block.find(".icon-ok").attr("isOr", "false");
			filter_block.find(".icon-ok").data("fieldinfo", $(this).parent().prev());
		});

		$(".icon_add_or").live("click", function (e) {
			var filter_block = $(this).parents(".filter_block");
			filter_block.find(".select_field").html(field_info);
			var tree_f7_json = {
				id : "prop_field",
				name : "prop_field"
			};
			tree_f7_json.subWidgetName = 'shrPromptTree';
			tree_f7_json.subWidgetOptions = {
				treeSettings : {},
				dataUrl : shr.getContextPath() + "/shr/msf/service.do?method=callService&serviceName=getQueryZTreeNodes&scheme=" + _self.selectDatas,
				width : 250
			};
			filter_block.find('#prop_field').shrPromptBox(tree_f7_json);
			_self._addItemEventListener(filter_block.find('#prop_field'));
			filter_block.find(".select_field").css("display", "table-cell");
			filter_block.find(".select_field >div").addClass("search-emp-field");
			filter_block.find(".field_ok").css("display", "table-cell");
			filter_block.find(".field_add").css("display", "none");
			filter_block.find(".filter_field").css("display", "block");
			filter_block.find(".icon-ok").attr("isOr", "true");
		});

		$(".icon-ok").live("click", function (e) {
			var filter_block = $(this).parents(".filter_block");
			if (filter_block.find("#prop_field").size() != 0) {
				if (filter_block.find("#prop_field").val() == "" || filter_block.find("#prop_op").val() == "") {
					shr.showError({
						message : "查询条件输入不全",
						hideAfter : 3
					});
				} else if (filter_block.find("#prop_field").attr("prop_field") == null) {
					shr.showError({
						message : "查询条件输入不合法",
						hideAfter : 3
					});
				} else {
					var filter_field = filter_block.find(".filter_field");
					filter_field.parent().find(".field_ok").css("display", "none");

					var prop_field = filter_block.find('#prop_field').val();
					var prop_op = filter_block.find("#prop_op").shrSelect("getValue").value;
					var prop_value_text = filter_block.find("#prop_value").val();
					var prop_op_text = filter_block.find("#prop_op").val();
					var prop_value = "";
					var fieldValue = filter_block.find("#prop_field").data('fieldValue');
					if (prop_value == "" || prop_value == null) {
						prop_value = filter_block.find("#prop_value").val();
					}
					if (prop_value_text == "" || prop_value_text == null) {
						prop_value_text = "@" + fieldValue.field.replace(".", "_");
					}

					if (fieldValue.type == "StringEnum" || fieldValue.type == "IntEnum" || fieldValue.type == "Boolean") {
						prop_value = filter_block.find("#prop_value_el").val();
					}

					if ($(this).attr("index") != undefined) {
						filter_field.find(".text-tag:eq(" + $(this).attr("index") + ")").replaceWith('<div class="text-tag" isOr="' + $(this).attr("isOr") + '" field_type="' + filter_block.find('#prop_field').attr("field_type") + '" prop_field="' + filter_block.find('#prop_field').attr("prop_field") + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"><span class="text-label">\"' + prop_field + "\" " + prop_op_text + " \"" + prop_value_text + '\"</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined") {
							var prompt_value = filter_block.find("#prop_value").shrPromptBox("getValue");
							if (filter_block.find("#prop_value").prev().val() != "") {
								filter_field.find(".text-tag:eq(" + $(this).attr("index") + ")").data("prompt_value", prompt_value);
							}
						}
						filter_field.find(".text-tag:eq(" + $(this).attr("index") + ")").data('fieldValue', fieldValue);
					} else if ($(this).attr("isOr") == "false") {
						filter_field.append('<div class="text-tag" isOr="false" field_type="' + filter_block.find('#prop_field').attr("field_type") + '" prop_field="' + filter_block.find('#prop_field').attr("prop_field") + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"><span class="text-label">\"' + prop_field + "\" " + prop_op_text + " \"" + prop_value_text + '\"</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined") {
							var prompt_value = filter_block.find("#prop_value").shrPromptBox("getValue");
							if (filter_block.find("#prop_value").prev().val() != "") {
								filter_field.find(".text-tag:last").data("prompt_value", prompt_value);
							}
						}
						filter_field.find(".text-tag:last").data('fieldValue', fieldValue);
					} else {
						$("<div class='filter_block'></div>").insertAfter($(".filter_block:last")).append(filter_block_content);
						$(".filter_block:last").find(".filter_field").append('or <div class="text-tag" isOr="true" field_type="' + filter_block.find('#prop_field').attr("field_type") + '" prop_field="' + filter_block.find('#prop_field').attr("prop_field") + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"><span class="text-label">\"' + prop_field + "\" " + prop_op_text + " \"" + prop_value_text + '\"</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						if (fieldValue.uipk != null && fieldValue.uipk != "null" && fieldValue.uipk != "undefined") {
							var prompt_value = filter_block.find("#prop_value").shrPromptBox("getValue");
							if (filter_block.find("#prop_value").prev().val() != "") {
								$(".filter_block:last").find(".filter_field").find(".text-tag:last").data("prompt_value", prompt_value);
							}
						}
						$(".filter_block:last").find(".filter_field").find(".text-tag:last").data('fieldValue', fieldValue);
						filter_field.css("display", "table-cell");
						filter_field = $(".filter_block:last").find(".filter_field");
					}
					$(this).removeAttr("index");
					$(".select_field").empty();
					$(".select_field").hide();

					filter_field.css("display", "table-cell");
					$(".field_add").css("display", "table-cell");
					$(".field_add").find(".icon_add_or").hide();
					$(".filter_block:last").find(".icon_add_or").show();
				}
			}
		});

		$(".icon-remove").live("click", function (e) {
			var filter_block = $(this).parents(".filter_block");
			filter_block.find(".field_ok").css("display", "none");
			filter_block.find(".field_add").css("display", "table-cell");
			filter_block.find(".filter_field").css("display", "table-cell");
			filter_block.find(".select_field").empty();
			filter_block.find(".select_field").hide();
			$(this).prev().removeAttr("index");
		});

		$(".filter_field .text-tag").live("mouseenter", function (e) {
			$(this).find(".text-remove").show();
		}).live("mouseleave", function (e) {
			$(this).find(".text-remove").hide();
		});

		$(".filter_field").find(".text-remove").live("click", function (e) {
			if ($(this).parents(".filter_field").find(".text-tag").length == 1 && $(".filter_block").length > 1) {
				$(this).parents(".filter_block").remove();
				$(".filter_block:last").find(".icon_add_or").show();
			} else {
				if ($(this).parents(".filter_field").find(".text-tag").length == 1) {
					$(this).parents(".filter_block").find(".icon_add_or").hide();
				}
				$(this).parent().remove();
			}
		});
	},

	onNext : function (_wizard) {
		var model = _wizard.getParm("model");
		var searchResultAll = [];
		var dataparams = [];
		var paramIndex = 0;
		if (model.customsql == true || model.customsql == "true"){
			return {
				status : 1
			};
		}
		$(".filter_block").each(function (index) {
			var searchResult = [];
			$(this).find(".filter_field .text-tag").each(function (index) {
				var prop_field = $(this).attr("prop_field");
				var prop_op = $(this).attr("prop_op");
				var prop_value = $(this).attr("prop_value");
				var prompt_value = "";
				var field_type = $(this).attr("field_type");
				var prop_text = $(this).find(".text-label").html();
				var fieldValue = $(this).data("fieldValue");
				var uipk = fieldValue.uipk;
				if (uipk != undefined && uipk != "" && uipk != "null" && uipk != "undefined" && $(this).data("prompt_value") != null) {
					prompt_value = $(this).data("prompt_value");
				}

				var fileType = "0";
				var comp = "0";
				var parampk = "";
				if (field_type != undefined && field_type == "String") {
					fileType = "0";
				} else if (field_type == "TimeStamp" || field_type == "Date") {
					fileType = "2";
					comp = "2";
				} else if (field_type == "IntEnum") {
					fileType = "1";
					comp = "1";
				} else if (field_type == "Short" || field_type == "Double" || field_type == "BigDecimal" || field_type == "Integer" || field_type == "Long" || field_type == "Float" || field_type == "Int") {
					fileType = "1";
					comp = "0";
				} else if (field_type == "StringEnum") {
					fileType = "0";
					comp = "1";
				} else if (field_type == "Boolean") {
					fileType = "3";
					comp = "1";
				}
				if (uipk != undefined && uipk != null && uipk != "") {
					comp = "4";
					parampk = uipk + ";" + prop_field.substring(prop_field.lastIndexOf('.') + 1);
				}
				if (fieldValue.enumSource != undefined && fieldValue.enumSource != null && fieldValue.enumSource != "") {
					parampk = fieldValue.enumSource;
				}
				//if(prop_field.replace(".","_") == prop_value){
				if (prop_value == "" || prop_value == "null" || prop_value == null || prop_value == "@" + prop_field.replace(".", "_")) {
					prop_value = "@" + prop_field.replace(".", "_");
					dataparams[paramIndex] = {
						paramname : prop_field.replace(".", "_"),
						paramdesc : fieldValue.name,
						paramtype : fileType,
						paramcomp : comp,
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : parampk
					};
					paramIndex++;
				}

				searchResult[index] = {
					prop_field : prop_field,
					prop_text : prop_text,
					prop_op : prop_op,
					prop_value : prop_value,
					prompt_value : prompt_value,
					field_type : field_type,
					fieldValue : fieldValue
				}
			});
			searchResultAll.push(searchResult);
		});
		model.filterItems = JSON.stringify(searchResultAll);
		if (dataparams.length > 0) {
			if (model.dataparams != undefined && model.dataparams != "") {
				var paramlength = model.dataparams.length;
				var addIndex = 0;
				for (var i = 0; i < dataparams.length; i++) {
					var isadd = true;
					for (var j = 0; j < paramlength; j++) {
						if (model.dataparams[j].paramname == dataparams[i].paramname) {
							//model.dataparams[j] = dataparams[i];
							isadd = false;
						}
					}
					if (isadd) {
						model.dataparams[paramlength + addIndex] = dataparams[i];
						addIndex++;
					}
				}
			} else {
				model.dataparams = dataparams;
			}
		}
		var ontherfilter;
		if (model.selectDatas == "001") {
			var curDate = $("#selectdate").attr("value");
			var startDate = $("#startdate").attr("value");
			var endDate = $("#enddate").attr("value");
			if (curDate != undefined && curDate != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				} else {
					model.dataparams = [];
				}
				var isaddbasedate = true;
				var isaddstartdate = true;
				var isaddenddate = true;
				for (var i = 0; i < length; i++) {
					if (curDate.indexOf("@") != -1 && curDate.replace("@", "").length > 0 && model.dataparams[i].paramname == curDate.replace("@", "")) {
						isaddbasedate = false;
					}
					if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0 && model.dataparams[i].paramname == startDate.replace("@", "")) {
						isaddstartdate = false;
					}
					if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0 && model.dataparams[i].paramname == endDate.replace("@", "")) {
						isaddenddate = false;
					}
				}
				if (isaddbasedate) {
					var paramstate = "0";
					if ($('#dimension').shrSelect("getValue").value == "month") {
						paramstate = "2";
					}
					model.dataparams[length] = {
						paramname : curDate.replace("@", ""),
						paramdesc : "基准日期",
						paramtype : "2",
						paramcomp : "2",
						paramvalue : "getSystemDate()",
						paramnull : false,
						paramstate : paramstate,
						paramuipk : ""
					};
					length++;
				}
				if (isaddstartdate && $('#dimension').shrSelect("getValue").value == "month") {
					model.dataparams[length] = {
						paramname : startDate.replace("@", ""),
						paramdesc : "开始日期",
						paramtype : "2",
						paramcomp : "2",
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : ""
					};
					length++;
				}
				if (isaddenddate && $('#dimension').shrSelect("getValue").value == "month") {
					model.dataparams[length] = {
						paramname : endDate.replace("@", ""),
						paramdesc : "结束日期",
						paramtype : "2",
						paramcomp : "2",
						paramvalue : "",
						paramnull : false,
						paramstate : "0",
						paramuipk : ""
					};
					length++;
				}
			}
			if ($('#dimension').shrSelect("getValue").value == "month") {
				ontherfilter = {
					selecttype : $('#dimension').shrSelect("getValue").value,
					startdate : $("#startdate").attr("value"),
					enddate : $("#enddate").attr("value"),
					includetype : $("#includetype").shrSelect("getValue").value,
					selectdate : $("#selectdate").attr("value"),
					isncount : $('#isncount').is(':checked').toString();,
					isOnthestrength : $('#isOnthestrength').is(':checked').toString()
				}
			} else {
				ontherfilter = {
					selecttype : $('#dimension').shrSelect("getValue").value,
					selectdate : $("#selectdate").attr("value"),
					isncount : $('#isncount').is(':checked').toString();
					isOnthestrength : $('#isOnthestrength').is(':checked').toString()
				}
			}
		} else if (model.selectDatas == "002") {			
			var startDate = $("#startdate").attr("value");
			if (startDate != undefined && startDate != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == startDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							model.dataparams = [{
									paramname : startDate.replace("@", ""),
									paramdesc : "开始时间",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : startDate.replace("@", ""),
								paramdesc : "开始时间",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var endDate = $("#enddate").attr("value");
			if (endDate != undefined && endDate != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == endDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							model.dataparams = [{
									paramname : endDate.replace("@", ""),
									paramdesc : "结束时间",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : endDate.replace("@", ""),
								paramdesc : "结束时间",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var beginYear = $("#beginYear").attr("value");
			if (beginYear != undefined && beginYear != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (beginYear.indexOf("@") != -1 && beginYear.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == beginYear.replace("@", "")){
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getFullYear();
						if (length == 0) {
							model.dataparams = [{
									paramname : beginYear.replace("@", ""),
									paramdesc : "开始年份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : beginYear.replace("@", ""),
								paramdesc : "开始年份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
							}
						}
					}
				}
			}			
			var beginMonth = $("#beginMonth").attr("value");
			if (beginMonth != undefined && beginMonth != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (beginMonth.indexOf("@") != -1 && beginMonth.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == beginMonth.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getMonth()+1;
						if (length == 0) {
							model.dataparams = [{
									paramname : beginMonth.replace("@", ""),
									paramdesc : "开始月份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : beginMonth.replace("@", ""),
								paramdesc : "开始月份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
							}
						}
					}
				}
			}
			var endYear = $("#endYear").attr("value");
			if (endYear != undefined && endYear != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (endYear.indexOf("@") != -1 && endYear.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == endYear.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getFullYear();
						if (length == 0) {
							model.dataparams = [{
									paramname : endYear.replace("@", ""),
									paramdesc : "结束年份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : endYear.replace("@", ""),
								paramdesc : "结束年份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodYearList"
							}
						}
					}
				}
			}
			var endMonth = $("#endMonth").attr("value");
			if (endMonth != undefined && endMonth != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (endMonth.indexOf("@") != -1 && endMonth.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == endMonth.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						var myValue = myDate.getMonth()+1;
						if (length == 0) {
							model.dataparams = [{
									paramname : endMonth.replace("@", ""),
									paramdesc : "结束月份",
									paramtype : "1",
									paramcomp : "1",
									paramvalue : myValue,
									paramnull : false,
									paramstate : "0",
									paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : endMonth.replace("@", ""),
								paramdesc : "结束月份",
								paramtype : "1",
								paramcomp : "1",
								paramvalue : myValue,
								paramnull : false,
								paramstate : "0",
								paramuipk : "url:/dynamic.do?uipk=shr.compensation.cmpImport&method=getPeriodMonthList"
							}
						}
					}
				}
			}			
			ontherfilter = {
				startdate : $("#startdate").attr("value"),
				enddate : $("#enddate").attr("value"),
				beginYear : $("#beginYear").attr("value"),
				beginMonth : $("#beginMonth").attr("value"),
				endYear : $("#endYear").attr("value"),
				endMonth : $("#endMonth").attr("value")
			};			
		} else if (model.selectDatas == "003") {
			var startDate = $("#startdate").attr("value");
			if (startDate != undefined && startDate != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (startDate.indexOf("@") != -1 && startDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == startDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							model.dataparams = [{
									paramname : startDate.replace("@", ""),
									paramdesc : "开始日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : startDate.replace("@", ""),
								paramdesc : "开始日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			var endDate = $("#enddate").attr("value");
			if (endDate != undefined && endDate != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (endDate.indexOf("@") != -1 && endDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == endDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							model.dataparams = [{
									paramname : endDate.replace("@", ""),
									paramdesc : "结束日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : endDate.replace("@", ""),
								paramdesc : "结束日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			ontherfilter = {
				startdate : $("#startdate").attr("value"),
				enddate : $("#enddate").attr("value")
			}
		} else if (model.selectDatas == "004") {
			var curDate = $("#selectdate").attr("value");
			if (curDate != undefined && curDate != "") {
				var length = 0;
				if (model.dataparams) {
					length = model.dataparams.length;
				}
				if (curDate.indexOf("@") != -1 && curDate.replace("@", "").length > 0) {
					var isadd = true;
					for (var i = 0; i < length; i++) {
						if (model.dataparams[i].paramname == curDate.replace("@", "")) {
							isadd = false;
						}
					}
					if (isadd) {
						var myDate = new Date();
						if (length == 0) {
							model.dataparams = [{
									paramname : curDate.replace("@", ""),
									paramdesc : "基准日期",
									paramtype : "2",
									paramcomp : "2",
									paramvalue : "getSystemDate()",
									paramnull : false,
									paramstate : "0",
									paramuipk : ""
								}
							]
						} else {
							model.dataparams[length] = {
								paramname : curDate.replace("@", ""),
								paramdesc : "基准日期",
								paramtype : "2",
								paramcomp : "2",
								paramvalue : "getSystemDate()",
								paramnull : false,
								paramstate : "0",
								paramuipk : ""
							}
						}
					}
				}
			}
			ontherfilter = {
				selectdate : $("#selectdate").attr("value")
			}
		}
		model.ontherfilter = ontherfilter;
		return {
			status : 1
		};
	},

	onNaviLoad : function (_navi) {
		var _self = this;
		var model = _navi.getParm("model");
		_self.selectDatas = model.selectDatas;
		if (model.selectDatas == "001") {
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">统计周期</span>' +
				'<div style="width: 100px;display: inline-block;vertical-align: bottom;">' +
				'<input id="dimension" type="text" name="dimension" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span class="day-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;">基准日期</span>' +
				'<div class="day-other-param" style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="selectdate" type="text" name="selectdate" disabled="true" class="search-input-length input-height day-other-param"/></div>');
			$("#ontheroption").append('<span class="month-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;">开始日期</span>' +
				'<div class="month-other-param" style="width: 110px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate" type="text" name="startdate" class="search-input-length input-height month-other-param"/></div>');
			$("#ontheroption").append('<span class="month-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;">结束日期</span>' +
				'<div class="month-other-param" style="width: 110px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate" type="text" name="enddate" class="search-input-length input-height month-other-param"/></div>');
			$("#ontheroption").append('<span class="month-other-param" style="padding-right: 15px; font-weight: bold;padding-left: 15px;"></span>' +
				'<div class="month-other-param" style="width: 140px;display: inline-block;vertical-align: bottom;">' +
				'<input id="includetype" type="text" name="includetype" class="search-input-length input-height month-other-param"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; padding-left: 15px; font-weight: bold;">占人头数</span>' +
				'<div style="width: 45px;display: inline-block;vertical-align: bottom;">' +
				'<input role="checkbox" style="margin-bottom: 4px;" type="checkbox" id="isncount" name="isIncount"></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">占编制数</span>' +
				'<div style="width: 45px;display: inline-block;vertical-align: bottom;">' +
				'<input role="checkbox" style="margin-bottom: 4px;" type="checkbox" id="isOnthestrength" name="isOnthestrength"></div>');

			var picker_json = {
				id : 'startdate'
			};
			picker_json.tagClass = 'block-father input-height';
			picker_json.validate = '{dateISO:true,required:true}';
			$("#startdate").shrDatePicker(picker_json);
			$("#startdate").shrDatePicker("disable");
			picker_json.id = 'enddate';
			$("#enddate").shrDatePicker(picker_json);
			$("#enddate").shrDatePicker("disable");
			var select_json = {
				id : "dimension"
			};
			select_json.data = [{
					value : "day",
					alias : "按日"
				}, {
					value : "month",
					alias : "按月"
				}
			];
			select_json.validate = "{required:true}";
			$('#dimension').shrSelect(select_json);
			var include_json = {
				id : "includetype"
			};
			include_json.data = [{
					value : "start",
					alias : "导出期初数据"
				}, {
					value : "end",
					alias : "导出期末数据"
				}, {
					value : "startend",
					alias : "导出期初期末数据"
				}
			];
			include_json.validate = "{required:true}";
			$('#includetype').shrSelect(include_json);
			$('#includetype').shrSelect("setValue", "start");
			$('#dimension').change(function () {
				if (model.customsql == true || model.customsql == "true"){
					$('.day-other-param').show();
					$('.month-other-param').hide();
					return;
				}
				if ($('#dimension').shrSelect("getValue").value == "month") {
					$('.day-other-param').hide();
					$('.month-other-param').show();
					
					if (model.ontherfilter.startdate != undefined && model.ontherfilter.startdate != "") {
						$("#startdate").attr("value", model.ontherfilter.startdate);
					} else {
						$("#startdate").attr("value", "@startDate");
					}
					if (model.ontherfilter.enddate != undefined && model.ontherfilter.enddate != "") {
						$("#enddate").attr("value", model.ontherfilter.enddate);
					} else {
						$("#enddate").attr("value", "@endDate");
					}
					
					if (model.dataparams) {
						var length = model.dataparams.length;
						for (var i = 0; i < length; i++) {
							if (model.dataparams[i].paramname == "baseDate") {
								model.dataparams[i].paramstate = "2";
							}
						}
					}
				} else {
					$('.day-other-param').show();
					$('.month-other-param').hide();
					if (model.dataparams) {
						var length = model.dataparams.length;
						var choose = [];
						var index = 0;
						for (var i = 0; i < length; i++) {
							if (model.dataparams[i].paramname != "startDate"
								 && model.dataparams[i].paramname != "endDate") {
								if (model.dataparams[i].paramname == "baseDate") {
									model.dataparams[i].paramstate = "0";
								}
								choose[index] = model.dataparams[i];
								index++;
							}
						}
						model.dataparams = choose;
					}
				}
			});
			if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				if (model.ontherfilter.selecttype != undefined && model.ontherfilter.selecttype == "month") {
					$('#dimension').shrSelect("setValue", select_json.data[1].value);
					if (model.ontherfilter.startdate != undefined && model.ontherfilter.startdate != "") {
						$("#startdate").attr("value", model.ontherfilter.startdate);
					} else {
						$("#startdate").attr("value", "@startDate");
					}
					if (model.ontherfilter.enddate != undefined && model.ontherfilter.enddate != "") {
						$("#enddate").attr("value", model.ontherfilter.enddate);
					} else {
						$("#enddate").attr("value", "@endDate");
					}
					if (model.ontherfilter.includetype != undefined && model.ontherfilter.includetype != "") {
						$('#includetype').shrSelect("setValue", model.ontherfilter.includetype);
					} else {
						$('#includetype').shrSelect("setValue", "start");
					}
				} else {
					$('#dimension').shrSelect("setValue", select_json.data[0].value);
				}
				if (model.ontherfilter.selectdate == undefined || model.ontherfilter.selectdate == "") {
					$("#selectdate").attr("value", "@baseDate");
				} else {
					$("#selectdate").attr("value", model.ontherfilter.selectdate);
				}
				if (model.ontherfilter.isncount && "true" == model.ontherfilter.isncount) {
					$("#isncount")[0].checked = true;
				} else {
					$("#isncount")[0].checked = false;
				}
				if (model.ontherfilter.isOnthestrength && "true" == model.ontherfilter.isOnthestrength) {
					$("#isOnthestrength")[0].checked = true;
				} else {
					$("#isOnthestrength")[0].checked = false;
				}
			} else {
				$('#dimension').shrSelect("setValue", select_json.data[0].value);
				$("#selectdate").attr("value", "@baseDate");
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			}} else if (model.selectDatas == "002") {
			$("#ontheroption").append('<table><tr><td width="25%">发薪时间</td><td width="25%">'+
					'<input type="radio" name="isPeriod" id="isTime"/></td><td width="25%">统计年月</td>'+
					'<td width="25%"><input type="radio" name="isPeriod" id="isPeriod"/></td></tr></table>');		
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">开始时间</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate" type="text" name="startdate" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">结束时间</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate" type="text" name="enddate" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">开始年份</span>' +
					'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
					'<input id="beginYear" type="text" name="beginYear" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">开始月份</span>' +
					'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
					'<input id="beginMonth" type="text" name="beginMonth" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">结束年份</span>' +
					'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
					'<input id="endYear" type="text" name="endYear" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">结束月份</span>' +
					'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
					'<input id="endMonth" type="text" name="endMonth" class="search-input-length input-height"/></div>');
			$("#isTime").shrRadio({id:'isTime'}).shrRadio('check');
			$("#isPeriod").shrRadio({id:'isPeriod'});
			var isp = 0;
			if (model.ontherfilter && (model.ontherfilter.startdate || model.ontherfilter.enddate)) {
				isp = false;
			}else{
				isp = true;
			}	
			var startdate = "@startDate",enddate = "@endDate",beginYear = "@beginYear",beginMonth = "@beginMonth",endYear = "@endYear",endMonth = "@endMonth";
			if(isp){
				if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
					beginYear = model.ontherfilter.beginYear||"@beginYear";
					beginMonth = model.ontherfilter.beginMonth||"@beginMonth";
					endYear = model.ontherfilter.endYear||"@endYear";
					endMonth = model.ontherfilter.endMonth||"@endMonth";
				}				
			}else{
				if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
					startdate = model.ontherfilter.startdate||"@startDate";
					enddate = model.ontherfilter.enddate||"@endDate";
				}				
			}
			if(isp){
				$("#startdate").attr("value", "").parent().hide().prev("span").hide();
				$("#enddate").attr("value", "").parent().hide().prev("span").hide();	
				$("#beginYear").attr("value", beginYear).parent().show().prev("span").show();
				$("#beginMonth").attr("value", beginMonth).parent().show().prev("span").show();
				$("#endYear").attr("value", endYear).parent().show().prev("span").show();
				$("#endMonth").attr("value", endMonth).parent().show().prev("span").show();
				$("#isPeriod").shrRadio('check');
			}else{
				$("#startdate").attr("value", startdate).parent().show().prev("span").show();
				$("#enddate").attr("value", enddate).parent().show().prev("span").show();	
				$("#beginYear").attr("value", "").parent().hide().prev("span").hide();
				$("#beginMonth").attr("value", "").parent().hide().prev("span").hide();
				$("#endYear").attr("value", "").parent().hide().prev("span").hide();
				$("#endMonth").attr("value", "").parent().hide().prev("span").hide();
				$("#isTime").shrRadio('check');
			}			
			$("#isPeriod,#isTime").change(function(a,b){
				var ispc= $("#isPeriod").shrRadio("isSelected");			
				if(ispc){
					$("#startdate").attr("value", "").parent().hide().prev("span").hide();
					$("#enddate").attr("value", "").parent().hide().prev("span").hide();	
					$("#beginYear").attr("value", beginYear).parent().show().prev("span").show();
					$("#beginMonth").attr("value", beginMonth).parent().show().prev("span").show();
					$("#endYear").attr("value", endYear).parent().show().prev("span").show();
					$("#endMonth").attr("value", endMonth).parent().show().prev("span").show();
				}else{					
					$("#startdate").attr("value", startdate).parent().show().prev("span").show();
					$("#enddate").attr("value", enddate).parent().show().prev("span").show();	
					$("#beginYear").attr("value", "").parent().hide().prev("span").hide();
					$("#beginMonth").attr("value", "").parent().hide().prev("span").hide();
					$("#endYear").attr("value", "").parent().hide().prev("span").hide();
					$("#endMonth").attr("value", "").parent().hide().prev("span").hide();
				}
				model.dataparams = null;
				model.ontherfilter = null;
			});
		} else if (model.selectDatas == "003") {
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">开始日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="startdate" type="text" name="startdate" class="search-input-length input-height"/></div>');
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">结束日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="enddate" type="text" name="enddate" class="search-input-length input-height"/></div>');
			if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				if (model.ontherfilter.startdate == undefined || model.ontherfilter.startdate == "") {
					$("#startdate").attr("value", "@startDate");
				} else {
					$("#startdate").attr("value", model.ontherfilter.startdate);
				}
				if (model.ontherfilter.enddate == undefined || model.ontherfilter.enddate == "") {
					$("#enddate").attr("value", "@endDate");
				} else {
					$("#enddate").attr("value", model.ontherfilter.enddate);
				}
			} else {
				$("#startdate").attr("value", "@startDate");
				$("#enddate").attr("value", "@endDate");
			}
		} else if (model.selectDatas == "004") {
			$("#ontheroption").append('<span style="padding-right: 15px; font-weight: bold;">基准日期</span>' +
				'<div style="width: 160px;display: inline-block;vertical-align: bottom;">' +
				'<input id="selectdate" type="text" name="selectdate" class="search-input-length input-height"/></div>');
			if (!(model.ontherfilter == undefined || model.ontherfilter == "")) {
				$("#selectdate").attr("value", model.ontherfilter.selectdate);
			} else {
				$("#selectdate").attr("value", "@baseDate");
			}
		}
		var filter_block_content = $(".filter_block").html();
		if (model.filterItems != undefined) {
			var searchFilter = $.parseJSON(model.filterItems);
			for (var i = 0, len = searchFilter.length; i < len; i++) {
				if (i > 0) {
					$("<div class='filter_block'></div>").insertAfter($(".filter_block:last")).append(filter_block_content);
				}
				if (i == searchFilter.length - 1) {
					$(".filter_block:last").find(".icon_add_or").show();
				}
				for (var j = 0, slen = searchFilter[i].length; j < slen; j++) {
					var prop_field = searchFilter[i][j].prop_field;
					var prop_op = searchFilter[i][j].prop_op;
					var prop_value = searchFilter[i][j].prop_value;
					var prompt_value = searchFilter[i][j].prompt_value;
					var field_type = searchFilter[i][j].field_type;
					var prop_text = searchFilter[i][j].prop_text;
					var fieldValue = searchFilter[i][j].fieldValue;
					var uipk = fieldValue.uipk;
					if (i > 0 && j == 0) {
						$(".filter_block:last").find(".filter_field").append('or <div class="text-tag" field_type="' + field_type + '" prop_field="' + prop_field + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"></div>');
					} else {
						$(".filter_block:last").find(".filter_field").append('<div class="text-tag" field_type="' + field_type + '" prop_field="' + prop_field + '" prop_op="' + prop_op + '" prop_value="' + prop_value + '"></div>');
					}
					$(".filter_block:last").find(".filter_field .text-tag:last").append('<span class="text-label">' + prop_text + '</span><span class="text-remove" title="删除" style="display: none;">x</span>');

					if (uipk != null && uipk != "null" && uipk != "undefined") {
						$(".filter_block:last").find(".filter_field .text-tag:last").data("prompt_value", prompt_value);
					}
					$(".filter_block:last").find(".filter_field .text-tag:last").data("fieldValue", fieldValue);
				}
			}
		}
	},

	_addItemEventListener : function (prop_fieldCom) {
		var prop_op_json = {
			id : "prop_op"
		};
		prop_op_json.data = [{
				value : "like",
				alias : "包含"
			}, {
				value : "not like",
				alias : "不包含"
			}, {
				value : "=",
				alias : "等于"
			}, {
				value : "<>",
				alias : "不等于"
			}, {
				value : ">",
				alias : "大于"
			}, {
				value : "<",
				alias : "小于"
			}
		];

		var prop_op_date_json = {
			id : "prop_op"
		};
		prop_op_date_json.data = [{
				value : "=",
				alias : "等于"
			}, {
				value : "<>",
				alias : "不等于"
			}, {
				value : ">",
				alias : "大于"
			}, {
				value : "<",
				alias : "小于"
			}, {
				value : ">=",
				alias : "大于等于"
			}, {
				value : "<=",
				alias : "小于等于"
			}
		];

		var prop_boolean_json = {
			id : "prop_op"
		};
		prop_boolean_json.data = [{
				value : "=",
				alias : "等于"
			}, {
				value : "<>",
				alias : "不等于"
			}
		];
		prop_fieldCom.shrPromptBox("option", {
			onchange : function (e, value) {
				$(this).parents(".ui-promptBox-frame").next().replaceWith('<input id="prop_op" type="text" name="prop_op" class="search-input-length input-height"/>');
				$(this).parents(".ui-promptBox-frame").next().next().replaceWith('<input id="prop_value" type="text" name="prop_value" class="search-input-length input-height"/>');
				var parent = $(this).parents(".ui-promptBox-frame").parent();
				$("#prop_op_down").remove();
				$("#prop_value_down").remove();
				if (value.current != null) {					
					var id = value.current.id;
					var name = value.current.name;
					var type = value.current.type;
					var uipk = value.current.uipk;
					var enumSource = value.current.enumSource;
					var field = value.current.field;
					prop_fieldCom.data('fieldValue', value.current);
					prop_fieldCom.attr("prop_field", field);
					prop_fieldCom.attr("field_type", type);
					if (type == "Date" || type == "TimeStamp") {
						parent.find("#prop_op").shrSelect(prop_op_date_json);
						parent.find("#prop_op").shrSelect("setValue", prop_op_date_json.data[0].value);

						var picker_json = {};
						parent.find("#prop_value").shrDatePicker(picker_json);
					}
					if (type == "Short" || type == "Double" || type == "BigDecimal" || type == "Integer" || type == "Long" || type == "Float" || type == "Int") {
						parent.find("#prop_op").shrSelect(prop_op_date_json);
						parent.find("#prop_op").shrSelect("setValue", prop_op_date_json.data[0].value);
					}
					if (type == "StringEnum" || type == "IntEnum") {
						parent.find("#prop_op").shrSelect(prop_boolean_json);
						parent.find("#prop_op").shrSelect("setValue", prop_boolean_json.data[0].value);

						var select_json = {};
						select_json.id = "prop_value";
						var enumUrl = enumSource;
						if(enumUrl == "com.kingdee.shr.compensation.CalState"){
							select_json.filter = "1,4,8,12,20";
						}
						if(enumUrl && enumUrl.trim().indexOf("url:")==0){
							var url = enumUrl.trim().substr(4);
							select_json.url = url;
						}else{
							select_json.enumSource = enumUrl;
						}
						parent.find("#prop_value").shrSelect(select_json);
					}
					if (type == "Boolean") {
						parent.find("#prop_op").shrSelect(prop_boolean_json);
						parent.find("#prop_op").shrSelect("setValue", prop_boolean_json.data[0].value);

						var select_json = {
							id : "prop_value"
						};
						select_json.data = [{
								value : "1",
								alias : "是"
							}, {
								value : "0",
								alias : "否"
							}
						];
						parent.find("#prop_value").shrSelect(select_json);
					}
					if (type == "String") {
						parent.find("#prop_op").shrSelect(prop_op_json);
						parent.find("#prop_op").shrSelect("setValue", prop_op_json.data[0].value);
						parent.find("#prop_value").css("width", "280px");
						parent.find("#prop_value").attr("placeholder", "多选请使用用逗号分隔");
					}
					if (uipk != null && uipk != "null" && uipk != "undefined") {
						var f7FieldName = value.current.f7FieldName;
						var f7Json = {
							id : "prop_value",
							name : "prop_value"
						};
						if (f7FieldName != undefined) {
							f7Json.displayFormat = "{" + f7FieldName + "}";
						}
						f7Json.subWidgetName = 'shrPromptGrid';
						f7Json.subWidgetOptions = {
							title : name,
							uipk : uipk,
							multiselect : true
						};
						parent.find("#prop_value").shrPromptBox(f7Json);
						parent.find("#prop_value").unbind("keydown.shrPromptGrid");
						parent.find("#prop_value").unbind("keyup.shrPromptGrid");
					}
					$(".select_field >div").addClass("search-emp-field");
					parent.find("#prop_op").shrSelect("option", {
						onChange : function (e, value) {
							$(this).parents(".ui-select-frame").removeClass("oe_focused");
							$("#prop_value").focus();
							if (type == "Boolean" || type == "StringEnum" || type == "IntEnum") {
								$("#prop_value").shrSelect("selectClick");
							}
						}
					});
				}
			}
		});
	},
	getkeyNodes : function (event, dropdownElement) {
		var _self = this;
		var filter_block = $("#prop_value").parents(".filter_block");
		var pos = $("#prop_value").offset();
		dropdownElement.css({
			'left' : pos.left,
			'width' : $("#prop_value").outerWidth() - 2,
			'top' : pos.top + 24,
			'z-index' : 2000
		});
		var key = $("#prop_value").val().trim();
		if (meter != null) {
			window.clearTimeout(meter);
		}
		if (event.keyCode == 118) {
			if ($("#prop_value").parents(".ui-promptBox-frame").length != 0) {
				$("#prop_value").shrPromptBox("open");
			}
		}
		if (event.keyCode == 8) {
			$("#prop_value").prev().val(null);
		}
		if (event.keyCode == 13 && key != "") { //回车键
			if ($("#prop_value").val() != "" && dropdownElement.is(':hidden')) {
				filter_block.find(".icon-ok").click();
			} else {
				var name = dropdownElement.find('li .custom-hover strong').html();
				if (name != null) {
					if ($("#prop_value").val().indexOf(",") > 0) {
						var prop_value = $("#prop_value").val().split(",");
						prop_value.splice((prop_value.length - 1), 1, name);
						$("#prop_value").val(prop_value.join(","));
					} else if ($("#prop_value").val().indexOf("，") > 0) {
						var prop_value = $("#prop_value").val().split("，");
						prop_value.splice((prop_value.length - 1), 1, name);
						$("#prop_value").val(prop_value.join("，"));
					} else {
						$("#prop_value").val(name);
					}
				}
				dropdownElement.hide();
			}
		} else if (event.keyCode == 8 && key == "") { //回格键
			dropdownElement.hide();
		} else if (key != "") {
			if (key != null && ((event.keyCode > 47 && event.keyCode < 106) || event.keyCode == 32 || event.keyCode == 8)) {
				var fields = null;
				if (key.indexOf(",") > 0) {
					key = key.split(",")[key.split(",").length - 1];
				}
				if (key.indexOf("，") > 0) {
					key = key.split("，")[key.split("，").length - 1];
				}
				if ($("#prop_field").attr("prop_field") != null && !filter_block.find(".field_ok").is(':hidden')) {
					meter = window.setTimeout(function () {
							shr.callService({
								serviceName : 'getCompositeMappingFieldValueService',
								param : {
									field : $("#prop_field").attr("prop_field"),
									value : key,
									schemeNum : _self.selectDatas
								},
								async : true,
								success : function (data) {
									if (data.length != 0) {
										fields = data;
									}
									dropdownElement.empty();
									if (fields != null && !filter_block.find(".field_ok").is(':hidden')) {
										for (var i = 0; i < fields.length; i++) {
											dropdownElement.append("<li><a href='#'><strong title='" + fields[i].value + "'>" + fields[i].value + "</strong></a></li>");
										}
										dropdownElement.show();
									} else {
										dropdownElement.hide();
									}
									dropdownElement.find('li a').width("auto");
									dropdownElement.find('li:eq(0) a').addClass("custom-hover");

									dropdownElement.find('li').click(function () {
										var name = $(this).find("strong").html();
										if (name != null) {
											if ($("#prop_value").val().indexOf(",") > 0) {
												var prop_value = $("#prop_value").val().split(",");
												prop_value.splice((prop_value.length - 1), 1, name);
												$("#prop_value").val(prop_value.join(","));
											} else if ($("#prop_value").val().indexOf("，") > 0) {
												var prop_value = $("#prop_value").val().split("，");
												prop_value.splice((prop_value.length - 1), 1, name);
												$("#prop_value").val(prop_value.join("，"));
											} else {
												$("#prop_value").val(name);
											}
										}
										dropdownElement.hide();
									});
									dropdownElement.find('li a').mouseenter(function () {
										dropdownElement.find('li a').removeClass("custom-hover");
										$(this).addClass("custom-hover");
									}).mouseleave(function () {
										if ($(this).hasClass("custom-hover")) {
											$(this).removeClass("custom-hover");
										}
									});
								}
							});
						}, 300);
				}
			}

			if (event.keyCode == 38) {
				dropdownElement.find('li').each(function (index) {
					if ($(this).find("a").hasClass("custom-hover")) {
						$(this).find("a").removeClass("custom-hover");
						if ($(this).prev().length != 0) {
							$(this).prev().find("a").addClass("custom-hover");
						} else {
							$(this).parent().find("li:last a").addClass("custom-hover");
						}
						return false;
					}
				});
			}
			if (event.keyCode == 40) {
				dropdownElement.find('li').each(function (index) {
					if ($(this).find("a").hasClass("custom-hover")) {
						$(this).find("a").removeClass("custom-hover");
						if ($(this).next().length != 0) {
							$(this).next().find("a").addClass("custom-hover");
						} else {
							$(this).parent().find("li:eq(0) a").addClass("custom-hover");
						}
						return false;
					}
					if (!$(this).parent().find("li a").hasClass("custom-hover")) {
						$(this).parent().find("li:eq(0) a").addClass("custom-hover");
						return false;
					}
				});
			}

			if (event.keyCode == 45) {
				if ($("#prop_value").val() != "" && dropdownElement.is(':hidden')) {
					filter_block.find(".icon-ok").click();
					filter_block.find(".field_add").click();
					$("#prop_field").focus();
				}
			}

			if (event.keyCode == 46) {
				filter_block.find(".select_field").empty();
				filter_block.find(".field_add").click();
				$("#prop_field").focus();
			}

		}
	}
});
var meter = null;
