﻿shr.defineClass("shr.report.preViewData", shr.framework.Core, {
	preView: function(model,reportParam,currentDataParaMapping){
		var isshow = true;
		var _self = this;
		this.dateUtils = new shr.report.dateUtils;
		if (model.dataparams != undefined && model.dataparams.length > 0) {
			for (var i = 0; i < model.dataparams.length; i++) {
				if (model.dataparams[i].paramstate != 2) {
					isshow = true;
					break;
				}
			}
			model.dataparams[model.dataparams.length] = {
				paramname : "adminOrg",
				paramdesc : "组织",
				paramtype : "0",
				paramcomp : "4",
				paramvalue : "",
				paramnull : false,
				paramstate : "0",
				paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
			};
		} else {
			model.dataparams = [{
					paramname : "adminOrg",
					paramdesc : "组织",
					paramtype : "0",
					paramcomp : "4",
					paramvalue : "",
					paramnull : false,
					paramstate : "0",
					paramuipk : "com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7;longNumber"
				}
			];
		}
		if (isshow) {
			this.addFilterComponent(model.dataparams,reportParam);
			var show = false;
			var DataParaMapping = jQuery.parseJSON(currentDataParaMapping.param);
			
			for (var i = 0; i < model.dataparams.length; i++) {
				var reportparam = reportParam[0];
				for(var j=0;j<DataParaMapping.length;j++){
					if(DataParaMapping[j].dataparameName.replace(".","_") == model.dataparams[i].paramname){
						reportparam = DataParaMapping[j].reportparam;
						break;
					}
				}
				var isneed = 'false';
				if (!reportparam.is_null || model.dataparams[i].paramname == "adminOrg") {
					isneed = 'true';
				}
				if (model.dataparams[i].paramstate != 2) {
					show = true;
					if (model.dataparams[i].paramcomp == 4) {
						var grid_f7_json = {
							id : model.dataparams[i].paramname,
							name : model.dataparams[i].paramname
						};
						grid_f7_json.subWidgetName = 'shrPromptGrid';
						if (model.dataparams[i].paramuipk != undefined && model.dataparams[i].paramuipk != '') {
							var f7param = model.dataparams[i].paramuipk.split(";");
							grid_f7_json.subWidgetOptions = {
								title : model.dataparams[i].paramdesc,
								uipk : f7param[0],
								query : "",
								filter : "",
								domain : "",
								multiselect : false
							};
							grid_f7_json.autoComplete = false;
							grid_f7_json.readonly = "";
							grid_f7_json.validate = "{required:" + isneed + "}";
							if (f7param.length > 1) {
								grid_f7_json.submitFormat = '{' + f7param[1] + '}';
							} else {
								grid_f7_json.submitFormat = '{id}';
							}
						}
						grid_f7_json.value = {
							id : "",
							name : ""
						};
						$("input[id='"+model.dataparams[i].paramname+"']").shrPromptBox(grid_f7_json);
						$("input[id='"+model.dataparams[i].paramname+"']").attr("value", reportparam.param_default_value );
						$("input[id='"+model.dataparams[i].paramname+"_el']").attr("value", reportparam.param_default_value );
						if (model.dataparams[i].paramname == "adminOrg") {
							$.ajax({
								url : shr.getContextPath() + "/dynamic.do?method=getUserTopAdmin",
								data : {
									uipk : "com.kingdee.shr.report.app.ReportDef.list"
								},
								success : function (data) {
									$("#adminOrg").shrPromptBox("setValue", data);
								}
							});
						}
					} else if (model.dataparams[i].paramcomp == 0) {
						var text_json = {
							id : model.dataparams[i].paramname,
							name : model.dataparams[i].paramname,
							readonly : "",
							value : "",
							validate : "{maxlength:255,required:" + isneed + "}",
							onChange : null
						};
						$("input[id^='"+model.dataparams[i].paramname+"']").shrTextField(text_json);
						$("input[id^='"+model.dataparams[i].paramname+"']").attr("value",reportparam.param_default_value);

					} else if (model.dataparams[i].paramcomp == 1) {
						if (model.dataparams[i].paramtype == "3" || model.dataparams[i].paramtype == 3) {
							var select_json = {
								id : model.dataparams[i].paramname
							};
							select_json.data = [{
									value : "1",
									alias : "是"
								}, {
									value : "0",
									alias : "否"
								}
							];
							select_json.validate = "{required:" + isneed + "}";
							$("input[id='"+model.dataparams[i].paramname+"']").shrSelect(select_json);
							if (model.dataparams[i].paramvalue == "1" || model.dataparams[i].paramvalue == "是") {
								$("input[id='"+model.dataparams[i].paramname+"']").shrSelect("setValue", select_json.data[0].value);
							} else if (model.dataparams[i].paramvalue == "0" || model.dataparams[i].paramvalue == "否") {
								$("input[id='"+model.dataparams[i].paramname+"']").shrSelect("setValue", select_json.data[1].value);
							} else {
								$("input[id='"+model.dataparams[i].paramname+"']").shrSelect("setValue", "");
							}
						} else if (model.dataparams[i].paramtype == "0" || model.dataparams[i].paramtype == "1"
							 || model.dataparams[i].paramtype == 0 || model.dataparams[i].paramtype == 1) {
							if (model.dataparams[i].paramuipk && model.dataparams[i].paramuipk != "") {
								var select_json = {
									id : model.dataparams[i].paramname
								};
								var enumUrl = model.dataparams[i].paramuipk;
								if (enumUrl == "com.kingdee.shr.compensation.CalState") {
									select_json.filter = "1,4,8,12,20";
								}
								if (enumUrl && enumUrl.trim().indexOf("url:") == 0) {
									var url = enumUrl.trim().substr(4);
									select_json.url = url;
								} else {
									select_json.enumSource = enumUrl;
								}
								select_json.validate = "{required:" + isneed + "}";
								$("input[id='"+model.dataparams[i].paramname+"']").shrSelect(select_json);
								//$("input[id^='"+model.dataparams[i].paramname+"']").attr("value", model.dataparams[i].paramvalue);
								//$("input[id^='"+model.dataparams[i].paramname+"']").shrSelect("setValue", model.dataparams[i].paramvalue);
								//if($('#' + model.dataparams[i].paramname).shrSelect("getData").length >0){
								
								if(reportparam.param_default_value == undefined || reportparam.param_default_value == ""){
									$("input[id='"+model.dataparams[i].paramname+"']").attr("value","");
								}else{
									var data_tmp = $('#' + model.dataparams[i].paramname).shrSelect("getData");
									var value = "";
									var idx = 0;
									for(var index=0;index<data_tmp.length;index++){
										if(data_tmp[index].alias == reportparam.param_default_value){
											value = data_tmp[index].value;
											idx = index;
											break;
										}
									}
									$("input[id='"+model.dataparams[i].paramname+"']").shrSelect("setValue",value);
								}
							}
						}
					} else if (model.dataparams[i].paramcomp == 2) {
						var picker_json = {
							id : model.dataparams[i].paramname
						};
						picker_json.tagClass = 'block-father input-height';
						picker_json.validate = '{dateISO:true,required:' + isneed + '}';
						$("input[id^='"+model.dataparams[i].paramname+"']").shrDatePicker(picker_json);
						var date = this.dateUtils.getdate(reportparam.param_default_value);
						if(date == 'null' || date == undefined || date==null){
							date = "";
						}
						$("input[id^='"+model.dataparams[i].paramname+"']").attr("value", date);
					}
				}
			}
			if (show) {
				hashShow = true;
				var buttonpane = $('#dialog_report').parent().find(".ui-dialog-buttonpane");
				if(buttonpane.find(".plugView").length > 0){
					buttonpane.find(".plugView").empty();
				}
				$('#dialog_report').dialog({
					title : '选择过滤条件',
					width : 840,
					height : 600,
					resizable : false,
					buttons : {
						'确定' : function () {
							var allParam = [];
							if (!_self.checkNullValue(model.dataparams)) {
								return;
							}
							for (var i = 0; i < model.dataparams.length; i++) {
								if (model.dataparams[i].paramstate != 2) {
									if (model.dataparams[i].paramcomp == 4 || model.dataparams[i].paramcomp == 1) {
										//model.dataparams[i].curentValue = $('#' + model.dataparams[i].paramname + "_el").val();
										model.dataparams[i].curentValue = $("input[id^='"+model.dataparams[i].paramname + "_el"+"']").val();
									} else if (model.dataparams[i].paramcomp == 2) {
										model.dataparams[i].curentValue = $('#' + model.dataparams[i].paramname).val().replace(/\//g, "-");
									} else {
										model.dataparams[i].curentValue = $('#' + model.dataparams[i].paramname).val();
									}
								}
							}
							if ($.block) {
								$.block.show({
									text : '正在加载，请稍候...'
								});
							}
							_self.getViewData(model);
							if (model.dataparams[model.dataparams.length - 1] && model.dataparams[model.dataparams.length - 1].paramname == "adminOrg") {
								model.dataparams.pop();
							}
							$(this).dialog('close');
						},
						'取消' : function () {
							if (model.dataparams[model.dataparams.length - 1] && model.dataparams[model.dataparams.length - 1].paramname == "adminOrg") {
								model.dataparams.pop();
							}
							$(this).dialog('close');
							hashShow = false;
						}
					},
					close : function () {
						if (model.dataparams[model.dataparams.length - 1] && model.dataparams[model.dataparams.length - 1].paramname == "adminOrg") {
							model.dataparams.pop();
						}
						hashShow = false;
					}
				});
			} else {
				$(".report_filter").empty();
			}
		} else {
			if ($.block) {
				$.block.show({
					text : '正在加载，请稍候...'
				});
			}
			_self.getViewData(model);
		}
	},
	
	addFilterComponent : function (data,reportParam) {
		var router = 0;
		var xml;
		$(".report_filter").empty();
		for (var i = 0; i < data.length; i++) {
			var ins = data[i].paramdesc;;// 过滤条件提示信息
			var paramMapping = reportParam;
			var paramname = data[i].paramname;
			for(var j=0,size = paramMapping.length; j<size; j++){
				if(paramMapping[j].param_value.replace(".","_") == paramname &&  paramMapping[j].ins != ""){
					ins = paramMapping[j].ins;
					break;
				}
			}
			if (data[i].paramstate != 2) {
				router++;
				var isneed = 'false';
				if (!data[i].paramnull) {
					isneed = 'true';
				}
				if (data[i].paramtype == 0 && data[i].paramcomp == 4) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" name="' + data[i].paramname + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" name="' + data[i].paramname + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].paramtype == 0) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" class="block-father input-height" type="text" name="' + data[i].paramname + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" class="block-father input-height" type="text" name="' + data[i].paramname + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].paramtype == 1) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" class="block-father input-height" type="text" name="' + data[i].paramname + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" class="block-father input-height" type="text" name="' + data[i].paramname + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].paramtype == 2) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" name="' + data[i].paramname + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].paramname + '" name="' + data[i].paramname + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].paramtype == 3) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc  + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].paramname + '" name="' + data[i].paramname + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
								 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].paramdesc + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].paramname + '" name="' + data[i].paramname + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
								 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				}
			}
		}
		if (router % 2 == 1 && xml != null) {
			$(".report_filter").append(xml + '</div>');
		}
	},
	
	getViewData : function (model) {
		var _self = this;
		shr.remoteCall({
			uipk : 'com.kingdee.eas.rpts.ctrlsqldesign.app.KSQLReport.form',
			method : 'preView',
			param : {
				col_field : JSON.stringify(model.field_list),
				searchFilter : model.filterItems,
				selectDatas : model.selectDatas,
				querySql : model.querySql,
				customsql : model.customsql,
				grouptype : $("input[name='outputMode']:checked").val(),
				ontherfilter : JSON.stringify(model.ontherfilter),
				otheroption : JSON.stringify(model.other_option),
				paramsDate : JSON.stringify(model.dataparams)
			},
			success : function (data) {
				if (data.error != undefined && data.error == "error") {
					shr.showError({
						message : data.summary,
						hideAfter : 3
					});
					if ($.block) {
						$.block.hide();
					}
					return;
				}
				var queryData = data.data;
				var outputColumn = data.outputColumn;
				if (queryData == undefined || outputColumn == undefined) {
					return;
				}
				$("#table").remove();
				$("#table").remove();
				$('#preView').parent().append('<div id="table"><table id="preViewGrid" class=""></table></div>');
				var infos = {};
				infos.head = [];
				for (var i = 0; i < outputColumn.length; i++) {
					var record = outputColumn[i];
					if (model.field_list && !(model.customsql || model.customsql == true || model.customsql == "true")) {
						for (var j = 0; j < model.field_list.length; j++) {
							if (model.field_list[j].prop_field.toUpperCase() == record.columnName) {
								record.columnLabel = model.field_list[j].outParameDes;
							}
						}
					} else {
						if (!(model.outputColumn == undefined || model.outputColumn == "")) {
							for (var j = 0; j < model.outputColumn.length; j++) {
								if (model.outputColumn[j].columnName == record.columnName) {
									record.columnLabel = model.outputColumn[j].columnLabel;
								}
							}
						}
					}
					infos.head[i] = {
						name : record.columnName,
						label : record.columnLabel,
						width : 100,
						align : "left",
						hidden : false,
						key : false,
						frozen : false
					}
				}
				model.outputColumn = outputColumn;
				infos.datas = [];
				infos.datas = data.data;
				_self.createTableForPreview(infos);
			}
		});
	},
	
	createTableForPreview : function (infos) {
		$('#table').dialog({
			title : '数据预览',
			width : 840,
			height : 600,
			resizable : false,
			buttons : {
				'确定' : function () {

					$(this).dialog('close');
				}
			},
			close : function () {
				$(this).dialog('close');
			}
		});
		var head = infos.head;
		var colNames = [],
		colModel = [],
		dataGrid_option = {},
		columnModel = '',
		gridId = 'preViewGrid';
		for (var i = 0; i < head.length; i++) {
			columnModel += head[i].name + ",";
			colNames.push(head[i].label);
			var columnOptions = {
				name : head[i].name,
				label : head[i].label,
				//width : head[i].width,
				width : head.length>10?head[i].width:800/head.length,
				align : head[i].align,
				hidden : head[i].hidden,
				key : head[i].key,
				frozen : head[i].frozen,
				fixed : true
			};
			colModel.push(columnOptions);
		}

		var url = shr.getContextPath();
		url = url + '';

		dataGrid_option = {
			url : url,
			uipk : "",
			query : "",
			sorterItems : "number",
			datatype : "local",
			filter : "",
			colNames : colNames,
			jsonReader : {
				repeatitems : false
			},
			colModel : colModel,
			data : infos.datas,
			columnModel : columnModel,
			pagerpos : 'center',
			rowNum : 50,
			customPager : '#gridPager',
			//height : '' + ($(window).height() - 350),
			height : 'auto',
			//width : '' + ($(window).width() - 143),
			width : 'auto',
			autowidth : false,
			rowList : [50, 100, 200],
			multiselect : false,
			recordpos : 'left',
			pginputpos : 'right',
			recordtext : '({0}-{1})/{2}',
			gridview : true,
			pginput : true,
			rownumbers : true,
			viewrecords : true,
			shrinkToFit : false,
			mtype : 'POST'
		};
		dataGrid_option.loadComplete = function (ret) {
			if ($("#gridPager").html() == "" && "true" == "true") {
				$("#preViewGrid").setCustomPager("#gridPager");
			}

			shr.setIframeHeight();

			$('#gridPager_left').click(function () {
				$('.ui-pg-selbox').show();
				$(this).children('.ui-paging-info').hide();
			});

			if ($.isFunction(jsBinder.gridLoadComplete)) {
				jsBinder.gridLoadComplete.call(this, ret);
			}
		};

		dataGrid_option.onPaging = function () {
			$('.ui-pg-selbox').hide();
			$('#gridPager_left').children('.ui-paging-info').show();
		};
		$("#preViewGrid").jqGrid(dataGrid_option);

		$("#preViewGrid").jqGrid("resizeGrid", {
			base : $("#preViewGrid"),
			offset : 0
		});

	},
	
	checkNullValue : function (queryData) {
		var currentValue;
		for (var i = 0; i < queryData.length; i++) {
			if (queryData[i].paramstate != 2) {
				if (queryData[i].paramcomp != null && (queryData[i].paramcomp == 4 || queryData[i].paramcomp == 1)) {
					currentValue = $("[id='" + queryData[i].paramname + "']").prev().val()||$("input[id='"+queryData[i].paramname+"']").shrPromptBox("getValue").number;
				} else {
					currentValue = $("[id='" + queryData[i].paramname + "']").val();
				}
				if (!queryData[i].paramnull && (currentValue == null || currentValue == undefined || currentValue == "null" || currentValue == "")) {
					shr.showError({
						message : '请输入' + queryData[i].paramdesc,
						hideAfter : 3
					});
					return false;
				}
				
				// 日期型控件要保证输入的日期合法
				if((queryData[i].designDataType == 2 || queryData[i].designDataType == "2") && !queryData[i].isAllowNull){
					var date = new Date(currentValue);
					if(!date.getFullYear() || date.getFullYear() > 9999){
						shr.showError({
							message : queryData[i].paramdesc + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
					if(date.getMonth() >11 || date.getMonth() < 0){
						shr.showError({
							message : queryData[i].paramdesc + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
					if(date.getDate() > 31 || date.getDate() < 1){
						shr.showError({
							message : queryData[i].paramdesc + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
				}
				
			}
		}
		return true;
	},
});