﻿shr.defineClass("shr.report.reportBase", shr.framework.Core, {
	_navi : null,
	_self : null,
	reportParam :null,
	datasources : null,
	IsEdit :null,
	initalizeDOM:function(){
		shr.report.reportBase.superClass.initalizeDOM.call(this);
		_self = this;
		// 获取所有businessType
		$.ajax({
			url: shr.getContextPath() + "/dynamic.do?method=getAllBusiness",
			async:false,
			data: {   
				uipk : "com.kingdee.shr.report.app.ReportDef.list",
			},
			success: function(data) {
				var select_json = {
					id : "reportmk"
				};
				var business =[];
				for(var i=0; i < data.length; i++ ){
					business [i] = {
						value : data[i].id,
						alias : data[i].name
					}
				}
				select_json.data = business;
				select_json.validate = "{required:true}";
				$('#reportmk').shrSelect(select_json);
				// 设置默认的所属模块为员工
				var index = 0;
				for(var i=0;i<business.length;i++){
					if(business[i].alias == "员工管理"){
						index = i;
						break;
					}
				}
				
				$('#reportmk').shrSelect("setValue", business [index].value);
			}
		});	
	},
	
	
	
	dsSaveAction: function() {
		var _navi = this._navi;
		var reportName = $("#reportName").val();
		var reportDesc = $("#reportDesc").val();
		var reportId = _navi.getParm("reportId");
		var defaultDS = $("#defaultDS").shrPromptBox("getValue");
		var adminOrg = $("#adminOrg").shrPromptBox("getValue");
		var bussinessName = $("#reportmk").val();
		if(reportName == ""){
			shr.showError(
			{
				message: "请填写报表名称",
				hideAfter: 3
			});
			return false;
		}
		
		// 判断报表名称是否包含非法字符
		if(_self.checkIllegalChar(reportName)){
			shr.showError({
				message: "名称不可包含以下特殊字符！('!@#$%^&*-+=:/\\空格)",
				hideAfter: 5
			});
			$("#reportName").focus();
			return false;
		}
		
		var ischange = true;
		/*
		if(reportId == undefined || reportId == null || reportId == ""){
			ischange = true;
		}else{
			if(reportName == _navi.getParm("reportName") && reportDesc == _navi.getParm("reportDesc") && adminOrg == _navi.getParm("adminOrg") && bussinessName == _navi.getParm("reportMk")){
				ischange = false;
			}else{
				ischange = true;
			}
		}
		*/
		if(ischange){
			$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=saveReport",
				async:false,
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					reportId : reportId,
					reportName : reportName,
					reportDesc : reportDesc,
					defaultDS : JSON.stringify(defaultDS),
					adminOrg : JSON.stringify(adminOrg),
					bussinessName : bussinessName
				},
				success: function(data) {
					if(data.data != undefined && data.data != null){
						_self._navi.setParm("reportId",data.data);
						shr.showInfo({
							message: "保存成功",
							hideAfter: 3
						});
					}else{
						if(data.summary != undefined ){
							shr.showError({
								message: data.summary,
								hideAfter: 3
							});
						}else{
							shr.showError({
								message: data,
								hideAfter: 3
							});
						}
					}
				}
			});
		}
	},
	
	onNext:function(_wizard){
		
		var reportName = $("#reportName").val();
		var reportId = _self._navi.getParm("reportId");
		var issame = false;

		if((reportName == "" || reportName == null)&&reportName != undefined && this.IsEdit == "true"){
			shr.showError({
				message: "名称不可为空",
				hideAfter: 3
			});
			return {status: 0};
		}
		// 判断报表名称是否包含非法字符
		if(_self.checkIllegalChar(reportName)){
			shr.showError({
				message: "名称不可包含非法字符！",
				hideAfter: 3
			});
			$("#reportName").focus();
			return {status: 0};
		}
		
		
		if(($("#reportmk").val() == "" || $("#reportmk").val() == null) && this.IsEdit == "true" ){
			shr.showError({
				message: "所属模块不能为空",
				hideAfter: 3
			});
			return {status: 0};
		}
		
		if(($("#adminOrg").val() == "" || $("#adminOrg").val() == null) && this.IsEdit == "true"){
			shr.showError({
				message: "所属组织不能为空",
				hideAfter: 3
			});
			return {status: 0};
		}
		
		$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=existReport",
				async:false,
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					reportId : reportId,
					reportName : reportName
				},
				success: function(data) {
					if(data.data != undefined && (data.data == true || data.data == 'true')){
						shr.showError({
							message: "已存在相同名字报表",
							hideAfter: 3
						});
						issame = true;
						return{status: 0};
					}
				}
			});		
		if(issame){
			return;
		}
		
		_wizard.setParm("reportName", reportName);
		
		var reportDesc = $("#reportDesc").val();
		_wizard.setParm("reportDesc", reportDesc);
		
		var reportMk = $("#reportmk").val();
		_wizard.setParm("reportMk", reportMk);
		
		var defaultDS = $("#defaultDS").shrPromptBox("getValue");
		_wizard.setParm("defaultDS", JSON.stringify(defaultDS));
		
		var adminOrg = $("#adminOrg").shrPromptBox("getValue");
		_wizard.setParm("adminOrg", adminOrg);
		
		// 保存
		_self.dsSaveAction();
	  
		// 获取报表参数
		$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=getReportParam",
				async:false,
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					reportId : _self._navi.getParm("reportId"),
				},
				success: function(data) {
					_wizard.setParm("reportParam",JSON.stringify(data));
				}
			});		
		
		
		// 获取报表关联的数据源
		$.ajax({
			url: shr.getContextPath() + "/dynamic.do?method=getReportDefDatasByID",
			async:false,
			data: {
				uipk : "com.kingdee.shr.report.app.ReportDef.list",
				reportId : _self._navi.getParm("reportId")
			},
			success: function(data) {
				_wizard.setParm("_datasources",data);
			}
		});
		
		if(this.IsEdit != null){
			_wizard.setParm("IsEdit",this.IsEdit);
		}
		
		 return {status: 1};
	},
	
	onNaviLoad:function(_navi){	
		var _self = this;
		_self._navi = _navi;
		if( $('#breadcrumb').length == 0 ){
			$(".wz_navi").before("<div class='view_mainPage'><ul id='breadcrumb' class='breadcrumb' data-breadcrumbType=''></ul></div>");
		}
		if (shr.isWorkareaFrame() || shr.isWizardFrame()) {
			var breadcrumb = $('#breadcrumb').shrBreadcrumb();
			breadcrumb.shrBreadcrumb('addItem', {name: '报表定义'});
		}
		var reportName = _navi.getParm("reportName");
		var reportDesc = _navi.getParm("reportDesc");
		var defaultDS = _navi.getParm("defaultDS");
		var adminOrg = _navi.getParm("adminOrg");
		var reportId = _navi.getParm("reportId");
		var reportMk = _navi.getParm("reportMk");
		var params = $.parseJSON($('#workArea', window.parent.document).attr('params'));
		this.IsEdit = sessionStorage.getItem('IsEdit');
		if( params == undefined ){
			params = $.parseJSON(sessionStorage.getItem('reportParams'));
		}
		
		var grid_f7_json = {id:"defaultDS",name:"defaultDS"};
		grid_f7_json.subWidgetName = 'shrPromptGrid';
		grid_f7_json.subWidgetOptions = {title:"数据集",uipk:"com.kingdee.shr.report.app.PersonDataSourceDef.list",query:"",filter:"id in (select FPersonDSID from T_SHR_ReportDatas where FReportDefID = '"+reportId+"')",domain:"",multiselect:false};
		grid_f7_json.readonly = '';
		grid_f7_json.validate = '{required:false}';
		grid_f7_json.value = {id:"",name:""};
		$('#defaultDS').shrPromptBox(grid_f7_json);	
		adminOrg
		var admin_f7_json = {id:"adminOrg",name:"adminOrg"};
		admin_f7_json.subWidgetName = 'shrPromptGrid';
		admin_f7_json.subWidgetOptions = {title:"行政组织",uipk:"com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7",query:"",filter:"",domain:"",multiselect:false};
		admin_f7_json.readonly = '';
		admin_f7_json.validate = '{required:false}';
		admin_f7_json.value = {id:"",name:""};
		$('#adminOrg').shrPromptBox(admin_f7_json);	
		if(adminOrg != undefined && adminOrg != "" && adminOrg != '""'){
			$('#adminOrg').shrPromptBox("setValue",adminOrg);
		}else{
			$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=getUserTopAdmin",
				async:false,
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form"
				},
				success: function(data) {
					$('#adminOrg').shrPromptBox("setValue",data);
				}
			});
		}
		if((params == undefined || params == null || params == "null") && reportName == undefined){
			this.IsEdit = "true";
			$("#reportType").val("否");
			$("#reportType").attr("disabled",true);
			$("#reportType").parent().css({"border":"0px"});
			return;
		}
		if(reportName == undefined || reportName == ""&& (params != undefined || params != null)){
			reportName = params.name;
			_navi.setParm("reportName",reportName);
		}
		
		if(reportDesc == undefined || reportDesc == ""&& (params != undefined || params != null)){
			reportDesc = params.description;
			_navi.setParm("reportDesc",reportDesc);
		}
		if(defaultDS == undefined || defaultDS == ""&& (params != undefined || params != null)){
			defaultDS = params.defaultDS;
			_navi.setParm("defaultDS",defaultDS);
		}
		if(adminOrg == undefined || adminOrg == ""&& (params != undefined || params != null)){
			adminOrg = params.adminOrg;
			_navi.setParm("adminOrg",adminOrg);
		}
		
		if(reportMk == undefined || reportMk == ""&& (params != undefined || params != null)){
			reportMk = params.reportMk;
			_navi.setParm("reportMk",reportMk);
		}
		
		if( params != undefined ){
			$(".wz_navi_step").addClass("enabled");
		}
		if(params != undefined){
			$("#reportName").val(params.name);
			$("#reportDesc").val(params.description);
			if(params.id == null){
				$("#reportName").val(params.name + "-复制");
			}
		}
		if(reportId == undefined || reportId == ""){
			reportId = params.id;
			_navi.setParm("reportId",reportId);
		}
		if(reportName != undefined){
			$("#reportName").val(reportName);
		}
		if(reportDesc != undefined){
			$("#reportDesc").val(reportDesc);
		}
		if(reportMk != undefined){
			$("#reportmk").val(reportMk);
		}
		if(reportId == undefined ){
			reportId = "";
		}
		if(defaultDS != undefined && defaultDS != ""){
			$('#defaultDS').shrPromptBox("setValue",$.parseJSON(defaultDS));
		}
		if(adminOrg != undefined && adminOrg != ""){
			if(typeof adminOrg == 'string'){ // 如果获取的是字串型数据则转换成对象
			adminOrg = jQuery.parseJSON(adminOrg);
			}
			$('#adminOrg').shrPromptBox("setValue",adminOrg);
		}
		// 报表类型
		if(params == null){
			$("#reportType").val("否");
		}else{
			if(params.reportType == "system"){
				$("#reportType").val("是");	
			}else{
				$("#reportType").val("否");
			}
		}
		$("#reportType").attr("disabled",true);
		$("#reportType").parent().css({"border":"0px"});
		this.reportParam = params.reportparam;
		//根据是否具有编辑权限，判断是否需要加上遮罩层
		if(this.IsEdit == false || this.IsEdit == "false"){
			$("#reportName").attr("disabled",true);
			$("#reportDesc").attr("disabled",true);
			$("#reportmk").attr("disabled",true);
			$("#adminOrg").attr("disabled",true);
			$("[name='dsSave']").hide();
			$('#adminOrg').shrPromptBox("disable");
			$("#reportmk").shrSelect("disable");
		}else{
			$("#reportName").attr("disabled",false);
			$("#reportDesc").attr("disabled",false);
			$("#reportmk").attr("disabled",false);
			$("#adminOrg").attr("disabled",false);
			$("[name='dsSave']").show();
			$('#adminOrg').shrPromptBox("enable");
			$("#reportmk").shrSelect("enable");
		}
	},
	checkIllegalChar :function (str){
		var pattern = new RegExp("['!@#$%^&*-+=:/\]");
		if(pattern.test(str)){
			return true;
		}else{
			return false;
		}
	}
});