﻿shr.defineClass("shr.report.reportSave", shr.framework.Core, {
	_navi : null,
	_self : null,
	initalizeDOM:function(){
		shr.report.reportSave.superClass.initalizeDOM.call(this);
		_self = this;
	},
	
	
	
	dsSaveAction: function() {
		var _navi = this._navi;
		var reportName = $("#reportName").val();
		var reportDesc = $("#reportDesc").val();
		var reportId = _navi.getParm("reportId");
		var defaultDS = $("#defaultDS").shrPromptBox("getValue");
		var adminOrg = $("#adminOrg").shrPromptBox("getValue");
		
		if(reportName == ""){
			shr.showError(
			{
				message: "请填写数据集名称",
				hideAfter: 3
			});
			return false;
		}
		var ischange = false;
		if(reportId == undefined || reportId == null || reportId == ""){
			ischange = true;
		}else{
			if(reportName == _navi.getParm("reportName") && reportDesc == _navi.getParm("reportDesc") && adminOrg == _navi.getParm("adminOrg")){
				ischange = false;
			}else{
				ischange = true;
			}
		}
		if(ischange){
			$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=saveReport",
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					reportId : reportId,
					reportName : reportName,
					reportDesc : reportDesc,
					defaultDS : JSON.stringify(defaultDS),
					adminOrg : JSON.stringify(adminOrg)
				},
				success: function(data) {
					if(data.data != undefined && data.data != null){
						_self._navi.setParm("reportId",data.data);
						shr.showInfo({
							message: "保存成功",
							hideAfter: 3
						});
					}else{
						if(data.summary != undefined ){
							shr.showError({
								message: data.summary,
								hideAfter: 3
							});
						}else{
							shr.showError({
								message: data,
								hideAfter: 3
							});
						}
					}
				}
			});
		}
	},
	
	onNext:function(_wizard){	
		var reportName = $("#reportName").val();
		var reportId = _self._navi.getParm("reportId");
		var issame = false;
		/*
		if(reportName == undefined || reportName == "" || reportName == null){
			shr.showError({
				message: "名称不可为空",
				hideAfter: 3
			});
			return {status: 0};
		}
		*/
		if((reportName == "" || reportName == null)&&reportName != undefined ){
			shr.showError({
				message: "名称不可为空",
				hideAfter: 3
			});
			return {status: 0};
		}
		

		$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=existReport",
				async:false,
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					reportId : reportId,
					reportName : reportName
				},
				success: function(data) {
					if(data.data != undefined && (data.data == true || data.data == 'true')){
						shr.showError({
							message: "已存在相同名字报表",
							hideAfter: 3
						});
						issame = true;
						return{status: 0};
					}
				}
			});		
		if(issame){
			return;
		}
		_wizard.setParm("reportName", reportName);
		
		var reportDesc = $("#reportDesc").val();
		_wizard.setParm("reportDesc", reportDesc);
		
		var defaultDS = $("#defaultDS").shrPromptBox("getValue");
		_wizard.setParm("defaultDS", JSON.stringify(defaultDS));
		
		var adminOrg = $("#adminOrg").shrPromptBox("getValue");
		_wizard.setParm("adminOrg", JSON.stringify(adminOrg));
		
		_self.dsSaveAction();
	    return {status: 1};
	},
	
	onNaviLoad:function(_navi){	
		var _self = this;
		_self._navi = _navi;
		if( $('#breadcrumb').length == 0 ){
			$(".wz_navi").before("<div class='view_mainPage'><ul id='breadcrumb' class='breadcrumb' data-breadcrumbType=''></ul></div>");
		}
		if (shr.isWorkareaFrame() || shr.isWizardFrame()) {
			var breadcrumb = $('#breadcrumb').shrBreadcrumb();
			breadcrumb.shrBreadcrumb('addItem', {name: '报表定义'});
		}
		var reportName = _navi.getParm("reportName");
		var reportDesc = _navi.getParm("reportDesc");
		var defaultDS = _navi.getParm("defaultDS");
		var adminOrg = _navi.getParm("adminOrg");
		var reportId = _navi.getParm("reportId");
		var params = $.parseJSON($('#workArea', window.parent.document).attr('params'));
		if( params == undefined ){
			params = $.parseJSON(sessionStorage.getItem('reportParams'));
		}
		var grid_f7_json = {id:"defaultDS",name:"defaultDS"};
		grid_f7_json.subWidgetName = 'shrPromptGrid';
		grid_f7_json.subWidgetOptions = {title:"数据集",uipk:"com.kingdee.shr.report.app.PersonDataSourceDef.list",query:"",filter:"id in (select FPersonDSID from T_SHR_ReportDatas where FReportDefID = '"+reportId+"')",domain:"",multiselect:false};
		grid_f7_json.readonly = '';
		grid_f7_json.validate = '{required:false}';
		grid_f7_json.value = {id:"",name:""};
		$('#defaultDS').shrPromptBox(grid_f7_json);	
		adminOrg
		var admin_f7_json = {id:"adminOrg",name:"adminOrg"};
		admin_f7_json.subWidgetName = 'shrPromptGrid';
		admin_f7_json.subWidgetOptions = {title:"行政组织",uipk:"com.kingdee.eas.basedata.org.app.AdminOrgUnit.F7",query:"",filter:"",domain:"",multiselect:false};
		admin_f7_json.readonly = '';
		admin_f7_json.validate = '{required:false}';
		admin_f7_json.value = {id:"",name:""};
		$('#adminOrg').shrPromptBox(admin_f7_json);	
		if(adminOrg != undefined && adminOrg != "" && adminOrg != '""'){
			$('#adminOrg').shrPromptBox("setValue",$.parseJSON(adminOrg));
		}else{
			$.ajax({
				url: shr.getContextPath() + "/dynamic.do?method=getUserTopAdmin",
				async:false,
				data: {
					uipk : "com.kingdee.shr.report.app.ReportDef.form"
				},
				success: function(data) {
					$('#adminOrg').shrPromptBox("setValue",data);
				}
			});
		}
		if((params == undefined || params == null || params == "null") && reportName == undefined){
			return;
		}
		if(reportName == undefined || reportName == ""&& (params != undefined || params != null)){
			reportName = params.name;
			_navi.setParm("reportName",reportName);
		}
		
		if(reportDesc == undefined || reportDesc == ""&& (params != undefined || params != null)){
			reportDesc = params.description;
			_navi.setParm("reportDesc",reportDesc);
		}
		if(defaultDS == undefined || defaultDS == ""&& (params != undefined || params != null)){
			defaultDS = params.defaultDS;
			_navi.setParm("defaultDS",defaultDS);
		}
		if(adminOrg == undefined || adminOrg == ""&& (params != undefined || params != null)){
			adminOrg = params.adminOrg;
			_navi.setParm("adminOrg",adminOrg);
		}
		if( params != undefined ){
			$(".wz_navi_step").addClass("enabled");
		}
		if(params != undefined){
			$("#reportName").val(params.name);
			$("#reportDesc").val(params.description);
			if(params.id == null){
				$("#reportName").val(params.name + "-复制");
			}
		}
		if(reportId == undefined || reportId == ""){
			reportId = params.id;
			_navi.setParm("reportId",reportId);
		}
		if(reportName != undefined){
			$("#reportName").val(reportName);
		}
		if(reportDesc != undefined){
			$("#reportDesc").val(reportDesc);
		}
		if(reportId == undefined ){
			reportId = "";
		}
		if(defaultDS != undefined && defaultDS != ""){
			$('#defaultDS').shrPromptBox("setValue",$.parseJSON(defaultDS));
		}
	}
});