﻿shr.defineClass("shr.report.reportTemplates", shr.framework.Core, {
	_navi : null,
	_self : null,
	IsEdit : null,
	initalizeDOM : function () {
		shr.report.reportTemplates.superClass.initalizeDOM.call(this);
		$(".text-tag").live("mouseenter", function (e) {
			$(this).find(".text-remove").show();
		}).live("mouseleave", function (e) {
			$(this).find(".text-remove").hide();
		});
		var _self = this;
		this.dateUtils = new shr.report.dateUtils;
		//删除模板
		$(".template_list").find(".text-remove").die("click").live("click", function (e) {
			if($(this).attr("remove") == "false" || $(this).attr("remove") == false){
				return;
			}
			var boid = $(this).prev().attr("templateid");
			var self = this;
			if (boid == undefined) {
				$(self).parent().remove();
			} else {
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=removeTemplate",
					data : $.param({
						boid : boid,
						objid : _self._navi.getParm("reportId"),
						uipk : "com.kingdee.shr.report.app.ReportDef.form"
					}),
					success : function (data) {
						if(data.data != undefined && data.data.error != undefined && data.data.error != null && data.data.error != ""){
							shr.showError({
								message : data.data.error
							});
							return;
						}
						$(self).parent().remove();
						$(".export_template_list").find(".text-label[templateid='" + boid + "']").parent().remove();
						$(".export_field").empty();
					}
				});
			}
		});

		$(".export_template_list").find(".text-remove").die("click").live("click", function (e) {
			if($(this).attr("remove") == "false" || $(this).attr("remove") == false){
				return;
			}
			var boid = $(this).prev().attr("templateid");
			var self = this;
			$.ajax({
				url : shr.getContextPath() + "/dynamic.do?method=removeTemplate",
				data : $.param({
					boid : boid,
					uipk : "com.kingdee.shr.report.app.ReportDef.form"
				}),
				success : function (data) {
					$(".template_list").find(".text-label[templateid='" + boid + "']").parent().remove();
					$(self).parent().remove();
					$(".export_field").empty();
					$(".template_field").empty();
				}
			});
		});

		$(".template_list").find(".text-tag").die("click").live("click", function () {
			if (!$(this).hasClass("template_pressed")) {
				$(".template_list .text-tag").removeClass("template_pressed");
				$(".template_list .text-label").removeClass("text_label_pressed");
				$(this).addClass("template_pressed");
				$(this).find(".text-label").addClass("text_label_pressed");
			}else{
				$(".template_list .text-tag").removeClass("template_pressed");
				$(".template_list .text-label").removeClass("text_label_pressed");
			}
	
		});

		$(".export_template_list").find(".text-tag").die("click").live("click", function () {
			$(".export_template_list .text-tag").removeClass("template_pressed");
			$(this).addClass("template_pressed");

			var boid = $(this).find(".text-label").attr("templateId");
			$(".template_list").find(".text-label[templateId='" + boid + "']").parent().click();
			$.ajax({
				url : shr.getContextPath() + "/dynamic.do?method=getTemplateFiles",
				data : $.param({
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					boid : boid
				}),
				success : function (data) {
					$(".export_field").empty();
					for (var i in data) {
						$(".export_field").append('<div class="text-tag"><span class="text-label" title="' + data[i] + '">' + data[i] + '</span></div>');
					}
				}
			});
			$(".export_template_list").find(".text-remove").die("click").live("click", function (e) {
				var boid = $(this).prev().attr("templateid");
				var self = this;
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=removeTemplate",
					data : $.param({
						boid : boid,
						uipk : "com.kingdee.shr.report.app.ReportDef.form"
					}),
					success : function (data) {
						$(".template_list").find(".text-label[templateid='" + boid + "']").parent().remove();
						$(self).parent().remove();
						$(".export_field").empty();
						$(".template_field").empty();
					}
				});
			});

		});
		
		$(".exportreport").unbind("click").bind("click", function (e) {
			var checkresult = _self.checkReport(_self._navi.getParm("reportId")); 
			if(!(checkresult.result)){
				
				var msg ="";
				for(var i=0;i<checkresult.message.length;i++){
					msg += "【"+checkresult.message[i]+"】 ";
				}
				
				shr.showError({
					message : "您的报表存在以下缺陷: " + msg,
					hideAfter : 5
				});	
				return;
			}
			_self.exportreport();
		});
		
		$(".template_download").unbind("click").bind("click", function (e) {
			_self.template_download();
		});
		
		$(".uploadreport").unbind("click").bind("click", function (e) {
			//$('#attachment').click();
			
			if(!(navigator.userAgent.indexOf("MSIE 9.0")>0)){
				$('#attachment').click();	
			}else{
				//$('#attachment').dblclick();
				// IE9浏览器   8.2 SP2 暂不支持
				shr.showInfo({
					message : '上传模板功能需使用chrome或者Ie9以上浏览器',
					hideAfter : 3
				});
			}  
		});

	},
	//模板下载
	template_download : function () {
		var boid = $(".template_list .template_pressed").find(".text-label").attr("templateId");
		if (boid == undefined) {
			shr.showError({
				message : "请选择已上传的模板",
				hideAfter : 3
			});
		} else {
			var param = $.param({
					method : 'exportTemplate',
					boid : boid,
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					oprtype : "download"
				});
			location.href = shr.getContextPath() + "/dynamic.do?" + param;
		}
	},
	//导出
	exportreport : function () {
		var _self = this;
		if(this._datasources == undefined){
			shr.showError({
				message : "您没有查看信息集的权限，无法导出数据明细!",
				hideAfter : 3
			});
			return ;
		}
		// 判断是否关联数据源
		var boid = $(".template_list .template_pressed").find(".text-label").attr("templateId");
		var billId = _self._navi.getParm("reportId");
		if (billId == undefined) {
			shr.showError({
				message : "请先保存",
				hideAfter : 3
			});
			return ;
		} else if(this._datasources.length == 0){
			shr.showError({
				message : "当前报表没有关联数据源,无法导出数据明细",
				hideAfter : 3
			});
			return ;
		}else {
			$.ajax({
				url : shr.getContextPath() + "/dynamic.do?method=getReportFilterItems",
				data : $.param({
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					reportId : _self._navi.getParm("reportId")
				}),
				success : function (result) {
					queryData = result;
					var templates;
					var show = false;
					addFilterComponent(result);
					for (var i = 0; i < result.length; i++) {
						var isneed = 'true';
						if (result[i].isAllowNull) {
							isneed = 'false';
						}
						if (result[i].name == "adminOrg") {
							isneed = 'true';
						}
						
						if (result[i].inputState != 2) {
							show = true;
							if (result[i].inputType == 4) {
								var grid_f7_json = {
									id : result[i].name,
									name : result[i].name
								};
								grid_f7_json.subWidgetName = 'shrPromptGrid';
								var ismultiselect = false;
								if(result[i].name == "adminOrg"){
									//ismultiselect = true;
									ismultiselect = false;
								}
								if (result[i].desc != undefined && result[i].desc != '') {
									var f7param = result[i].desc.split(";");
									grid_f7_json.subWidgetOptions = {
										title : result[i].properties.alias_zh_CN,
										uipk : f7param[0],
										query : "",
										filter : "",
										domain : "",
										multiselect : ismultiselect
									};
									grid_f7_json.autoComplete = false;
									grid_f7_json.readonly = "";
									grid_f7_json.validate = "{required:" + isneed + "}";
									if (f7param.length > 1) {
										grid_f7_json.submitFormat = '{' + f7param[1] + '}';
									} else {
										grid_f7_json.submitFormat = '{id}';
									}
								} else {
									grid_f7_json.subWidgetOptions = {
										title : result[i].properties.alias_zh_CN,
										uipk : result[i].inputCtrl.defDbsource.name,
										query : "",
										filter : "",
										domain : "",
										multiselect : ismultiselect
									};
									grid_f7_json.readonly = "";
									grid_f7_json.validate = "{required:" + isneed + "}";
									grid_f7_json.submitFormat = '{' + result[i].inputCtrl.defValue.name + '}';
								}
								grid_f7_json.value = {
									id : "",
									name : ""
								};
								$("input[id='"+result[i].name+"']").shrPromptBox(grid_f7_json);
								$("input[id='"+result[i].name+"']").attr("value", result[i].defaultValue );
								$("input[id='"+result[i].name+"_el']").attr("value", result[i].defaultValue );
								if(result[i].name == "adminOrg"){
									$.ajax({
										url : shr.getContextPath() + "/dynamic.do?method=getUserTopAdmin",
										data : {
											uipk : "com.kingdee.shr.report.app.ReportDef.list"
										},
										success : function (data) {
											$("#adminOrg").shrPromptBox("setValue",data);
										}
									});
								}
							} else if (result[i].inputType == 0) {
								var text_json = {
									id : result[i].name,
									name : result[i].name,
									readonly : "",
									value : result[i].defaultValue,
									validate : "{maxlength:255,required:" + isneed + "}",
									onChange : null
								};
								$("input[id='"+result[i].name+"']").shrTextField(text_json);
								$("input[id='"+result[i].name+"']").attr("value",result[i].defaultValue);
							} else if (result[i].inputType == 1) {
								if (result[i].designDataType == "3" || result[i].designDataType == 3) {
									var select_json = {
										id : result[i].name
									};
									select_json.data = [{
											value : "1",
											alias : "是"
										}, {
											value : "0",
											alias : "否"
										}
									];
									select_json.validate = "{required:" + isneed + "}";
									$("input[id='"+result[i].name+"']").shrSelect(select_json);
									if (result[i].defaultValue == "1" || result[i].defaultValue == "是") {
										$("input[id='"+result[i].name+"']").shrSelect("setValue", select_json.data[0].value);
										$("input[id='"+result[i].name+"_el']").attr("value", select_json.data[0].value );
									} else if (result[i].defaultValue == "0" || result[i].defaultValue == "否") {
										$("input[id='"+result[i].name+"']").shrSelect("setValue", select_json.data[1].value);
										$("input[id='"+result[i].name+"_el']").attr("value", select_json.data[1].value );
									}else{
										$("input[id='"+result[i].name+"']").shrSelect("setValue", "");
									}
								} else if (result[i].designDataType == "0" || result[i].designDataType == "1"
									 || result[i].designDataType == 0 || result[i].designDataType == 1) {
									if (result[i].desc && result[i].desc != "") {
										var select_json = {
											id : result[i].name
										};
										var enumUrl = result[i].desc;
										if(enumUrl == "com.kingdee.shr.compensation.CalState"){
											select_json.filter = "1,4,8,12,20";
										}
										if(enumUrl && enumUrl.trim().indexOf("url:")==0){
											var url = enumUrl.trim().substr(4);
											select_json.url = url;
										}else{
											select_json.enumSource = enumUrl;
										}
										select_json.validate = "{required:" + isneed + "}";
										//$('#' + result[i].name).shrSelect(select_json);
										$("input[id='"+result[i].name+"']").shrSelect(select_json);
										if(result[i].name == result[i].defaultValue || result[i].defaultValue == undefined || result[i].defaultValue == ""){
											$("input[id='"+result[i].name+"']").attr("value","");
										}else{
											var data_tmp = $("input[id='"+result[i].name+"']").shrSelect("getData");
											var value = "";
											for(var index=0;index<data_tmp.length;index++){
												if(data_tmp[index].alias == result[i].defaultValue){
													value = data_tmp[index].value;
													break;
												}
											}
											$("input[id='"+result[i].name+"']").shrSelect("setValue",value);
										}	
									}
								}
							} else if (result[i].inputType == 2) {
								var picker_json = {
									id : result[i].name
								};
								picker_json.tagClass = 'block-father input-height';
								picker_json.validate = '{dateISO:true,required:' + isneed + '}';
								$("input[id='"+result[i].name+"']").shrDatePicker(picker_json);
								var date = _self.dateUtils.getdate(result[i].defaultValue);
								if(date == 'null' || date == undefined || date==null){
									date = "";
								}
								$("input[id^='"+result[i].name+"']").attr("value", date);
							}
						}
					}
					if (show) {
						if($('#dialog_report').attr("class") == undefined){
							$('.ui-dialog').remove();
						}
						$('#dialog_report').dialog({
							title : '选择过滤条件',
							width : 840,
							height : 600,
							resizable : false,
							buttons : {
								'确定' : function () {
									//document.getElementById('orgDialogIfame').contentWindow.jsBinder.saveAction();
									if(!_self.checkNullValue(queryData)){
										return;
									}
									for (var i = 0; i < queryData.length; i++) {
										if (queryData[i].inputState != 2) {
											if(queryData[i].inputType != null && (queryData[i].inputType == 4|| queryData[i].inputType == 1)){
												//queryData[i].curentValue = $('#'+queryData[i].name).prev().val();
												queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").prev().val();
												if("adminOrg" == queryData[i].name){
													queryData[i].curentValueAlias = $("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").displayName;
												}else{
													queryData[i].curentValueAlias = $("input[id='"+queryData[i].name+"']").val();
												}	
											}else if (queryData[i].inputType == 2){
													queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").val().replace(/\//g,"-");
											} else {
												queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").val();
											}
										}
										var alias = {alias:queryData[i].properties.alias_zh_CN};
										queryData[i].properties = JSON.stringify(alias);
									}
									if ($.block) {
									$.block.show({
										text : '正在导出数据明细，请稍候...'
									});
									}
									var fileName = "";
									var JsessionId = "";
									$.ajax({
										url : shr.getContextPath() + "/dynamic.do?method=outReportDetail",
										type : 'post',
										data : $.param({
													boid : boid,
													billId : billId,
													outputType : "Detail",
													uipk : "com.kingdee.shr.report.app.ReportDef.form",
													filterParam : $.toJSON(queryData),
													tmpPath:_self.getJSessionCookie()
										}),
										success : function (data) {
											if ($.block) {
												$.block.hide();
											}
											fileName = data.fileName;
											JsessionId = data.sessionId;
											var urlparam = $.param({
											method : 'getReportFile',
											uipk : "com.kingdee.shr.report.app.ReportDef.list",
											fileName : data.fileName,
											tmpPath : JsessionId
											});
											location.href = shr.getContextPath() + "/dynamic.do?" + urlparam;	
										}
									});
									$(this).dialog('close');
								},
								'取消' : function () {
									$(this).dialog('close');
								}
							}
						});
					} else {
						for (var i = 0; i < queryData.length; i++) {
							var alias = {alias:queryData[i].properties.alias_zh_CN};
							queryData[i].properties = JSON.stringify(alias);
						}
						var param = $.param({
								method : 'exportreport',
								boid : boid,
								billId : billId,
								uipk : "com.kingdee.shr.report.app.ReportDef.form",
								filterParam : $.toJSON(queryData),
								tmpPath:_self.getJSessionCookie()
							});
						location.href = shr.getContextPath() + "/dynamic.do?" + param;
					}
				}
			});
		}

		var addFilterComponent = function (data) {
			var router = 0;
			var xml;
			$(".report_filter").empty();
			
			for (var i = 0; i < data.length; i++) {
				var ins = data[i].properties.alias_zh_CN;// 过滤条件提示信息
				var paramMapping = _self.reportParam;
				var paramname = data[i].name;
				if(typeof paramMapping == 'string'){
					paramMapping = (jQuery.parseJSON(paramMapping));
				}
				for(var j=0,size = paramMapping.length; j<size; j++){
					if(paramMapping[j].param_value == paramname &&  paramMapping[j].ins != ""){
						ins = paramMapping[j].ins;
						break;
					}
				}
				
				if (data[i].inputState != 2) {
					router++;
					var isneed = true;
					if ((data[i].isAllowNull)) {
						isneed = false;
					}
					if (data[i].name == "adminOrg") {
							isneed = true;
						}
					if (data[i].designDataType == 0 && data[i].inputType == 4) {
						if (router % 2 == 1) {
							xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
								 + '</div><div class="span1 field-desc"></div></div>';
						} else {
							$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
								 + '</div><div class="span1 field-desc"></div></div></div>');
						}
					} else if (data[i].designDataType == 0) {
						if (router % 2 == 1) {
							xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal="" style="width:180px !important"/>'
								 + '</div><div class="span1 field-desc"></div></div>';
						} else {
							$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
								 + '</div><div class="span1 field-desc"></div></div></div>');
						}
					} else if (data[i].designDataType == 1) {
						if (router % 2 == 1) {
							xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
								 + '</div><div class="span1 field-desc"></div></div>';
						} else {
							$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
								 + '</div><div class="span1 field-desc"></div></div></div>');
						}
					} else if (data[i].designDataType == 2) {
						if (router % 2 == 1) {
							xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" name="' + data[i].name + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
								 + '</div><div class="span1 field-desc"></div></div>';
						} else {
							$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" name="' + data[i].name + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
								 + '</div><div class="span1 field-desc"></div></div></div>');
						}
					} else if (data[i].designDataType == 3) {
						if (router % 2 == 1) {
							xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
								 + '</div><div class="span1 field-desc"></div></div>';
						} else {
							$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
								 + '<div class="field_label" title="' + ins + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
								 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
								 + '</div><div class="span1 field-desc"></div></div></div>');
						}
					}
				}
			}
			if (router % 2 == 1 && xml != null) {
				$(".report_filter").append(xml + '</div>');
			}
		};
	},
	
	checkNullValue : function (queryData) {
		var currentValue;
		for (var i = 0; i < queryData.length; i++) {
			if (queryData[i].inputState != 2) {
				if (queryData[i].inputType != null && (queryData[i].inputType == 4 || queryData[i].inputType == 1)) {
					//currentValue = $('#' + queryData[i].name).prev().val();
					currentValue = $("[id='"+queryData[i].name+ "']").prev().val()||$("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").number;
				} else {
					//currentValue = $('#' + queryData[i].name).val();
					currentValue = $("[id='"+ queryData[i].name+ "']").val();
				}
				if(!queryData[i].isAllowNull && (currentValue == null || currentValue == undefined || currentValue == "null" || currentValue == "")){
					shr.showError({
						message : '请输入'+queryData[i].properties.alias_zh_CN,
						hideAfter : 3
					});
					return false;
				}
				
				if(queryData[i].name == "adminOrg" && (currentValue == null || currentValue == undefined || currentValue == "null" || currentValue == "")){
					shr.showError({
						message : '请输入'+queryData[i].properties.alias_zh_CN,
						hideAfter : 3
					});
					return false;
				}
				
				// 日期型控件要保证输入的日期合法
				if((queryData[i].designDataType == 2 || queryData[i].designDataType == "2") && !queryData[i].isAllowNull){
					var date = new Date(currentValue);
					if(!date.getFullYear() || date.getFullYear() > 9999){
						shr.showError({
							message : queryData[i].properties.alias_zh_CN + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
					if(date.getMonth() >11 || date.getMonth() < 0){
						shr.showError({
							message : queryData[i].properties.alias_zh_CN + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
					if(date.getDate() > 31 || date.getDate() < 1){
						shr.showError({
							message : queryData[i].properties.alias_zh_CN + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
				}
				
			}
		}
		return true;
	},

	onNext : function (_wizard) {

		return {
			status : 1
		};
	},

	onNaviLoad : function (_navi) {
		var _self = this;
		var reportId = _navi.getParm("reportId");
		_self.reporId = reportId;
		this.reportParam = _navi.getParm("reportParam");
		this._datasources = _navi.getParm("_datasources");
		this.IsEdit = _navi.getParm("IsEdit");
		//根据是否具有编辑权限，判断是否需要加上遮罩层
		if(this.IsEdit == false || this.IsEdit == "false"){
			$("button[name='uploadreport']").hide();
			//$("button[name='exportreport']").hide();
		}else{
			$("button[name='uploadreport']").show();
			//$("button[name='exportreport']").show();
		}
		// 根据浏览器类型，初始化上传控件
		if(navigator.userAgent.indexOf("MSIE 9.0")>0)  
		{   // IE9浏览器
			$(".attachmentUploadArea").css("margin-left","-200px");	
			$(".attachmentUploadArea").css("opacity","0");
			_self.initalIe9upload(reportId);
		}else{
			// 非IE9浏览器
			$(".attachmentUploadArea").css("margin-left","100px");
			$(".attachmentUploadArea").css("filter","alpha(opacity=0.5)");
			_self.initalotherupload(reportId);
		}   
		
		$("#template_attachment-button").attr("style", "width: 26px;margin-left: 0px;");

		if (reportId != undefined && reportId != "") {
			$.ajax({
				url : shr.getContextPath() + "/dynamic.do?method=getAttachTemplates",
				data : $.param({
					uipk : "com.kingdee.shr.report.app.ReportDef.form",
					objid : reportId
				}),
				success : function (data) {
					$(".template_list .text-tag").remove();
					$(".export_template_list .text-tag").remove();
					for (var i in data) {
						$(".template_list").append('<div class="text-tag"><span class="text-label" templateId="' + data[i].id + '" title="' + data[i].name + '">' + data[i].name + '</span><span class="text-remove" remove="'+data.isCanEdit+'" title="删除" style="display: none;">x</span></div>');
						$(".template_edit_panel").before('<div class="text-tag"><span class="text-label" templateId="' + data[i].id + '" title="' + data[i].name + '">' + data[i].name + '</span><span class="text-remove" remove="'+data.isCanEdit+'" title="删除" style="display: none;">x</span></div>');
					}
					$(".export_template_list").find(".text-tag:eq(0)").click();
				}
			});
		}
		_self._navi = _navi;
	},

	finishedClick : function () {
		var _self = this;
		_self._navi.reloadPage({
			uipk : 'com.kingdee.shr.report.app.ReportDef.list'
		});
	},
	
	//检查报表合法性
	checkReport : function(reportId){
		var checkresult;
		$.ajax({
			url: shr.getContextPath() + "/dynamic.do?method=checkReport",
			async:false,
			data: {
				uipk : "com.kingdee.shr.report.app.ReportDef.form",
				reportId : reportId
			},
			success: function(data) {
				checkresult = data;
			},
			error : function(data){
				checkresult =  data;
			}
		});
		return checkresult;
	},
	getJSessionCookie : function () {
   	var array = document.cookie.split(";");
		for (var i = 0; i < array.length; i++) {
			if (array[i].indexOf("JSESSIONID") >= 0) {
				return array[i].trim().substring('JSESSIONID'.length + 1);
			}
		}
	 return "";
   },
   
   /*
	*初始化适用于Ie9浏览器的上传控件（uploadify）
	*/
    initalIe9upload : function(reportId){
		$("#attachment").uploadify({
			uploader: shr.getContextPath() + "/dynamic.do?method=uploadTemplate",
			buttonText: 'upload',
			buttonClass: "awareUpload",
			fileObjName:'uploadAttach',
			height: '5',
			width : '75',
			//fileTypeExts : self.analysisFileType("uploadify"),
			//formData: {boID: self.options.formId, onlyone:self.options.onlyone},
			rollover: true,
			fileSizeLimit : '5MB' ,
			url : shr.getContextPath() + "/dynamic.do?method=uploadTemplate",
			formData : {
				uipk : "com.kingdee.shr.report.app.ReportDef.form",
				isNocheck : true,
				objid : reportId
			},
			swf: shr.getContextPath() + "/jslib/uploadify/uploadify.swf",
			
			//每次更新上载的文件的进展
			'onUploadProgress' : function(file, bytesUploaded, bytesTotal, totalBytesUploaded, totalBytesTotal) {
				 //有时候上传进度什么想自己个性化控制，可以利用这个方法
				 //使用方法见官方说明
			},
			//选择上传文件后调用
			'onSelect' : function(file) {
					$(".attachmentUploadArea").css("margin-left","100px");	
					$(".attachmentUploadArea").css("opacity","20");
			},
			//检测FLASH失败调用
			'onFallback':function(){
				alert("您未安装FLASH控件，无法上传！请安装FLASH控件后再试。");
			},
			//上传到服务器，服务器返回相应信息到data里
			'onUploadSuccess':function(file, data, response){
				$(".attachmentUploadArea").css("margin-left","-200px");	
				$(".attachmentUploadArea").css("opacity","0");
				var response = jQuery.parseJSON(data).data;
				//var filename = response.filename;
				$(".attachment-loading").remove();
				if(response && response.error != undefined && response.error != null && response.error != ""){
					shr.showError({
						message : response.error
					});
					return;
				}
				//上传后刷新一下
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=getAttachTemplates",
					data : $.param({
						uipk : "com.kingdee.shr.report.app.ReportDef.form",
						objid : reportId
					}),
					success : function (data) {
						$(".template_list .text-tag").remove();
						$(".export_template_list .text-tag").remove();
						for (var i in data) {
							$(".template_list").append('<div class="text-tag"><span class="text-label" templateId="' + data[i].id + '" title="' + data[i].name + '">' + data[i].name + '</span><span class="text-remove" remove="'+data.isCanEdit+'" title="删除" style="display: none;">x</span></div>');
							$(".template_edit_panel").before('<div class="text-tag"><span class="text-label" templateId="' + data[i].id + '" title="' + data[i].name + '">' + data[i].name + '</span><span class="text-remove" remove="'+data.isCanEdit+'" title="删除" style="display: none;">x</span></div>');
						}
						$(".export_template_list").find(".text-tag:eq(0)").click();
					}
				});
			}
		});
	},
	
	/*
	*初始化适用于Ie9以上及chrome浏览器的上传控件（jquery fileupload）
	*/
	initalotherupload : function(reportId){
		$('#attachment').fileupload({
			url : shr.getContextPath() +"/dynamic.do?method=uploadTemplate",
			formData : {
				uipk : "com.kingdee.shr.report.app.ReportDef.form",
				objid : reportId
			},
			dataType : "json",
			
			start : function (e) {
				var attachListId = '#' + 'attachment' + '_attachList';
				$(attachListId).append("<p class = 'attachment-loading'>文件正在上传，请稍后 .. <span class = 'progress'></span></p>");
				$(".progress").html("10%");
			},
			
			add : function (e, data) {
				var pattern = new RegExp("['!@#$%^&*-+=:/\]");
				var uploadErrors = [];

				if (data.originalFiles.length && data.originalFiles[0]['size'] > 5 * 1024 * 1024) {
					shr.showError({
						message : "文件大小超出限制，请上传小于5M的文件!"
					});
				} else if( pattern.test(data.originalFiles[0]['name']) ){
					shr.showError({
						message : "文件名不可包含以下特殊字符！('!@#$%^&*-+=:/\\)",
						hideAfter: 5
					});
				} else {
					data.submit();
				}
			},
			
			progressall : function (e, data) {
				var progress = parseInt(data.loaded / data.total * 100, 10);
				$(".progress").html(progress + "%");
			},
			
			done : function (e, data) {
				var response = data.result.data;
				//var filename = response.filename;
				$(".attachment-loading").remove();
				if(response && response.error != undefined && response.error != null && response.error != ""){
					shr.showError({
						message : response.error,
						hideAfter : 3
					});
					return;
				}
				//上传后刷新一下
				$.ajax({
					url : shr.getContextPath() + "/dynamic.do?method=getAttachTemplates",
					data : $.param({
						uipk : "com.kingdee.shr.report.app.ReportDef.form",
						objid : reportId
					}),
					success : function (data) {
						$(".template_list .text-tag").remove();
						$(".export_template_list .text-tag").remove();
						for (var i in data) {
							$(".template_list").append('<div class="text-tag"><span class="text-label" templateId="' + data[i].id + '" title="' + data[i].name + '">' + data[i].name + '</span><span class="text-remove" remove="'+data.isCanEdit+'" title="删除" style="display: none;">x</span></div>');
							$(".template_edit_panel").before('<div class="text-tag"><span class="text-label" templateId="' + data[i].id + '" title="' + data[i].name + '">' + data[i].name + '</span><span class="text-remove" remove="'+data.isCanEdit+'" title="删除" style="display: none;">x</span></div>');
						}
						$(".export_template_list").find(".text-tag:eq(0)").click();
					}
				});
			},
		});
	},
	
	checkIllegalChar :function (str){
		var pattern = new RegExp("['!@#$%^&*-+=:/\]");
		if(pattern.test(str)){
			return true;
		}else{
			return false;
		}
	}
});
