﻿shr.defineClass("shr.report.ReportDeployList", shr.framework.List, {
	_self : '',
	initalizeDOM:function(){
		shr.report.ReportDeployList.superClass.initalizeDOM.call(this);	
		_self = this;
		var html = "", $con = $("#permission");
		var html_user = "", $con_user = $("#user");
		
		$("#reportds_head").append('<div id="report_select" style="display: none;"><input id="prop_reportds" type="text" name="prop_reportds" style="width:50px;display: none;"></input></div>');

		$("#prop_reportds").shrPromptBox({
			id: "prop_reportds",
			name: "prop_reportds",
			displayFormat: "{number}",
			subWidgetName: "shrPromptGrid",
			subWidgetOptions: {
				title: "用户选择",
				uipk: 'com.kingdee.eas.base.permission.app.User.F7',
				multiselect: true
			}
		});
		
		$("#reportds_select").live("click",function(e){
			$("#report_select").find(".ui-promptBox-icon").click();
		});
		
		$("#prop_reportds").shrPromptBox("option",{onchange:function(e,value){
			if (!value.current) {
				return;
			}
		
			var addData = [];
			var addIndex = 0;
			var a = $("#grid").jqGrid("getSelectedRows")[0];
			var businessid = $("#grid").jqGrid("getCell", a, "businessType.id");
			var defid = $("#grid").jqGrid("getCell", a, "reportdef.id");
			
			for(var i = 0;i<value.current.length;i++){
				var hasName = false;
				$(".reportds_list").find(".text-label").each(function(){
					if($(this).html() == value.current[i].name){
						hasName = true;
						return;
					}
				});
				if(!hasName){
					//var reportID = _self._navi.getParm("id");
					addData[i] ={dataSourceID:value.current[i].id};
				}
			}
			
			_self.remoteCall({
				method: "addPermission", 
				param: {
					businessid:businessid,
					defid:defid,
					selectData : JSON.stringify(addData)
				}, 
				success: function(data) {
					shr.showInfo({
						message: "添加成功",
						hideAfter: 3
						
					});
					
					// 重新加载表格
					_self.remoteCall({
						method: "getBusinessTypes", 
						param: {
							businessid:businessid,
							defid:defid
						}, 
						success: function(data) {
							if(!data) return;
							//data = "(" + data + ")";
							var $grid2 = $("#tempTab");
							$grid2.jqGrid({
								width: "auto",
								height: "auto",
								datatype: "local",
								multiselect: true,
								rownumbers: true,
								colNames: ["ID","类别ID","类别", "报表ID","报表","用户"],
								colModel: [{name: "id", hidden: true, key: true},{name: "bid", hidden: true, key: true}, {name: "businessType", width: 340},{name: "defid", hidden: true, key: true},{name: "reportdef", width: 280},{name: "user", width: 280}]
							});
							
							$grid2.jqGrid("clearGridData");
							for(var i in data) {         
								var d = {id: data[i].id,bid:data[i].businessType.id,businessType:data[i].businessType.name, defid: data[i].reportdef.id,reportdef:data[i].reportdef.name,user: data[i].user.name};
								$grid2.jqGrid("addRowData", i + 1, d);
							}
						}
					});
					
					$("#prop_reportds").shrPromptBox('setValue', null);
				}
			});	
			}
	});
		
		
		
		// 显示所有记录
		$("#showAll").live("click",function(e){
			var param = $.param({
				//method : 'getReportDeploy',
				businessTypeid:_self.initData.custom_params.businessTypeid,
				defid: _self.initData.custom_params.defid,
				isFilter:"no",
				uipk : "com.kingdee.shr.report.app.ReportDeploy.list",

			});
			location.href = shr.getContextPath()+"/dynamic.do?" + param;
			
		});		

    $("#showOwn").live("click",function(e){
			var param = $.param({
				//method : 'getReportDeploy',
				businessTypeid:_self.initData.custom_params.businessTypeid,
				isFilter:"ok",
				defid: _self.initData.custom_params.defid,
				uipk : "com.kingdee.shr.report.app.ReportDeploy.list",
			});
			location.href = shr.getContextPath()+"/dynamic.do?" + param;
		});		
		
	/*
	*添加权限按钮
	*/
	$("#addPermission").live("click",function(e){
		top.Messenger().hideAll();
		
	
		
	});		
		
	/*
	*取消分配按钮
	*/
	$("#cancelPermission").live("click",function(e){
		top.Messenger().hideAll();
		// 判断是否选中
		if(!(_self.CheckTabSelectedIds())){
			shr.showWarning({
			message: "请先选中表格中的数据!"	
			});
			_self.reloadGrid();
			return;
		}
		var a = $("#tempTab").jqGrid("getSelectedRows");
		var businessid = $("#tempTab").jqGrid("getCell", a[0], "bid");
		var defid = $("#tempTab").jqGrid("getCell", a[0], "defid");
		// 删除操作
		shr.showConfirm('您确认要删除吗？', function(){
			top.Messenger().hideAll();
			var permissonid = [];
			for(var i in a){
					permissonid [i] =  $("#tempTab").jqGrid("getCell", a[i], "id");
				}
			_self.remoteCall({
				method: "cancelPermission", 
				param: {
					permissonid:JSON.stringify(permissonid)
				}, 
				success: function(data) {
					shr.showInfo({
						message: "删除成功",
						hideAfter: 3
					});
				// 重新加载表格
				_self.remoteCall({
				method: "getBusinessTypes", 
				param: {
					businessid:businessid,
					defid:defid
				}, 
				success: function(data) {
					if(!data) return;
					//data = "(" + data + ")";
					var $grid2 = $("#tempTab");
					$grid2.jqGrid({
						width: "auto",
						height: "auto",
						datatype: "local",
						multiselect: true,
						rownumbers: true,
						colNames: ["ID","类别ID","类别", "报表ID","报表","用户"],
						colModel: [{name: "id", hidden: true, key: true},{name: "bid", hidden: true, key: true}, {name: "businessType", width: 340},{name: "defid", hidden: true, key: true},{name: "reportdef", width: 280},{name: "user", width: 280}]
					});
					
					$grid2.jqGrid("clearGridData");
					for(var i in data) {         
						var d = {id: data[i].id,bid:data[i].businessType.id,businessType:data[i].businessType.name, defid: data[i].reportdef.id,reportdef:data[i].reportdef.name,user: data[i].user.name};
						$grid2.jqGrid("addRowData", i + 1, d);
					}
				}
			});
				}
			});
	
			
		});

		
		
	});		
	
	
	$("#permissionAssignment").live("click",function(e){
			top.Messenger().hideAll();
			// 判断是否选中
			if(!(_self.CheckSelectedIds())){
				shr.showWarning({
				message: "请先选中表格中的数据!"
				});
				return;
			}	
			html = "<div id='dialog_report2'>"
			+"<button id='reportds_select' type='button' name='reportds_select' class='shrbtn-primary shrbtn next' onclick=''>给用户分配权限</button>"
			//+"<button id='addPermission' type='button' name='addPermission' class='null shrbtn' >添加权限</button>"
			+"<button id='cancelPermission' type='button' name='cancelPermission' class='null shrbtn'>取消分配</button>"
			+"<table id='tempTab'></table></div>";
			$("#dialog_report2").parent().empty();
			$con.empty();
			$con.append(html);	
			//$("#dialog_report2").append("<button >添加成员</button>  <button >取消分配</button><table id='grid' class=''></table><div id='gridPager'></div>");
			// 获取所选行的businessType和ReportDef的id   
			var a = $("#grid").jqGrid("getSelectedRows")[0];
			var businessid = $("#grid").jqGrid("getCell", a, "businessType.id");
			var defid = $("#grid").jqGrid("getCell", a, "reportdef.id");
			_self.remoteCall({
				method: "getBusinessTypes", 
				param: {
					businessid:businessid,
					defid:defid
				}, 
				success: function(data) {
					if(!data) return;
					//data = "(" + data + ")";
					var $grid2 = $("#tempTab");
					$grid2.jqGrid({
						width: "auto",
						height: "auto",
						datatype: "local",
						multiselect: true,
						rownumbers: true,
						colNames: ["ID","类别ID","用户", "报表ID","报表","类别"],
						colModel: [{name: "id", hidden: true, key: true},{name: "bid", hidden: true, key: true},{name: "user", width: 280} ,{name: "defid", hidden: true, key: true},{name: "reportdef", width: 280},{name: "businessType", width: 340}]
					});
					
					$grid2.jqGrid("clearGridData");
					for(var i in data) {         
						var d = {id: data[i].id,bid:data[i].businessType.id,user: data[i].user.name, defid: data[i].reportdef.id,reportdef:data[i].reportdef.name,businessType:data[i].businessType.name};
						$grid2.jqGrid("addRowData", i + 1, d);
					}
				}
			});
			
			$('#dialog_report2').dialog({
					title: '权限分配',
					width: 800,
					height: 600,
					resizable: false,
					buttons:{
						'确定': function(){	
							var infos = {};									
							//_self.createTable(infos);
								
							$(this).dialog('close');
						},
						'取消': function(){
							$(this).dialog('close');
						}
					}
				});
			
		});	
		
	
	
					
},
	CheckSelectedIds: function() {
		var selectedIds = $("#grid").jqGrid("getSelectedRows")
		if (selectedIds.length > 0) {
			return true;
	    }else{
			return false;
		}
	},
	
	CheckTabSelectedIds: function() {
		var selectedIds = $("#tempTab").jqGrid("getSelectedRows");
		if (selectedIds.length > 0) {
			return true;
	    }else{
			return false;
		}
	}
	
	,
	
	/**
	 * 重新加载表格
	 */
	reloadGrid: function() {
		$("#dialog_report2").jqGrid("reloadGrid");
	},
	/**
	 * 重新加载表格
	 */
	reloadGrid_grid: function() {
		$("#grid").jqGrid("reloadGrid");
	},
	onCellSelect: function(rowid, colIndex, cellcontent, e) {
		
	},
	/**
	 * 描述:删除操作 
	 */
	deleteRecord:function(selectedIds) {
		var _self = this;
		shr.showConfirm('您确认要取消发布吗？', function(){
			top.Messenger().hideAll();
			
			var data = {
				method: 'delete',
				billId: selectedIds
			};
			data = $.extend(_self.prepareParam(), data);
			
			shr.doAction({
				url: _self.dynamicPage_url,
				type: 'post', 
				data: data,
				success : function(response) {					
					_self.reloadGrid_grid();
					
				},
				error: function(response) {
					if (selectedIds.split(',').length > 1) {
						_self.reloadGrid_grid();
					}
				}
			});	
		});
	},
	
});