﻿shr.defineClass("shr.report.ReportQueryList", shr.framework.List, {
	self : null,
	initalizeDOM : function () {
		shr.report.ReportQueryList.superClass.initalizeDOM.call(this);
		_self = this;
		self = this;
		$(".template_list").find(".text-tag").live("click", function () {
			if (!$(this).hasClass("template_pressed")) {
				$(".template_list .text-tag").removeClass("template_pressed");
				$(".template_list .text-label").removeClass("text_label_pressed");
				$(this).addClass("template_pressed");
				$(this).find(".text-label").addClass("text_label_pressed");
			} else {
				$(".template_list .text-tag").removeClass("template_pressed");
				$(".template_list .text-label").removeClass("text_label_pressed");
			}

		});

	},

	onCellSelect : function (rowid, colIndex, cellcontent, e) {
		//var _self = this;
		_self.selectedRowId = rowid;

		// 选择的是选择框
		if (colIndex == 0) {
			return;
		}
		var billId = $(_self.gridId).jqGrid("getCell", rowid, _self.getBillIdFieldName());
		if (billId != "" && billId != undefined) {
			//_self.viewAction(billId);
			var businessid = $(_self.gridId).jqGrid("getCell", billId, "businessType.id");
			var defid = $(_self.gridId).jqGrid("getCell", billId, "reportdef.id");
		}
		
		// 检查报表完整性
		var checkresult = _self.checkReportIntegrity(defid);
		if(!(checkresult.result)){
			shr.showError({
				message : "当前报表存在缺陷，无法使用！",
				hideAfter : 3
			});
			return;
		}
		
		_self.remoteCall({
			///////////////////////////////////////////////////////
			method : 'getReportFilterItems',
			param : {
				reportId : defid
			},
			success : function (data) {
				queryData = data.filterItems;
				var result = data.filterItems;
				var templates;
				var show = true;
				var templateid;
				_self.addFilterComponent(result);

				$(".template_list .text-tag").remove();
				$(".export_template_list .text-tag").remove();
				$("#notemplates").remove();

				$(".report_filter").append('<div class="ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix"  style="border-bottom:1px solid #ccc;" ><span id="ui-id-1" class="ui-dialog-title">选择模板</span></div>');
				//}
				if (data.templates.length == 0) {
					$(".template_list").append('<div id="notemplates"><span id="ui-id-1" class="ui-dialog-title" style="color:#FA0610">无模板</span></div>');
				} else {
					// 显示模板
					for (var i in data.templates) {
						$(".template_list").append('<div class="text-tag"><span class="text-label" templateId="' + data.templates[i].value + '" title="' + data.templates[i].alias + '">' + data.templates[i].alias + '</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
						$(".template_edit_panel").before('<div class="text-tag"><span class="text-label" templateId="' + data.templates[i].value + '" title="' + data.templates[i].alias + '">' + data.templates[i].alias + '</span><span class="text-remove" title="删除" style="display: none;">x</span></div>');
					}
					$(".template_list").find(".text-tag:eq(0)").click();
				}

				// 显示筛选条件
				for (var i = 0; i < result.length; i++) {
					var isneed = 'true';
					if (result[i].isAllowNull) {
						isneed = 'false';
					}
					if (result[i].inputState != 2) {
						show = true;
						if (result[i].inputType == 4) {
							var grid_f7_json = {
								id : result[i].name,
								name : result[i].name
							};
							grid_f7_json.subWidgetName = 'shrPromptGrid';
							var ismultiselect = false;
							if(result[i].name == "adminOrg"){
								//ismultiselect = true;
								ismultiselect = false;
								isneed = 'true';
							}
							if (result[i].desc != undefined && result[i].desc != '') {
								var f7param = result[i].desc.split(";");
								grid_f7_json.subWidgetOptions = {
									title : result[i].properties.alias_zh_CN,
									uipk : f7param[0],
									query : "",
									filter : "",
									domain : "",
									multiselect : ismultiselect
								};
								grid_f7_json.autoComplete = false;
								grid_f7_json.readonly = "";
								grid_f7_json.validate = "{required:" + isneed + "}";
								if (f7param.length > 1) {
									grid_f7_json.submitFormat = '{' + f7param[1] + '}';
								} else {
									grid_f7_json.submitFormat = '{id}';
								}
							} else {
								grid_f7_json.subWidgetOptions = {
									title : result[i].properties.alias_zh_CN,
									uipk : result[i].inputCtrl == null?"":result[i].inputCtrl.defDbsource.name,
									query : "",
									filter : "",
									domain : "",
									multiselect : ismultiselect
								};
								grid_f7_json.autoComplete = false;
								grid_f7_json.readonly = "";
								grid_f7_json.validate = "{required:" + isneed + "}";
								var submitFormat = result[i].inputCtrl == null?"":result[i].inputCtrl.defValue.name;
								grid_f7_json.submitFormat = '{' + submitFormat + '}';
							}
							grid_f7_json.value = {
								id : "",
								name : ""
							};
							$("input[id='"+result[i].name+"']").shrPromptBox(grid_f7_json);
							$("input[id='"+result[i].name+"']").attr("value", result[i].defaultValue );
							$("input[id='"+result[i].name+"_el']").attr("value", result[i].defaultValue );
							if(result[i].name == "adminOrg"){
								$.ajax({
									url : shr.getContextPath() + "/dynamic.do?method=getUserTopAdmin",
									data : {
										uipk : "com.kingdee.shr.report.app.ReportDef.list"
									},
									success : function (data) {
										$("#adminOrg").shrPromptBox("setValue",data);
									}
								});
							}
						} else if (result[i].inputType == 0) {
							var text_json = {
								id : result[i].name,
								name : result[i].name,
								readonly : "",
								value : "",
								validate : "{maxlength:255,required:" + isneed + "}",
								onChange : null
							};
							$("input[id^='"+result[i].name+"']").shrTextField(text_json);
							$("input[id^='"+result[i].name+"']").attr("value", result[i].defaultValue) ;
						} else if (result[i].inputType == 1) {
							if (result[i].designDataType == "3" || result[i].designDataType == 3) {
								var select_json = {
									id : result[i].name
								};
								select_json.data = [{
										value : "1",
										alias : "是"
									}, {
										value : "0",
										alias : "否"
									}
								];
								select_json.validate = "{required:" + isneed + "}";
								$("input[id='"+result[i].name+"']").shrSelect(select_json);
								if (result[i].defaultValue == "1" || result[i].defaultValue == "是") {
									$("input[id='"+result[i].name+"']").shrSelect("setValue", select_json.data[0].value);
									$("input[id='"+result[i].name+"_el']").attr("value", select_json.data[0].value );
								} else if (result[i].defaultValue == "0" || result[i].defaultValue == "否") {
									$("input[id='"+result[i].name+"']").shrSelect("setValue", select_json.data[1].value);
									$("input[id='"+result[i].name+"_el']").attr("value", select_json.data[1].value );
								}else{
									$("input[id='"+result[i].name+"']").shrSelect("setValue", "");
								}
							} else if (result[i].designDataType == "0" || result[i].designDataType == "1"
								 || result[i].designDataType == 0 || result[i].designDataType == 1) {
								if (result[i].desc && result[i].desc != "") {
									var select_json = {
										id : result[i].name
									};
									var enumUrl = result[i].desc;
									if(enumUrl == "com.kingdee.shr.compensation.CalState"){
										select_json.filter = "1,4,8,12,20";
									}
									if(enumUrl && enumUrl.trim().indexOf("url:")==0){
										var url = enumUrl.trim().substr(4);
										select_json.url = url;
									}else{
										select_json.enumSource = enumUrl;
									}									
									select_json.validate = "{required:" + isneed + "}";
									$("input[id^='"+result[i].name+"']").shrSelect(select_json);
									if(result[i].name == result[i].defaultValue || result[i].defaultValue == undefined || result[i].defaultValue == ""){
											$("input[id='"+result[i].name+"']").attr("value","");
									}else{
										var data_tmp = $("input[id='"+result[i].name+"']").shrSelect("getData");
										var value = "";
										for(var index=0;index<data_tmp.length;index++){
											if(data_tmp[index].alias == result[i].defaultValue){
												value = data_tmp[index].value;
												break;
											}
										}
										if(value == ""){
											$("input[id='"+result[i].name+"']").shrSelect("setValue",data_tmp[0].value);
										}else{
											$("input[id='"+result[i].name+"']").shrSelect("setValue",value);
										}
									}	
								}
							}
						} else if (result[i].inputType == 2) {
							var picker_json = {
								id : result[i].name
							};
							picker_json.tagClass = 'block-father input-height';
							picker_json.validate = '{dateISO:true,required:' + isneed + '}';
							$("input[id^='"+result[i].name+"']").shrDatePicker(picker_json);
							var date = _self.getdate(result[i].defaultValue=="getSystemDate()"?"today":result[i].defaultValue);
							if(date == 'null' || date == undefined || date==null){
								date = "";
							}
							$("input[id^='"+result[i].name+"']").attr("value", date);
						}
					}
				}
				if (show) {
					$('#dialog_report').dialog({
						title : '选择过滤条件',
						width : 840,
						height : 600,
						resizable : false,
						buttons : {
							'下载' : function () {
								var allParam = [];
								if(!_self.checkNullValue(queryData)){
									return;
								}
								for (var i = 0; i < queryData.length; i++) {
									if (queryData[i].inputState != 2) {
										if (queryData[i].inputType != null && (queryData[i].inputType == 4 || queryData[i].inputType == 1)) {
											queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").prev().val() == "null"?"":$("input[id='"+queryData[i].name+"']").prev().val()||$("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").number;
											if ("adminOrg" == queryData[i].name) {
												queryData[i].curentValueAlias = $("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").displayName;
											} else {
												queryData[i].curentValueAlias = $("input[id='"+queryData[i].name+"']").val() == "null"?"":$("input[id='"+queryData[i].name+"']").val();
											}
										} else if (queryData[i].inputType == 2){
											queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").val().replace(/\//g,"-");
										} else {
											queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").val();
										}
									}
									var alias = {
										alias : queryData[i].properties.alias_zh_CN
									};
									allParam[i] = {
										curentValue : queryData[i].curentValue,
										curentValueAlias : queryData[i].curentValueAlias,
										dataType : queryData[i].dataType,
										defaultValue : queryData[i].defaultValue,
										designDataType : queryData[i].designDataType,
										inputState : queryData[i].inputState,
										inputType : queryData[i].inputType,
										isAllowNull : queryData[i].isAllowNull,
										properties : JSON.stringify(alias),
										name : queryData[i].name
									}
								}

								// 判断是否添加过滤条件
								if (queryData.length == 0) { // 没有设置过滤条件

									shr.showError({
										message : "您还没有为报表添加过滤条件，请先添加过滤条件后再进行此操作！",
										hideAfter : 3
									});
									return;
								}

								// 判断数据有效性
								for (var i = 0; i < queryData.length; i++) {
									if ((queryData[i].curentValue == null || queryData[i].curentValue == "" ) && queryData[i].isAllowNull == false) {
										shr.showError({
											message : queryData[i].properties.alias_zh_CN + "不可为空！",
											hideAfter : 3
										});
										return;
									}
								}

								// 判断是否添加了模板
								if ($(".template_list").find(".text-label").size() == 0) {
									// 没有添加模板
									shr.showError({
										message : "您还没有为报表添加模板，请先添加模板后再进行此操作！",
										hideAfter : 3
									});
									return;
								}

								// 判断是否选择模板
								if ($(".template_list .template_pressed").find(".text-label").attr("templateId") == undefined || $(".template_list .template_pressed").find(".text-label").attr("templateId") == null) {
									shr.showError({
										message : "请选择一个模板！",
										hideAfter : 3
									});
									return;
								}

								var param = $.param({
										method : 'getReport',
										boid : $(".template_list .template_pressed").find(".text-label").attr("templateId"),
										billId : defid,
										uipk : "com.kingdee.shr.report.app.ReportDef.list",
										preview : "true",
										filterParam : $.toJSON(allParam),
										tmpPath:_self.getJSessionCookie()
									});
								if ($.block) {
									$.block.show({
										text : '正在生成报表中，请稍候...'
									});
								}
								_self.remoteCall({
									param : param,
									success : function (data) {
										if ($.block) {
											$.block.hide();
										}
										fileName = data.fileName;
										JsessionId = data.sessionId;
										var urlparam = $.param({
											method : 'getReportFile',
											uipk : "com.kingdee.shr.report.app.ReportDef.list",
											fileName : data.fileName,
											tmpPath:JsessionId
										});
										location.href = shr.getContextPath()+"/dynamic.do?"+urlparam;
									},
									complete : function(requet,status){
										if ($.block) {
											$.block.hide();
										}
									}
								});
							},
							'数据预览' : function () {
								//document.getElementById('orgDialogIfame').contentWindow.jsBinder.saveAction();
								if(!_self.checkNullValue(queryData)){
									return;
								}
								var allParam = [];
								for (var i = 0; i < queryData.length; i++) {
									if (queryData[i].inputState != 2) {
										if (queryData[i].inputType != null && (queryData[i].inputType == 4 || queryData[i].inputType == 1)) {
											queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").prev().val()||$("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").number;
											if ("adminOrg" == queryData[i].name) {
												queryData[i].curentValueAlias = $("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").displayName;
											} else {
												queryData[i].curentValueAlias = $("input[id='"+queryData[i].name+"']").val();
											}
										} else if (queryData[i].inputType == 2){
											queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").val().replace(/\//g,"-");
										} else {
											queryData[i].curentValue = $("input[id='"+queryData[i].name+"']").val();
										}
									}
									var alias = {
										alias : queryData[i].properties.alias_zh_CN
									};
									allParam[i] = {
										curentValue : queryData[i].curentValue,
										curentValueAlias : queryData[i].curentValueAlias,
										dataType : queryData[i].dataType,
										defaultValue : queryData[i].defaultValue,
										designDataType : queryData[i].designDataType,
										inputState : queryData[i].inputState,
										inputType : queryData[i].inputType,
										isAllowNull : queryData[i].isAllowNull,
										properties : JSON.stringify(alias),
										name : queryData[i].name
									}
								}
								// 判断是否添加过滤条件
								if (queryData.length == 0) { // 没有设置过滤条件

									shr.showError({
										message : "您还没有为报表添加过滤条件，请先添加过滤条件后再进行此操作！",
										hideAfter : 3
									});
									return;
								}

								// 判断数据有效性
								for (var i = 0; i < queryData.length; i++) {
									if ((queryData[i].curentValue == null || queryData[i].curentValue == "") && queryData[i].isAllowNull == false && queryData[i].name == null) {
										shr.showError({
											message : queryData[i].properties.alias_zh_CN + "不可为空！",
											hideAfter : 3
										});
										return;
									}
								}

								// 判断是否添加了模板
								if ($(".template_list").find(".text-label").size() == 0) {
									// 没有添加模板
									shr.showError({
										message : "您还没有为报表添加模板，请先添加模板后再进行此操作！",
										hideAfter : 3
									});
									return;
								}

								// 判断是否选择模板
								if ($(".template_list .template_pressed").find(".text-label").attr("templateId") == undefined || $(".template_list .template_pressed").find(".text-label").attr("templateId") == null) {
									shr.showError({
										message : "请选择一个模板！",
										hideAfter : 3
									});
									return;
								}
								var param = $.param({
										method : 'getReport',
										boid : $(".template_list .template_pressed").find(".text-label").attr("templateId"),
										billId : defid,
										uipk : "com.kingdee.shr.report.app.ReportDef.list",
										preview : "true",
										filterParam : $.toJSON(allParam),
										tmpPath:_self.getJSessionCookie()
									});
								if ($.block) {
									$.block.show({
										text : '正在生成报表中，请稍候...'
									});
								}
								var fileName = "";
								var JsessionId = "";
								_self.remoteCall({
									param : param,
									success : function (data) {
										//location.href = shr.getContextPath()+"/excel.jsp?filePath=" + data.path;
										if ($.block) {
											$.block.hide();
										}
										fileName = data.fileName;
										JsessionId = data.sessionId;
										var urlparam = $.param({
											method : 'getReportFile',
											uipk : "com.kingdee.shr.report.app.ReportDef.list",
											fileName : data.fileName
										});
										//window.open(shr.getContextPath() + "/addon/report/web/weboffice7/reportView.html?url=" + urlparam);
										//var a = $("<a href='"+shr.getContextPath() + "/addon/report/web/weboffice7/reportView.html?url=" + urlparam+"' target='_blank'>Apple</a>").get(0);  
										//var e = document.createEvent('MouseEvents');  
										//e.initEvent('click', true, true);  
										//a.dispatchEvent(e);
										//window.open(shr.getContextPath() + "/addon/report/web/weboffice7/reportView.html?filePath=" + data.path);
									},
									complete : function(requet,status){
										if ($.block) {
											$.block.hide();
										}
									}
								});
								c = setInterval(function() {  
									if(fileName != ""){
										var urlparam = $.param({
											method : 'getReportFile',
											uipk : "com.kingdee.shr.report.app.ReportDef.list",
											fileName : fileName,
											sessionId:JsessionId
										});
										fileName = "";
										window.open(shr.getContextPath() + "/weboffice7/weboffice.html?title="+encodeURI('预览')+"&isEdit=true&url=" + urlparam);
										window.clearInterval(c);
									}
								}, 1000);
								$(this).dialog('close');
							},
							'取消' : function () {
								$(this).dialog('close');
							}
						}
					});
					$("#ui-id-1").parent().css("border-bottom", "0");
					var buttonpane = $('#dialog_report').parent().find(".ui-dialog-buttonpane");
					if(buttonpane.find(".plugView").length == 0){
						buttonpane.append('<div class="plugView" style="margin-top: 12px;margin-left: 150px;">数据预览不到，请 '+
						'<a onclick="_self.openPlugView()" style="display:inline-block;color:#428bca;font-weight: bold;cursor:pointer;text-decoration:underline;">设置</a> 一下吧。</div>');
					}
				} else {
					$(".report_filter").empty();
					var param = $.param({
							method : 'getReport',
							boid : templateid,
							billId : billId,
							uipk : "com.kingdee.shr.report.app.ReportDef.list",
							filterParam : $.toJSON(queryData),
							tmpPath:_self.getJSessionCookie()
						});
					location.href = shr.getContextPath() + "/dynamic.do?" + param;
				}
			}
		});

	},
	
	openPlugView : function(){
		window.open(shr.getContextPath() + "/weboffice7/plugView.html");
	},
	
	checkNullValue : function (queryData) {
		var currentValue;
		for (var i = 0; i < queryData.length; i++) {
			if (queryData[i].inputState != 2) {
				if (queryData[i].inputType != null && (queryData[i].inputType == 4 || queryData[i].inputType == 1)) {
					currentValue = $("input[id^='"+queryData[i].name+"']").prev().val()||$("input[id='"+queryData[i].name+"']").shrPromptBox("getValue").number;
				} else {
					currentValue = $("input[id^='"+queryData[i].name+"']").val();
				}
				if(!queryData[i].isAllowNull && (currentValue == null || currentValue == undefined || currentValue == "null" || currentValue == "")){
					shr.showError({
						message : '请输入'+queryData[i].properties.alias_zh_CN,
						hideAfter : 3
					});
					return false;
				}
				
				// 日期型控件要保证输入的日期合法
				if((queryData[i].designDataType == 2 || queryData[i].designDataType == "2") && !queryData[i].isAllowNull){
					var date = new Date(currentValue);
					if(!date.getFullYear() || date.getFullYear() > 9999){
						shr.showError({
							message : queryData[i].properties.alias_zh_CN + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
					if(date.getMonth() >11 || date.getMonth() < 0){
						shr.showError({
							message : queryData[i].properties.alias_zh_CN + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
					if(date.getDate() > 31 || date.getDate() < 1){
						shr.showError({
							message : queryData[i].properties.alias_zh_CN + ' 不合法',
							hideAfter : 3
						});
						return false;
					}
				}				
			}
		}
		return true;
	},

	CheckSelectedIds : function () {
		var selectedIds = $("#tempTab").jqGrid("getSelectedRows")
			if (selectedIds.length > 0) {
				return true;
			} else {
				return false;
			}
	},

	CheckTabSelectedIds : function () {
		var selectedIds = $("#tempTab").jqGrid("getSelectedRows");
		if (selectedIds.length > 0) {
			return true;
		} else {
			return false;
		}
	},

	addFilterComponent : function (data) {
		var router = 0;
		var xml;
		/////////////////////////////////////////////////////////////////

		$(".report_filter").empty();
		/*
		$(".report_filter").append('<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
		+'<div class="field_label" title="'+"模板"+'">'+"模板"+'</div></div><div class="span3 field-ctrl">'
		+'<input class="block-father input-height" id="selectTemplate" name="selectTemplate" validate="" placeholder="" type="text"  dataExtenal="" />'
		+'</div><div class="span1 field-desc"></div></div></div>');
		 */

		if (data.length == 0) {
			$(".report_filter").append('<div id="no"><span id="ui-id-1" class="ui-dialog-title" style="color:#FA0610;margin-left: 40px;">无过滤条件</span></div>');
		}

		for (var i = 0; i < data.length; i++) {
			if (data[i].inputState != 2) {
				router++;
				var isneed = 'false';
				if (!data[i].isAllowNull) {
					isneed = 'true';
				}
				if (data[i].designDataType == 0 && data[i].inputType == 4) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" class="block-father input-height" type="text" validate="{required:' + isneed + '}" />'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 0) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:255,required:' + isneed + '}" value="" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 1) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" class="block-father input-height" type="text" name="' + data[i].name + '" validate="{maxlength:9,digits:true,required:' + isneed + '}" value="0" placeholder=""  dataExtenal=""/>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 2) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input id="' + data[i].name + '" name="' + data[i].name + '" value="" validate="{dateISO:true,required:' + isneed + '}" placeholder="" type="text"  dataExtenal="">'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				} else if (data[i].designDataType == 3) {
					if (router % 2 == 1) {
						xml = '<div class="row-fluid row-block " id=""><div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input type="checkbox" id="' + data[i].name + '" name="' + data[i].name + '" value="1"    dataExtenal=""> <span></span>'
							 + '</div><div class="span1 field-desc"></div></div>';
					} else {
						$(".report_filter").append(xml + '<div data-ctrlrole="labelContainer" ><div class="span2">'
							 + '<div class="field_label" title="' + data[i].properties.alias_zh_CN + '">' + data[i].properties.alias_zh_CN + '</div></div><div class="span3 field-ctrl">'
							 + '<input type="checkbox" id="' + data[i].name + '" name="' + data[i].name + '" value="1"    dataExtenal=""> <span></span>'
							 + '</div><div class="span1 field-desc"></div></div></div>');
					}
				}
			}
		}

		if (router % 2 == 1 && xml != null) {
			$(".report_filter").append(xml + '</div>');
		}
		///////////////////////////////////////////////
	},
	getdate : function (date) {
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		switch(date){
			case "today" : 
				return now.format("yyyy-MM-dd");
				break;
			case "current_month_star" : 
				return this.getMonthStartDate();
				break;
			case "current_month_end" :
				return this.getMonthEndDate();
				break;
			case "current_quarter_star" :
				return this.getQuarterStartDate();
				break;
			case "current_quarter_end" :
				return this.getQuarterEndDate();
				break;
			case "current_annual_star" :
				return this.getAnnualStartDate();
				break;
			case "current_annual_end" :
				return this.getAnnualEndDate();
				break;
			case "last_month_star" :
				return this.getLastMonthStartDate();
				break;
			case "last_month_end" : 
				return this.getLastMonthEndDate();
				break;
			case "last_quarter_star" :
				var t_date = new Date(this.getQuarterStartDate()); 
				return this.getPriorSeasonFirstDay(nowYear,t_date.getMonth());
				break;
			case "last_quarter_end" :
				var t_date = new Date(this.getQuarterStartDate()); 
				return this.getPriorSeasonEndDay(nowYear,t_date.getMonth());
				break;
			case "last_annual_star" :
				return this.getLastAnnualStartDate();
				break;
			case "last_annual_end" :
				return this.getLastAnnualEndDate();
				break;
			default:
				return date;
				break;
		}
	},	
	
	
	formatDate :function (date) {  
		var myyear = date.getFullYear();  
		var mymonth = date.getMonth()+1;  
		var myweekday = date.getDate();  
		  
		if(mymonth < 10){  
		mymonth = "0" + mymonth;  
		}  
		if(myweekday < 10){  
		myweekday = "0" + myweekday;  
		}  
		return (myyear+"-"+mymonth + "-" + myweekday);  
	},  
  
	//获得某月的天数  
	getMonthDays :function (myMonth){
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getYear();  
		var lastMonth = lastMonthDate.getMonth(); 
		
		var monthStartDate = new Date(nowYear, myMonth, 1);  
		var monthEndDate = new Date(nowYear, myMonth + 1, 1);  
		var days = (monthEndDate - monthStartDate)/(1000 * 60 * 60 * 24);  
		return days;  
	},  
  
	//获得本季度的开端月份  
	getQuarterStartMonth :function (){
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getYear();  
		var lastMonth = lastMonthDate.getMonth();  	
		var quarterStartMonth = 0;  
		if(nowMonth<3){  
		quarterStartMonth = 0;  
		}  
		if(2<nowMonth && nowMonth<6){  
		quarterStartMonth = 3;  
		}  
		if(5<nowMonth && nowMonth<9){  
		quarterStartMonth = 6;  
		}  
		if(nowMonth>8){  
		quarterStartMonth = 9;  
		}  
		return quarterStartMonth;  
	},  
	  
	
	//获得本月的开端日期  
	getMonthStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var monthStartDate = new Date(nowYear, nowMonth, 1);  
		return monthStartDate.format("yyyy-MM-dd")	
	},  
	 
	//获得上月的开端日期  
	getLastMonthStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		var monthStartDate = new Date(nowYear, nowMonth-1, 1);  
		return monthStartDate.format("yyyy-MM-dd")	
	},  
	 
	//获得本月的停止日期  
	getMonthEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		
		var monthEndDate = new Date(nowYear, nowMonth, this.getMonthDays(nowMonth));  
		return monthEndDate.format("yyyy-MM-dd");	
	}, 
	
	//获得上月的停止日期  
	getLastMonthEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowDayOfWeek = now.getDay(); //今天本周的第几天  
		var nowDay = now.getDate(); //当前日  
		var nowMonth = now.getMonth(); //当前月  
		var nowYear = now.getFullYear(); //当前年  
		var monthEndDate = new Date(nowYear, nowMonth-1, this.getMonthDays(nowMonth));  
		return monthEndDate.format("yyyy-MM-dd");	
	},  	
	  
	//获得上月开端时候  
	getLastMonthStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getYear();  
		var lastMonth = lastMonthDate.getMonth();  	
		var lastMonthStartDate = new Date(nowYear, lastMonth, 1);  
		return lastMonthStartDate.format("yyyy-MM-dd");	
	},  
	  
	//获得上月停止时候  
	getLastMonthEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var lastMonthDate = new Date(); //上月日期  
		lastMonthDate.setDate(1);  
		lastMonthDate.setMonth(lastMonthDate.getMonth()-1);  
		var lastYear = lastMonthDate.getYear();  
		var lastMonth = lastMonthDate.getMonth();  	
		var lastMonthEndDate = new Date(nowYear, lastMonth, this.getMonthDays(lastMonth));  
		return lastMonthEndDate.format("yyyy-MM-dd");	
		
	}, 
	  
	//获得本季度的开端日期  
	getQuarterStartDate :function (){  
		var now = new Date(); //当前日期   
		var nowYear = now.getFullYear(); //当前年  
		var quarterStartDate = new Date(nowYear, this.getQuarterStartMonth(), 1);  
		return quarterStartDate.format("yyyy-MM-dd");	
		
	}, 
	
	
	//获得上季度季度的开端日期  
	getLastQuarterStartDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var quarterStartDate = new Date(nowYear, this.getQuarterStartMonth(), 1);  
		return quarterStartDate.format("yyyy-MM-dd");	
	}, 
	
	  
	//获的本季度的停止日期  
	getQuarterEndDate :function (){  
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var quarterEndMonth = this.getQuarterStartMonth() + 2;  
		var quarterStartDate = new Date(nowYear, quarterEndMonth, this.getMonthDays(quarterEndMonth));  
		return quarterStartDate.format("yyyy-MM-dd");	
	}, 

	//获取本年度初
	getAnnualStartDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear, 0, 1);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	//获取本年度初
	getLastAnnualStartDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear-1, 0, 1);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	//获取本年度末
	getAnnualEndDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear, 11, 31);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	
	//获取上年度末
	getLastAnnualEndDate : function(){
		var now = new Date(); //当前日期  
		var nowYear = now.getFullYear(); //当前年  
		var AnnualStartDate = new Date(nowYear-1, 11, 31);  
		return AnnualStartDate.format("yyyy-MM-dd");
	},
	
	 /**
     * 得到上季度的起始日期
     * year 这个年应该是运算后得到的当前本季度的年份
     * month 这个应该是运算后得到的当前季度的开始月份
     * */ 
   getPriorSeasonFirstDay : function(year,month){ 
        var quarterMonthStart=0; 
        var spring=0; //春  
        var summer=3; //夏  
        var fall=6;   //秋  
        var winter=9;//冬  
        //月份从0-11  
        switch(month){//季度的其实月份  
        case spring: 
            //如果是第一季度则应该到去年的冬季  
              year--; 
              month=winter; 
            break; 
        case summer: 
            month=spring; 
            break; 
        case fall: 
            month=summer; 
            break; 
        case winter: 
            month=fall; 
            break; 
             
        };  
        return (new Date(year,month,1)).format("yyyy-MM-dd"); 
    },
	
	 /**
     * 得到上季度的结束日期
     * year 这个年应该是运算后得到的当前本季度的年份
     * month 这个应该是运算后得到的当前季度的开始月份
     * */ 
   getPriorSeasonEndDay : function(year,month){ 
        var quarterMonthStart=0; 
        var spring=0; //春  
        var summer=3; //夏  
        var fall=6;   //秋  
        var winter=9;//冬  
        //月份从0-11  
        switch(month){//季度的其实月份  
        case spring: 
            //如果是第一季度则应该到去年的冬季  
              year--; 
              month=winter; 
            break; 
        case summer: 
            month=spring; 
            break; 
        case fall: 
            month=summer; 
            break; 
        case winter: 
            month=fall; 
            break; 
             
        };  
        return (new Date(year,month+2,this.getMonthDays(month))).format("yyyy-MM-dd"); 
    },
   getJSessionCookie : function () {
   	var array = document.cookie.split(";");
		for (var i = 0; i < array.length; i++) {
			if (array[i].indexOf("JSESSIONID") >= 0) {
				return array[i].trim().substring('JSESSIONID'.length + 1);
			}
		}
	 return "";
   },
  
	// 检查报表完整性
	checkReportIntegrity : function(reportId){
		var checkresult ;
		$.ajax({
			url : shr.getContextPath() + "/dynamic.do?method=checkReportIntegrity",
			async : false,
			data : {
				uipk : "com.kingdee.shr.report.app.ReportDef.list",
				reportId : reportId
			},
			success : function (data) {
				checkresult = data;	
			},
			error : function(data){
				checkresult =  data;
			}
		});
		return checkresult;
	},
});
